// bkview.cpp : implementation of the CBkView class
//
#include "stdafx.h"
#include "bk.h"
#include "bkdoc.h"
#include "bkview.h"
#include "eurecard.h"
#include "desc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBkView
IMPLEMENT_DYNCREATE(CBkView, CView)

BEGIN_MESSAGE_MAP(CBkView, CView)
	//{{AFX_MSG_MAP(CBkView)
	ON_WM_TIMER()
	ON_UPDATE_COMMAND_UI(ID_ACQ_FIG, OnUpdateAcqFig)
	ON_COMMAND(ID_ACQ_FIG, OnAcqFig)
	ON_UPDATE_COMMAND_UI(ID_ACQ_PERM, OnUpdateAcqPerm)
	ON_COMMAND(ID_ACQ_PERM, OnAcqPerm)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()
//////////////////////////////////////////
// CBkView construction/destruction
CBkView::CBkView()
{
	m_pApp=((CBkApp*)AfxGetApp());
}
CBkView::~CBkView()
{
	//KillTimer(1);
}
//////////////////////////////////////////
void CBkView::MAJ_Fen()
{
	CBkDoc* pDoc=GetDocument();
	CRect r;
	GetParent()->GetWindowRect(r);
	InvalidateRect(r,FALSE);
	pDoc->UpdateAllViews(this,(LPARAM)(LPCRECT)r);
}
//________________________________________
// CBkView drawing
void CBkView::OnDraw(CDC* pDC)
{
	CRect rcClient;
	HDC hDC;
	HPALETTE hpal;
	CBkDoc* pDoc=GetDocument();
	pDC->DPtoLP(rcClient);            
	CClientDC dc(this);
	hDC=dc.m_hDC;
	viewimage(m_hWnd,hDC,&hpal,0,0,pDoc->image);
}
//////////////////////////////////////////
// CBkView printing

BOOL CBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}
//////////////////////////////////////////
// CBkView diagnostics

#ifdef _DEBUG
void CBkView::AssertValid() const
{
	CView::AssertValid();
}

void CBkView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBkDoc* CBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBkDoc)));
	return (CBkDoc*) m_pDocument;
}

#endif //_DEBUG
//////////////////////////////////////////
// CBkView message handlers 
void CBkView::OnInitialUpdate()
{
	CView::OnInitialUpdate();
	CBkDoc* pDoc=GetDocument();
	//Mmoriser le pointeur sur la fentre et la vue dans le document
	pDoc->m_pWnd=GetParent();
	pDoc->m_pView=this;
	pDoc->DimensionnerFenetre(512,512);
	//______________________________________
	FILE *f_dir;
	enreg e;
	//Ecrasement d'un fichier existant, et spcification acq. permanente
	f_dir=fopen("c:\\BK.$$$","wb");
	e.i=m_ider=1;//Acq.permanente
	pDoc->m_iNb=0;
	e_enreg(f_dir,0,&e);
	fclose(f_dir);

	//DETECTION CARTE PRIMO ES3_____________
	if (gsp_primoboot("PRIMOGSP"))
	{
		//Carte non trouve
		m_OKCarte=FALSE;
		//AfxMessageBox("Carte d'imagerie Primo non dtecte !");
	}
	else
	{
		//Carte trouve
		m_OKCarte=TRUE;
		InitCarte();
	}
	//______________________________________
	if (!m_OKCarte) 
		pDoc->SetTitle("Carte non trouve !");
	else		
		pDoc->SetTitle("Carte PRIMO dtecte !");
	for (short i=0;i<10000;i++)
	for (short j=0;j<10000;j++)
	{
		//Temporisation
	}	
	m_iCarte=1;AcqPerm();	
	m_bBusy=FALSE;SetTimer(1,100,NULL);
}
//________________________________________
void CBkView::OnTimer(UINT nIDEvent)
{
	CBkDoc* pDoc=GetDocument();
	FILE *f_dir;
	enreg e;
	if (m_bBusy==FALSE)
	{
		m_bBusy=TRUE;
		switch (nIDEvent)
		{
			case 1://Lecture priodique du fichier "c:\\BK.$$$"
				pDoc->m_iNb++;
				f_dir=fopen("c:\\BK.$$$","ab+");
				if (f_dir!=NULL)
				{
					l_enreg(f_dir,0,&e);
					if (e.i!=m_ider)
					{
						switch (e.i)
						{
							case 1://e.i=1: Demande d'acq. permanente...
								//Acquisition permanente, si on ne l'est pas dj
								if (m_iCarte!=1)
								{
									AcqPerm();
									m_ider=m_iCarte=1;
									//On rinitialise le compteur...
									pDoc->m_iNb=0;
									pDoc->SetTitle("Acq. permanente...");
								}
							break;
							case 2://e.i=2: Demande d'acq. fige...
								//Acquisition fige, si on ne l'est pas dj
								if (m_iCarte!=2)
								{	
									FigerAcq();
									MAJ_Fen();
									m_ider=m_iCarte=2;
									//On rinitialise le compteur...
									pDoc->m_iNb=0;
									pDoc->SetTitle("Acq. fige...");
								}
							break;
						}
					}
					fclose(f_dir);
				}//if (f_dir!=NULL)
			break;
		}//switch
		m_bBusy=FALSE;
	}
	CView::OnTimer(nIDEvent);
}
//________________________________________
void CBkView::l_enreg(FILE *f_dir,unsigned short i,struct enreg *e)
{
	if (fseek(f_dir,i*sizeof(*e),SEEK_SET)==0)
	{
		if (fread(e,sizeof(*e),1,f_dir)==0) e->i=0;
	}
	else
		e->i=0;	
}
//________________________________________
void CBkView::e_enreg(FILE *f_dir,unsigned short i,struct enreg *e)
{
	fseek(f_dir,i*sizeof(*e),SEEK_SET);
	fwrite(e,sizeof(*e),1,f_dir);
}
//________________________________________
void CBkView::OnUpdateAcqFig(CCmdUI* pCmdUI)
{
  if (m_iCarte!=2) pCmdUI->Enable(TRUE); else pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnAcqFig()
{
	CBkDoc* pDoc=GetDocument();
	if (m_iCarte!=2)
	{
		//On passe de l'acqusition permanente  l'acquisition fige 
		//1: acq. perm., 2: acq. fige, 3: priodique
		FigerAcq();
		m_iCarte=2;
		pDoc->m_iNb=0;
		MAJ_Fen();
		pDoc->SetTitle("Acq. fige...");
	}
}
//________________________________________
void CBkView::OnUpdateAcqPerm(CCmdUI* pCmdUI)
{
	if (m_iCarte!=1) pCmdUI->Enable(TRUE); else pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnAcqPerm()
{
	CBkDoc* pDoc=GetDocument();
	if (m_OKCarte)
	{
		//On passe de l'acquisition fige  l'acquisition permanente
		AcqPerm();
		pDoc->m_iNb=0;
		m_iCarte=1;		
		pDoc->SetTitle("Acq. permanente...");
	}	
}
//________________________________________
void CBkView::FigerAcq()
{
	if (m_OKCarte)
	{
		map_12(OP_COPY,GRAB,VISU);     
		map_12(OP_COPY,GRAB,IMAGE_0);
		//Ecriture dur disque du fichier "bk.tif"   
		gsp_save_blk(IMAGE_0,"c:\\bk.tif",0);
		loadtif("c:\\bk.tif",GetDocument()->image);
	}
}
//________________________________________
void CBkView::AcqPerm()
{
	if (m_OKCarte)
	{
		gsp_set_sync_mode(0);             // Synchronise on channel zero
		gsp_set(APL_VIN,VIN_CHANNEL,0L);  // Video from channel zero
		map_12(OP_COPY,GRAB,VISU);
	}
}
//________________________________________
void CBkView::InitCarte()
{
	if (m_OKCarte)
	{
		gsp_clear_video_mem();
    gsp_set(APL_VOUT,VOUT_LUT,RAMP_VECT);
		gsp_set(APL_DIO,DIO_Q1,1L);
		gsp_set(APL_DIO,DIO_Q2,1L);   
	}
}