// 3dDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "3dDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// C3dDlg dialog
C3dDlg::C3dDlg(CWnd* pParent /*=NULL*/)
	: CDialog(C3dDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(C3dDlg)
	m_radioPas = -1;
	//}}AFX_DATA_INIT
}
void C3dDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(C3dDlg)
	DDX_Control(pDX, IDC_YPLUS, m_btnYplus);
	DDX_Control(pDX, IDC_YMOINS, m_btnYmoins);
	DDX_Control(pDX, IDC_XPLUS, m_btnXplus);
	DDX_Control(pDX, IDC_XMOINS, m_btnXmoins);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDVISU, m_btnVisu);
	DDX_Radio(pDX, IDC_PAS1, m_radioPas);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(C3dDlg, CDialog)
	//{{AFX_MSG_MAP(C3dDlg)
	ON_BN_CLICKED(IDVISU, OnVisu)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_XMOINS, OnXmoins)
	ON_BN_CLICKED(IDC_XPLUS, OnXplus)
	ON_BN_CLICKED(IDC_YMOINS, OnYmoins)
	ON_BN_CLICKED(IDC_YPLUS, OnYplus)
	ON_BN_CLICKED(IDC_ZMOINS, OnZmoins)
	ON_BN_CLICKED(IDC_ZPLUS, OnZplus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// C3dDlg message handlers
BOOL C3dDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	class CBkDoc *p;
	short
		l,h,nbB,i;	
	m_pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument();
	m_OK=FALSE;
	m_OKCarte=m_pApp->m_OKCarte;
	m_pApp->m_OKCarte=FALSE;
	m_radioPas=0;
	//Ouverture d'une nouvelle fentre...
	//Recherche N nouvelle image destination
	m_iNo=-1;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)==NULL)
		{
			m_iNo=i;
			//On sort
			i=m_pApp->m_iNbMax;    
		}
	}
	if (m_iNo!=-1)
	{
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		p=m_pApp->m_pDocument[m_iNo];

		l=m_pDoc->image->endx-m_pDoc->image->stx+1;
		h=m_pDoc->image->endy-m_pDoc->image->sty+1;
		nbB=m_pDoc->image->bmh->biBitCount;
		p->InitialiserImage(l,h,nbB);
		p->DimensionnerFenetre(l,h);
		p->DefinirCurseurs(l,h);
		p->PositionnerFenetre(0,0);
		p->m_sNomFic="Visualisation 3D";
		p->m_iType=1;
		copyimage(m_pDoc->image,p->image);

		if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
		if (m_pView!=NULL) 
		{
			m_pView->m_iPas=1;
			m_pView->MAJ_Fen();
		}
	}
	else
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnYplus.EnableWindow(FALSE);
		m_btnYmoins.EnableWindow(FALSE);
		m_btnVisu.EnableWindow(FALSE);
		AfxMessageBox("Fermer une fentre inutile.\nPuis rouvrir la bote de dialogue...");
	}
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void C3dDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void C3dDlg::OnCancel() 
{
	m_pApp->m_OKCarte=m_OKCarte;
	//On ferme la fentre de visualisation 3D...
	if (m_iNo!=-1)
	{
		SendMessage(WM_COMMAND,ID_FILE_CLOSE,0);
	}	CDialog::OnCancel();
}
//________________________________________
void C3dDlg::OnVisu() 
{
	if (!m_OK)
	{
		m_btnVisu.SetWindowText("Arrter");
		m_btnCancel.EnableWindow(FALSE);
		UpdateData(TRUE);
		if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
		GetDlgItem(IDC_PAS1)->EnableWindow(FALSE);
		GetDlgItem(IDC_PAS2)->EnableWindow(FALSE);
		SetTimer(1,150,NULL);
	}
	else
	{
		KillTimer(1);
		GetDlgItem(IDC_PAS1)->EnableWindow(TRUE);
		GetDlgItem(IDC_PAS2)->EnableWindow(TRUE);
		m_btnVisu.SetWindowText("Visualiser auto.");
		m_btnCancel.EnableWindow(TRUE);
	}
	m_OK=!m_OK;	
}
//________________________________________
void C3dDlg::OnTimer(UINT nIDEvent) 
{
  m_pApp->m_fAngleX -= 2.0f;
  m_pApp->m_fAngleY -= 20.0f;
  m_pApp->m_fAngleZ -= 10.0f;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();

	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void C3dDlg::OnXmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleY=m_pApp->m_fAngleY-20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnXplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleY=m_pApp->m_fAngleY+20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnYmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleX=m_pApp->m_fAngleX-20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnYplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleX=m_pApp->m_fAngleX+20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnZmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleZ=m_pApp->m_fAngleZ-20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnZplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleZ=m_pApp->m_fAngleZ+20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
