// AcqPhDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "AcqPhDlg.h"
#include "BkDoc.h"
#include "Vicdefs.h"
#include "C832.h"
#include "Piezo.h"
#include "BkView.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CAcqPhDlg dialog
CAcqPhDlg::CAcqPhDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcqPhDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcqPhDlg)
	m_radioTypDeph = -1;
	m_sTexte = _T("");
	m_OKFiltre = FALSE;
	m_sU0 = _T("");
	m_sU1 = _T("");
	m_sU2 = _T("");
	m_sU3 = _T("");
	m_sU4 = _T("");
	m_sX1 = _T("");
	m_sX2 = _T("");
	m_sX3 = _T("");
	m_sX4 = _T("");
	m_iTempo = 0;
	//}}AFX_DATA_INIT
}
void CAcqPhDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcqPhDlg)
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Control(pDX, IDC_SOURCE4, m_comboSource4);
	DDX_Control(pDX, IDC_SOURCE3, m_comboSource3);
	DDX_Control(pDX, IDC_SOURCE2, m_comboSource2);
	DDX_Control(pDX, IDC_SOURCE1, m_comboSource1);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Radio(pDX, IDC_RADIO_TYPE, m_radioTypDeph);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Check(pDX, IDC_FILTRE, m_OKFiltre);
	DDX_Text(pDX, IDC_U0, m_sU0);
	DDX_Text(pDX, IDC_U1, m_sU1);
	DDX_Text(pDX, IDC_U2, m_sU2);
	DDX_Text(pDX, IDC_U3, m_sU3);
	DDX_Text(pDX, IDC_U4, m_sU4);
	DDX_Text(pDX, IDC_X1, m_sX1);
	DDX_Text(pDX, IDC_X2, m_sX2);
	DDX_Text(pDX, IDC_X3, m_sX3);
	DDX_Text(pDX, IDC_X4, m_sX4);
	DDX_Text(pDX, IDC_TEMPO, m_iTempo);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAcqPhDlg, CDialog)
	//{{AFX_MSG_MAP(CAcqPhDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CAcqPhDlg message handlers
BOOL CAcqPhDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short n,i,j;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	//Valeurs par dfaut dphasage en provenance Bk.cpp
	m_radioTypDeph=m_pApp->m_radioTypDeph;
	m_OKFiltre=TRUE;
	//Piezo
	m_iU0=0;	
	m_iU1=m_pApp->m_iPhU[0];	
	m_iU2=m_pApp->m_iPhU[1];	
	m_iU3=m_pApp->m_iPhU[2];	
	m_iU4=m_pApp->m_iPhU[3];
	m_sU0.Format("%d",m_iU0);
	m_sU1.Format("%d",m_iU1);
	m_sU2.Format("%d",m_iU2);
	m_sU3.Format("%d",m_iU3);
	m_sU4.Format("%d",m_iU4);
	m_iTempo=m_pApp->m_iTempo;
	//Platine motorise
	m_fX1=m_pApp->m_fPhX[0];	
	m_fX2=m_pApp->m_fPhX[1];	
	m_fX3=m_pApp->m_fPhX[2];	
	m_fX4=m_pApp->m_fPhX[3];	
	m_sX1.Format("%1.3f",m_fX1);
	m_sX2.Format("%1.3f",m_fX2);
	m_sX3.Format("%1.3f",m_fX3);
	m_sX4.Format("%1.3f",m_fX4);

  if (!(GetVersion() & 0x80000000))
    //Windows NT is loaded
		m_OK_NT=TRUE;
	else
		m_OK_NT=FALSE;

	//Dphaseurs
	m_pPiezo=new CPiezo(m_pApp->m_radioPortSeriePiezo);
	if (!m_OK_NT)
	{
		//On n'est pas sous NT
		m_pC832=new CC832(120000);
		if (m_pC832->OK(1))
		{
			
			m_pC832->RT(1);
			m_pC832->IT(1);
			m_pC832->SV(1,20);
		}
		else
			;//AfxMessageBox("Carte P.I. C832 non trouve !");
	}
	//Initialisation tableau N images
	m_iI=new short[m_pApp->m_iNbMax];
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		m_iI[i]=-1;
	}                 
	j=0;
	//Recherche des images dj ouvertes
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)!=NULL)
		{
			s.Format("Image %d",i);	
			m_comboDest.AddString(s);
			m_comboSource1.AddString(s);
			m_comboSource2.AddString(s);
			m_comboSource3.AddString(s);
			m_comboSource4.AddString(s);
			m_iI[j]=i;
			j++;
		}         
	}
	//Recherche N nouvelles images
	n=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)==NULL)
		{
			s.Format("IMAGE %d",i);	
			m_comboDest.AddString(s);
			m_comboSource1.AddString(s);
			m_comboSource2.AddString(s);
			m_comboSource3.AddString(s);
			m_comboSource4.AddString(s);
			m_iI[j]=i;
			j++;
			n++;
			//On sort car on a trouv 4 nouvelles images disponibles
			if (n>4) i=m_pApp->m_iNbMax;    
		}
	}
	//Attribution des images par dfaut
	i=m_comboSource1.GetCount()-5;if (i<0) i=0;
	m_comboSource1.GetLBText(i,s);
	m_comboSource1.SetWindowText(s);	
	i=m_comboSource2.GetCount()-4;if (i<0) i=0;
	m_comboSource2.GetLBText(i,s);
	m_comboSource2.SetWindowText(s);	
	i=m_comboSource3.GetCount()-3;if (i<0) i=0;
	m_comboSource3.GetLBText(i,s);
	m_comboSource3.SetWindowText(s);	
	i=m_comboSource4.GetCount()-2;if (i<0) i=0;
	m_comboSource4.GetLBText(i,s);
	m_comboSource4.SetWindowText(s);
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	UpdateData(FALSE);
	//Contrle du bouton OK par timer
	m_OK=FALSE;
	m_btnOK.EnableWindow(FALSE);
	SetTimer(1,200,NULL);
	return TRUE;
}
//________________________________________
void CAcqPhDlg::OnTimer(UINT nIDEvent) 
{
	short is1,is2,is3,is4,id;
	BOOL ok=FALSE;

	UpdateData(TRUE);
	if (m_OK_NT)
	{
		//Carte non fonctionne pas sous NT...
		GetDlgItem(IDC_RADIO_TYPE2)->EnableWindow(FALSE);
	}
	else
	if (!m_pC832->OK(1))
	{
		GetDlgItem(IDC_RADIO_TYPE2)->EnableWindow(FALSE);
	}
	if (m_radioTypDeph==0)
	{
		//Piezo
		GetDlgItem(IDC_U1)->EnableWindow(TRUE);
		GetDlgItem(IDC_U2)->EnableWindow(TRUE);
		GetDlgItem(IDC_U3)->EnableWindow(TRUE);
		GetDlgItem(IDC_U4)->EnableWindow(TRUE);
		GetDlgItem(IDC_X1)->EnableWindow(FALSE);
		GetDlgItem(IDC_X2)->EnableWindow(FALSE);
		GetDlgItem(IDC_X3)->EnableWindow(FALSE);
		GetDlgItem(IDC_X4)->EnableWindow(FALSE);
	}
	else
	{
		//MM2000
		GetDlgItem(IDC_U1)->EnableWindow(FALSE);
		GetDlgItem(IDC_U2)->EnableWindow(FALSE);
		GetDlgItem(IDC_U3)->EnableWindow(FALSE);
		GetDlgItem(IDC_U4)->EnableWindow(FALSE);
		GetDlgItem(IDC_X1)->EnableWindow(TRUE);
		GetDlgItem(IDC_X2)->EnableWindow(TRUE);
		GetDlgItem(IDC_X3)->EnableWindow(TRUE);
		GetDlgItem(IDC_X4)->EnableWindow(TRUE);
	}
	//Validation du bouton OK si 5 images diffrentes slectionnes
	//Si l'utilisateur n'a pas touch aux combos...
	if (m_comboSource1.GetCurSel()<0)
		is1=m_iI[m_comboSource1.GetCount()-5];
	else
		is1=m_iI[m_comboSource1.GetCurSel()];
	if (m_comboSource2.GetCurSel()<0)
		is2=m_iI[m_comboSource2.GetCount()-4];
	else
		is2=m_iI[m_comboSource2.GetCurSel()];
	if (m_comboSource3.GetCurSel()<0)
		is3=m_iI[m_comboSource3.GetCount()-3];
	else
		is3=m_iI[m_comboSource3.GetCurSel()];
	if (m_comboSource4.GetCurSel()<0) 
		is4=m_iI[m_comboSource4.GetCount()-2];
	else
		is4=m_iI[m_comboSource4.GetCurSel()];

	if (m_comboDest.GetCurSel()<0) 
		id=m_iI[m_comboDest.GetCount()-1];
	else
		id=m_iI[m_comboDest.GetCurSel()];
	
	if (is1!=is2 && is1!=is3 && is1!=is4 && is1!=id) 
	{
		if (is2!=is1 && is2!=is3 && is2!=is4 && is2!=id) 
		{
			if (is3!=is1 && is3!=is2 && is3!=is4 && is3!=id) 
			{
					if (is4!=is1 && is4!=is2 && is4!=is3 && is4!=id) 
					{
						if (id!=is1 && id!=is2 && id!=is3 && id!=is4) 
						{
							ok=TRUE;
						}	
					}
			}
		}
	}
	if (ok!=m_OK)
	{
		m_OK=!m_OK;
		m_btnOK.EnableWindow(m_OK);
	}
	//m_sTexte.Format ("%d = (%d-%d)/(%d-%d)",id,is4,is2,is1,is3);
	if (!ok) m_sTexte="Les 5 images ne sont pas diffrentes!"; else m_sTexte=""; 
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CAcqPhDlg::OnOK() 
{
	float r;
	short 
		l=m_pApp->m_iL,
		h=m_pApp->m_iH,
		i,j,is1,is2,is3,is4,id;
	long w,w1,w2,w3,w4;
	CBkDoc *ps1,*ps2,*ps3,*ps4,*pd;
	KillTimer(1);
	UpdateData(TRUE);
	m_pApp->m_radioTypDeph=m_radioTypDeph;
	//Conversion CString -> int
	i=sscanf(m_sU1,"%d",&m_iU1);
	if (i==0) m_iU1=0;
	i=sscanf(m_sU2,"%d",&m_iU2);
	if (i==0) m_iU2=0;
	i=sscanf(m_sU3,"%d",&m_iU3);
	if (i==0) m_iU3=0;
	i=sscanf(m_sU4,"%d",&m_iU4);
	if (i==0) m_iU4=0;
	//Conversion CString -> float
	i=sscanf(m_sX1,"%f",&m_fX1);
	if (i==0) m_fX1=0;
	i=sscanf(m_sX2,"%f",&m_fX2);
	if (i==0) m_fX1=0;
	i=sscanf(m_sX3,"%f",&m_fX3);
	if (i==0) m_fX3=0;
	i=sscanf(m_sX4,"%f",&m_fX4);
	if (i==0) m_fX4=0;
	
	//Test de validit des entres
	if (m_iU1<0) m_iU1=0;
	if (m_iU1>495) m_iU1=495;
	m_pApp->m_iPhU[0]=m_iU1;	

	if (m_iU2<1) m_iU2=1;
	if (m_iU2>496) m_iU2=496;
	if (m_iU2<m_iU1) m_iU2=m_iU1+1;
	m_pApp->m_iPhU[1]=m_iU2;	

	if (m_iU3<2) m_iU3=2;
	if (m_iU3>497) m_iU3=497;
	if (m_iU3<m_iU2) m_iU3=m_iU2+1;
	m_pApp->m_iPhU[2]=m_iU3;	

	if (m_iU4<3) m_iU4=3;
	if (m_iU4>498) m_iU4=498;
	if (m_iU4<m_iU3) m_iU4=m_iU3+1;
	m_pApp->m_iPhU[3]=m_iU4;	

	if (m_fX1<0) m_fX1=0;
	if (m_fX1>100) m_fX1=100;
	m_pApp->m_fPhX[0]=m_fX1;	

	if (m_fX2<0) m_fX2=0;
	if (m_fX2>100) m_fX2=100;
	m_pApp->m_fPhX[1]=m_fX2;	

	if (m_fX3<0) m_fX3=0;
	if (m_fX3>100) m_fX3=100;
	m_pApp->m_fPhX[2]=m_fX3;	

	if (m_fX4<0) m_fX4=0;
	if (m_fX4>100) m_fX4=100;
	m_pApp->m_fPhX[3]=m_fX4;	

	m_sU1.Format("%d",m_iU1);
	m_sU2.Format("%d",m_iU2);
	m_sU3.Format("%d",m_iU3);
	m_sU4.Format("%d",m_iU4);
	m_sX1.Format("%1.3f",m_fX1);
	m_sX2.Format("%1.3f",m_fX2);
	m_sX3.Format("%1.3f",m_fX3);
	m_sX4.Format("%1.3f",m_fX4);

	if(m_iTempo<0) m_iTempo=0;
	if(m_iTempo>10000) m_iTempo=10000;
	m_pApp->m_iTempo=m_iTempo;
	UpdateData(FALSE);
		
	//Images sources
	is1=m_iI[m_comboSource1.GetCurSel()];
	is2=m_iI[m_comboSource2.GetCurSel()];
	is3=m_iI[m_comboSource3.GetCurSel()];
	is4=m_iI[m_comboSource4.GetCurSel()];
	//Image destination
	id=m_iI[m_comboDest.GetCurSel()];
	//Si l'utilisateur n'a pas touch aux combos...
	if (m_comboSource1.GetCurSel()<0)
		is1=m_iI[m_comboSource1.GetCount()-5];
	else
		is1=m_iI[m_comboSource1.GetCurSel()];
	if (m_comboSource2.GetCurSel()<0)
		is2=m_iI[m_comboSource2.GetCount()-4];
	else
		is2=m_iI[m_comboSource2.GetCurSel()];
	if (m_comboSource3.GetCurSel()<0)
		is3=m_iI[m_comboSource3.GetCount()-3];
	else
		is3=m_iI[m_comboSource3.GetCurSel()];
	if (m_comboSource4.GetCurSel()<0) 
		is4=m_iI[m_comboSource4.GetCount()-2];
	else
		is4=m_iI[m_comboSource4.GetCurSel()];
	if (m_comboDest.GetCurSel()<0) 
		id=m_iI[m_comboDest.GetCount()-1];
	else
		id=m_iI[m_comboDest.GetCurSel()];

	//Mmorisation situation actuelle fentres car la numrotation 
	//effective est attribue par CBkDoc...
	BOOL *m_OKF;
	m_OKF=new BOOL[m_pApp->m_iNbMax];
	for (i=0;i<m_pApp->m_iNbMax;i++)	
	{
		if (m_pApp->GetDocument(i)!=NULL) m_OKF[i]=TRUE; else m_OKF[i]=FALSE;
	}
	//Si la fentre source1, il faut la crer...
	if (!m_OKF[is1])
	{
		//L'image destination existe maintenant.
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		ps1=m_pApp->GetDocument();
	}
	else
	{
		//Pointeur sur destination
		ps1=m_pApp->m_pDocument[is1];
	}
	//Initialisation image 0_______________
	ps1->InitialiserImage(l,h,8);
	ps1->DimensionnerFenetre(l,h);
	ps1->m_sNomFic.Format("Image0");
	ps1->DefinirCurseurs(l,h);
	ps1->m_iType=0;
	ps1->InitTracker();
	//Acquisition image 0__________________
	ps1->AcqPerm();
	if (m_radioTypDeph==0) 
	{
		m_pPiezo->Tension(0);
		Sleep(m_iTempo);
		m_pPiezo->Tension(m_iU1);
	}
	else
	{
		m_pC832->MA(1,m_fX1);
		//m_pC832->WS(1);
		while (!m_pC832->MD(1))
		{
			;
		}
	}
	Sleep(m_iTempo);
	ps1->FigerAcq();

	if (!m_OKF[is2])
	{
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		ps2=m_pApp->GetDocument();
	}
	else
	{
		ps2=m_pApp->m_pDocument[is2];
	}
	//Initialisation image 90______________
	ps2->InitialiserImage(l,h,8);
	ps2->DimensionnerFenetre(l,h);
	ps2->m_sNomFic.Format("Image90");
	ps2->DefinirCurseurs(l,h);
	ps2->m_iType=0;
	ps2->InitTracker();
	//Acquisition image 90_________________
	ps2->AcqPerm();
	if (m_radioTypDeph==0)
	{
		m_pPiezo->Tension(m_iU2);
	}
	else
	{
		m_pC832->MA(1,m_fX2);
		//m_pC832->WS(1);
		while (!m_pC832->MD(1))
		{
			;
		}
	}
	Sleep(m_iTempo);
	ps2->FigerAcq();

	if (!m_OKF[is3])
	{
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		ps3=m_pApp->GetDocument();
	}
	else
	{
		ps3=m_pApp->m_pDocument[is3];
	}
	//Initialisation image 180_____________
	ps3->InitialiserImage(l,h,8);
	ps3->DimensionnerFenetre(l,h);
	ps3->m_sNomFic.Format("Image180");
	ps3->DefinirCurseurs(l,h);
	ps3->m_iType=0;
	ps3->InitTracker();
	//Acquisition image 180________________
	ps3->AcqPerm();
	if (m_radioTypDeph==0)
	{ 
		m_pPiezo->Tension(m_iU3);
	}
	else
	{
		m_pC832->MA(1,m_fX3);
		//m_pC832->WS(1);
		while (!m_pC832->MD(1))
		{
			;
		}
	}
	Sleep(m_iTempo);
	ps3->FigerAcq();

	if (!m_OKF[is4])
	{
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		ps4=m_pApp->GetDocument();
	}
	else
	{
		ps4=m_pApp->m_pDocument[is4];
	}
	//Initialisation image 270_____________
	ps4->InitialiserImage(l,h,8);
	ps4->DimensionnerFenetre(l,h);
	ps4->m_sNomFic.Format("Image270");
	ps4->DefinirCurseurs(l,h);
	ps4->m_iType=0;
	ps4->InitTracker();
	//Acquisition image 270________________
	ps4->AcqPerm();
	if (m_radioTypDeph==0)
	{ 
		m_pPiezo->Tension(m_iU4);
	}
	else
	{
		m_pC832->MA(1,m_fX4);
		//m_pC832->WS(1);
		while (!m_pC832->MD(1))
		{
			;
		}
	}
	Sleep(m_iTempo);
	ps4->FigerAcq();
	//Si la fentre destination n'existe pas, il faut la crer...
	if (!m_OKF[id])
	{
		//L'image destination existe maintenant.
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		pd=m_pApp->GetDocument();
	}
	else
	{
		//Pointeur sur destination
		pd=m_pApp->m_pDocument[id];
		pd->DimensionnerFenetre((short)(m_pApp->m_iL),(short)(m_pApp->m_iH));
	}
	//Initialisation image destination______
	pd->InitialiserImage(l,h,8);
	pd->DimensionnerFenetre(l,h);
	pd->m_sNomFic.Format("ImPhase");
	pd->DefinirCurseurs(l,h);
	pd->m_iType=0;
	pd->InitTracker();
	pd->PositionnerFenetre(0,0);
	//Calcul de l'image phase entre [0 et 255]
	if (m_OKFiltre)
	{
		//On calcule la moyenne au numrateur et au dnominateur des pixels d'une zone 3x3
		short id,ia,jd,ja,l,h,n;
		for (i=0;i<(short)(m_pApp->m_iL);i++)
		{
			for (j=0;j<(short)(m_pApp->m_iH);j++)
			{
				id=i-1;if (id<0) id=0;
				ia=i+1;if (ia>=m_pApp->m_iL) ia=m_pApp->m_iL-1;
				jd=j-1;if (jd<0) jd=0;
				ja=j+1;if (ja>=m_pApp->m_iH) ja=m_pApp->m_iH-1;
				w1=0;w4=0;n=0;
				for (l=id;l<=ia;l++)
				{
					for (h=jd;h<=ja;h++)
					{
						w4=w4+getpixelcolor(ps4->image,l,h)-getpixelcolor(ps2->image,l,h);
						w1=w1+getpixelcolor(ps1->image,l,h)-getpixelcolor(ps3->image,l,h);
						n++;
					}
				}
				if (n!=0)
				{
					w4=w4/n;w1=w1/n;
				}
				else
				{
					w4=0;w1=0;
				}

				if(w1==0)
					r=0;
				else
					//r=atan2(1.0*(w4),1.0*(w1));
					//atan entre 0 et 2PI
					r=atan_bk_f(1.0*(w4),1.0*(w1));

				//Intervalle [0, 255]
				//r=255.0*(r+3.14)/6.28;
				r=255.0*r/6.28;

				if (r<0) r=0;
				if (r>255) r=255;
				w=(long)(r);
				setpixelcolor(pd->image,i,j,w);
			}
		}		
	}
	else
	{
		//Pas de filtre...
		for (i=0;i<(short)(m_pApp->m_iL);i++)
		{
			for (j=0;j<(short)(m_pApp->m_iH);j++)
			{	
				w1=getpixelcolor(ps1->image,i,j);
				w2=getpixelcolor(ps2->image,i,j);
				w3=getpixelcolor(ps3->image,i,j);
				w4=getpixelcolor(ps4->image,i,j);
				if(w1-w3==0)
					r=0;
				else
					//r=atan2(1.0*(w4-w2),1.0*(w1-w3));
					r=atan_bk_f(1.0*(w4-w2),1.0*(w1-w3));
				//Intervalle [0, 255]
				//r=255.0*(r+3.14)/6.28;
				r=255.0*r/6.28;

				if (r<0) r=0;
				if (r>255) r=255;
				w=(long)(r);
				setpixelcolor(pd->image,i,j,w);
			}
		}
	}
	pd->UpdateAllViews(NULL);

	delete m_iI;
	delete m_OKF;
	if (!m_OK_NT) delete m_pC832;
	delete m_pPiezo;
	CDialog::OnOK();
}
//________________________________________
void CAcqPhDlg::OnCancel() 
{
	KillTimer(1);
	delete m_iI;
	if (!m_OK_NT) delete m_pC832;
	delete m_pPiezo;
	CDialog::OnCancel();
}
//________________________________________
float CAcqPhDlg::atan_bk_f(float n,float d)
{
	float r;
	if (fabs(d)<1e-8)
		r=1e10;
	else
	{
		r=atan(n/d);
		if (n>0)
		{
			//Numrateur positif
			if (r>0)
			{
				//Tangente positive et numrateur positif: 1er quadrant
			}
			else
			{
				//Tangente ngative et numrateur positif: 2me quadrant
				r=r+3.1415;
			}
		}
		else
		{
			//Numrateur ngatif
			if (r>0)
			{
				//Tangente positive et numrateur ngatif: 3me quadrant
				r=r+3.1445;
			}
			else
			{
				//Tangente ngative et numrateur ngatif: 4me quadrant
				r=r+6.28;
			}

		}
	}
	return r;
}
