// AjustDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "AjustDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CAjustDlg dialog
CAjustDlg::CAjustDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAjustDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAjustDlg)
	m_sTexte = _T("");
	m_iIt = 0;
	m_iCt = 0;
	m_sGt = _T("");
	//}}AFX_DATA_INIT
}
void CAjustDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAjustDlg)
	DDX_Control(pDX, IDC_SLIDERI, m_sliderI);
	DDX_Control(pDX, IDC_SLIDERG, m_sliderG);
	DDX_Control(pDX, IDC_SLIDERC, m_sliderC);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Text(pDX, IDC_IT, m_iIt);
	DDX_Text(pDX, IDC_CT, m_iCt);
	DDX_Text(pDX, IDC_GT, m_sGt);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAjustDlg, CDialog)
	//{{AFX_MSG_MAP(CAjustDlg)
	ON_BN_CLICKED(IDORI, OnOri)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDVISU, OnVisu)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CAjustDlg message handlers
void CAjustDlg::Visualiser() 
{
	copyimage(m_pApp->imt[m_iNo],m_pDoc->image);
	//Changement de luminance
	changebright(m_iIt,m_pDoc->image,m_pDoc->image);
	
	//Changement de contraste
	expandcontrast(0+m_iCt,255-m_iCt,m_pDoc->image,m_pDoc->image);
	//Changement de facteur gamma
	gammabrighten(m_fGt,m_pDoc->image,m_pDoc->image);
	
	//Raffichage vue
	//m_pDoc->UpdateAllViews(NULL);
	m_pView->MAJ_Fen();
}
//________________________________________
BOOL CAjustDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short rcode;
	//Pointeur sur l'application
	m_pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	//Pointeur sur la vue
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;

	m_iNo=m_pDoc->m_iNo;
	//m_pDoc=m_pApp->GetDocument();
	m_sTexte.Format("(%d)",m_iNo);
	//Dfinition des plages des sliders
	m_sliderI.SetRange(0,511);//-255, 255
	m_sliderC.SetRange(0,100);
	m_sliderG.SetRange(1,100);//0.01, 1
	m_sliderI.SetPos(255);//0
	m_sliderC.SetPos(0);//0
	m_sliderG.SetPos(100);//1
	m_iIt=m_sliderI.GetPos()-255;
	m_iCt=m_sliderC.GetPos();
	m_fGt=0.01*m_sliderG.GetPos();
	m_sGt.Format("%4.2f",m_fGt);
	rcode=m_pApp->DupliquerImageDestTempo(m_iNo,m_iNo);

	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CAjustDlg::OnOri() 
{
	m_sliderI.SetPos(255);//0
	m_sliderC.SetPos(0);//0
	m_sliderG.SetPos(100);//1
	m_iIt=m_sliderI.GetPos()-255;
	m_iCt=m_sliderC.GetPos();
	m_fGt=0.01*m_sliderG.GetPos();
	m_sGt.Format("%4.2f",m_fGt);
	UpdateData(FALSE);
	copyimage(m_pApp->imt[m_iNo],m_pDoc->image);
	//Raffichage vue
	//m_pDoc->UpdateAllViews(NULL);
	m_pView->MAJ_Fen();
}
//________________________________________
void CAjustDlg::OnOK() 
{
	//Raffichage vue
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnOK();
}
//________________________________________
void CAjustDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	//Dplacement d'un slider
	m_iIt=m_sliderI.GetPos()-255;
	m_iCt=m_sliderC.GetPos();
	m_fGt=0.01*m_sliderG.GetPos();
	m_sGt.Format("%4.2f",m_fGt);
	UpdateData(FALSE);	
	Visualiser();
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CAjustDlg::OnVisu() 
{
	int i;
	UpdateData(TRUE);
	if (m_iIt<-255) m_iIt=-255;
	if (m_iIt>255) m_iIt=255;
	if (m_iCt<0) m_iCt=0;
	if (m_iCt>100) m_iCt=100;
	i=sscanf(m_sGt,"%f",&m_fGt);
	if (i==0) m_fGt=0.0;
	if (m_fGt<0.01) m_fGt=0.01;
	if (m_fGt>=1.0) m_fGt=1.0;
	m_sGt.Format("%4.2f",m_fGt);
	m_sliderI.SetPos(m_iIt+255);
	m_sliderC.SetPos(m_iCt);
	m_sliderG.SetPos((short)(m_fGt*100));
	UpdateData(FALSE);
	Visualiser();
}
//________________________________________
void CAjustDlg::OnCancel() 
{
	copyimage(m_pApp->imt[m_iNo],m_pDoc->image);
	//Raffichage vue
	//m_pDoc->UpdateAllViews(NULL);
	m_pView->MAJ_Fen();
	CDialog::OnCancel();
}
