// BkDoc.cpp : implementation of the CBkDoc class
//
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "Vicdefs.h"
#include "GeoAna.h"
#include "Math.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CBkDoc construction/destruction
CBkDoc::CBkDoc()
{
	m_pApp=((CBkApp*)AfxGetApp());
	m_pWnd=NULL;				//Pointeur sur la fentre affect dans CBkView::OnInitialUpdate
	m_pView=NULL;				//Pointeur sur la vue affect dans CBkView::OnInitialUpdate
	//Tailles_______________________________
	m_iL=m_pApp->m_iL;
	m_iH=m_pApp->m_iH;
	m_iNbB=m_pApp->m_iNbB;
	//Fentre_______________________________
	short i;
	BOOL ok=FALSE;
	i=0;
	do
	{
		if (!m_pApp->m_pDocument[i])
		{
			ok=TRUE;
		}         
		else
			i++;
	}
	while (i<m_pApp->m_iNbMax && !ok);
	if (ok)
	{
		m_iNo=i;
		image=m_pApp->image[i];
	}
	//Pointeur sur document_________________
	m_pApp->m_pDocument[m_iNo]=this;
	m_sNomFic.Format("SansNom%d",m_iNo);
	m_pApp->m_iNo=m_iNo;
	//Coordonnes souris_____________________
	m_iX=m_iY=0;				//Coordonnes absolues
	m_iW=0;
	m_iDx=m_iDy=0;			//Coordonnes relatives
	m_iDw=0;
	m_iXpos=m_iYpos=0;	//Barres de dfilement
	//Attributions de l'image_______________
	m_iType=0;					//Bit0: Visu3D
											//Bit1: Trac dans Excel
											//Bit2: Trac de profil H
											//Bit3: Trac de profil V
											//Bit4: Trac de gaussienne H
											//Bit5: Trac de gaussienne V
											//Bit6: Trac de cotes
											//Bit7: Annotations
											//Bit8: Objet3D
  InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,m_pApp->m_iNbB);
	//Profil________________________________
	m_p.radioRouge=0,		//0:R, 1:V, 2:B
	m_p.iX1=-1;					//Positions de trac du profil
	m_p.iY1=-1;
	m_p.iX2=-1;
	m_p.iY2=-1;
	m_p.OK=FALSE;
  //Donnes (profil,...)__________________
	m_iNbMax=800;				//Nb. maxi de donnes
  m_iNb=0;						//Aucune donne pour l'instant
  m_fT=new float[m_iNbMax][6];

	//Cotation_______________________________________
	m_c.no=0;
	for (i=0;i<8;i++)
	{
		m_c.x1[i]=-1;m_c.y1[i]=-1;m_c.x2[i]=-1;m_c.y2[i]=-1;m_c.s[i]="";
	}
	//Franges de moir______________________
	m_iM=-1;
	m_fDeltaZ=1.5;
	//Echelles pour calibrage_______________
	if (m_pApp->m_OKCalb)
	{
		m_fEchXY=m_pApp->m_fEchXY;
		m_fEchZ=m_pApp->m_fEchZ;
		m_fFactXY=m_pApp->m_fFactXY;
		m_fFactZ=m_pApp->m_fFactZ;
		m_OKXY=m_OKZ=TRUE;
	}
	else
	{
		m_fEchXY=1;
		m_fEchZ=1;
		m_fFactXY=1;
		m_fFactZ=1;
		m_OKXY=m_OKZ=FALSE;
	}
	//Tracker_______________________________
	InitTracker();
	m_radioTypeTracker=0;//0:Rectangle, 1:Ellipse
	/*
	//Carte d'imagerie Meteor_______________
	//Carte d'imagerie Orion________________
	MilImage=m_pApp->MilImage[m_iNo];
	BufferAttributes=m_pApp->BufferAttributes[m_iNo];
	*/
}
//________________________________________
CBkDoc::~CBkDoc()
{
	//Carte d'imagerie Meteor_______________
	//Carte d'imagerie Orion________________
	/*
	if (m_pApp->m_OKCarte) 
	{
		RemoveFromDisplay();
		MbufClear(MilImage,0);
	}
	*/
	m_pApp->m_pDocument[m_iNo]=NULL;
	delete[] m_fT;
}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}
//////////////////////////////////////////
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	TiffData tif;
	JpegData jpg;
	CString s,s1;
	CFile *fp=ar.GetFile();
	short i,rcode;
	//Carte d'imagerie
	if (m_pApp->GrabIsStarted) FigerAcq();
	//______________________________________
	s=fp->GetFilePath();
	m_sNomFic="";//Nom de fichier attribu automatiquement
	if (ar.IsStoring())
	{
		//Ecriture
		//On ferme pour que la fonction saveim puisse ouvrir le mme fichier
		if (s.Find(".im")!=-1 || s.Find(".IM")!=-1)
		{
			fp->Close();
			rcode=Saveim(s,image);
			//On le rouvre pour ne pas faire boguer par la suite...
			fp->Open(s,CFile::modeWrite);	
		}
		else	
		if (s.Find(".tif")!=-1 || s.Find(".TIF")!=-1)
		{
			fp->Close();
			rcode=savetif(s,image,0);
			fp->Open(s,CFile::modeWrite);	
		}
		else
		if (s.Find(".jpg")!=-1 || s.Find(".JPG")!=-1)
		{
			fp->Close();
			rcode=savejpg(s,image,75);
			fp->Open(s,CFile::modeWrite);	
		}
		else
		{
			i=s.Find(".");
			if (i==-1)
			{
				//Ajout extension .tif
				s=s+".tif";
				fp->Close();
				rcode=savetif(s,image,0);
				fp->Open(s,CFile::modeWrite);	
			}
			else
				rcode=1;
		}
	}
	else
	{
		//Lecture
		if (s.Find(".im")!=-1 || s.Find(".IM")!=-1)
		{
			//On ferme pour que la fonction loadim puisse ouvrir le mme fichier
			fp->Close();
			rcode=Loadim(s,image);
			//On le rouvre pour ne pas faire boguer par la suite...
			fp->Open(s,CFile::modeRead);	
		}
		else
		if (s.Find(".tif")!=-1 || s.Find(".TIF")!=-1)
		{
			rcode=tiffinfo(s,&tif);
			if (rcode==0)
			{
				InitialiserImage(tif.width,tif.length,tif.vbitcount);
				rcode=loadtif(s,image);
				//Pas de marque de pointage
				//m_iDx=0;m_iDy=0;
			}
		}
		if (s.Find(".jpg")!=-1 || s.Find(".JPG")!=-1)
		{
			rcode=jpeginfo(s,&jpg);
			if (rcode==0)
			{
				InitialiserImage(jpg.width,jpg.length,jpg.vbitcount);
				rcode=loadjpg(s,image);
				//Pas de marque de pointage
				//m_iDx=0;m_iDy=0;
			}
		}
	}
	UpdateAllViews(NULL);
}
//////////////////////////////////////////
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}
void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkDoc commands
void CBkDoc::EcritTitre(void)
{
	CString s;
	short x;
	if (GetPathName().GetLength()==0)
	{
	}
	else
	{
		//GetTitle ne renvoie pas l'extension...
		if (m_sNomFic.GetLength()==0) m_sNomFic=GetPathName();

		//AfxMessageBox(m_sNomFic);

		//On enlve le chemin pour ne garder que le nom du fichier avec extension
		x=m_sNomFic.ReverseFind('\\');
		if (x>=0)	m_sNomFic=m_sNomFic.Right(m_sNomFic.GetLength()-x-1);
	}
	s.Format("(%d) %s (%dx%d)",m_iNo,m_sNomFic,m_iL,m_iH);
	SetTitle(s);
}
//_________________________________________________
void CBkDoc::DimensionnerFenetre(short l,short h)
{
	CRect	 MMRect,MMRect1,MMRect2;
	short l1,h1,l2,h2;
	m_pWnd->GetWindowRect(MMRect1);
	m_pWnd->GetClientRect(MMRect2);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	l2=MMRect2.right-MMRect2.left;
	h2=MMRect2.bottom-MMRect2.top;
	MMRect.SetRect(0,0,l+l1-l2+4,h+h1-h2+4);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l1,h1,MMRect.right,MMRect.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE|SWP_DRAWFRAME);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//_________________________________________________
void CBkDoc::PositionnerFenetre(short l,short h)
{
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1;
	m_pWnd->GetWindowRect(MMRect1);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	MMRect.SetRect(0,0,l1,h1);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l,h,MMRect.right,MMRect.bottom,SWP_NOZORDER|SWP_DRAWFRAME|SWP_SHOWWINDOW);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//________________________________________
void CBkDoc::LimiterTailleFenetre(short l,short h)
{
	//Limite la taille de la fentre  l x h si elle est plus grande
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1,l2,h2;
	if (m_pWnd!=NULL)
	{
		m_pWnd->GetWindowRect(MMRect1);
		m_pWnd->GetClientRect(MMRect2);
		l1=MMRect1.right-MMRect1.left;
		h1=MMRect1.bottom-MMRect1.top;
		l2=MMRect2.right-MMRect2.left;
		h2=MMRect2.bottom-MMRect2.top;
		if (l1>l || h1>h)
		{
			MMRect.SetRect(0,0,l+l1-l2+4,h+h1-h2+4);
			MMRect.OffsetRect(-MMRect.left,-MMRect.top);
			m_pWnd->SetWindowPos(NULL,l1,h1,MMRect.right,MMRect.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE|SWP_DRAWFRAME);
			m_pWnd->InvalidateRect(NULL,FALSE);
		}
	}
}
//________________________________________
void CBkDoc::DefinirCurseurs(short l,short h)
{
	m_pView->SetScrollSizes(MM_TEXT, CSize(l,h));
	m_pView->ScrollToPosition(CPoint(0,0));
	m_iXpos=m_pView->GetScrollPos(SB_HORZ);
	m_iYpos=m_pView->GetScrollPos(SB_VERT);
}
//________________________________________
void CBkDoc::InitialiserImage(short l,short h,short nbB)
{
	short l1,h1,nbB1;
	int rcode=0;
	l1=image->endx-image->stx+1;
	h1=image->endy-image->sty+1;
	nbB1=image->bmh->biBitCount;
	if (l!=l1 || h!=h1 || nbB!=nbB1)
	{
		freeimage(image);
		rcode=allocimage(image,l,h,nbB);
	}
	if (rcode==0) rcode=zeroimage(255,image);
	if (rcode!=0) AfxMessageBox("Erreur sur fonction CBkDoc::InitialiserImage");
	m_iL=l;m_iH=h;m_iNbB=nbB;
}
//________________________________________
//Calcul des fonctions profils et gaussiennes et affectation m_fT
void CBkDoc::CalculProfils(short rouge,short X1,short Y1,short X2,short Y2)
{
	short 
		x1,y1,x2,y2,
		i,nb,l,h,k;
	float 
		a,b,
		x,y,
		*t,sig,vc,
		PI=4*atan(1);
	long w;
	t=new float[m_iNbMax];
	class CGeoAna geo;
	//Initialisation tableau m_fT document destination
	for (l=0;l<m_iNbMax;l++)
	{
		for (h=0;h<6;h++) m_fT[l][h]=1e10;
	}

	if (X1<X2)
	{
		x1=X1;x2=X2;
	}
	else
	{
		x1=X2;x2=X1;
	}
	if (Y1<Y2)
	{
		y1=Y1;y2=Y2;
	}
	else
	{
		y1=Y2;y2=Y1;
	}
	geo.d2p(X1,Y1,X2,Y2,&a,&b);
	//Profil H____________________________
	k=0;
	for (l=x1;l<x2;l++)
	{
		geo.p2d(X1,Y1,a,l,0,PI/2,&x,&y);
		if (k<m_iNbMax && x!=1e10 && y!=1e10 && x>=0 && x<m_iL && y>=0 && y<m_iH)
		{
			w=getpixelcolor(image,l,(short)(y));
			w=composante(w,rouge);
			m_fT[k][0]=l;
			m_fT[k][1]=w;
			if (k<1024)
			{
				t[k]=(float)w;
				k++;
			}
		}
	}
	//Gauss H_____________________________
	nb=k;
	sig=sigma(t,nb);
	vc=val_cen(t,nb);
	if (vc==1e10)
		vc=127;
	else
		vc=vc+x1;
	//Maxi
	w=0;
	for (i=0;i<nb;i++)
	{
		if (i<m_iNbMax)
		{
			if (t[i]>w) w=(int)t[i];
		}
	}
	k=0;     
	for (l=x1;l<x2;l++)
	{
		if (k<m_iNbMax)
		{
			m_fT[k][2]=1.0*w*gauss(l,vc,sig);
			k++;
		}
	}
	//Profil V____________________________
	k=0;
	for (h=y1;h<y2;h++)
	{
		geo.p2d(X1,Y1,a,0,h,0,&x,&y);
		if (k<m_iNbMax && x!=1e10 && y!=1e10 && x>=0 && x<m_iL && y>=0 && y<m_iH)
		{
			w=getpixelcolor(image,(short)(x),h);
			w=composante(w,rouge);
			m_fT[k][3]=w;
			m_fT[k][4]=h;
			t[k]=(float)w;
			k++;
		}
	}	
	//Gauss V_____________________________
	nb=k;
	sig=sigma(t,nb);
	vc=val_cen(t,nb);
	if (vc==1e10)
		vc=127;
	else
		vc=vc+y1;
	//Maxi
	w=0;
	for (i=0;i<nb;i++)
	{
		if (i<m_iNbMax)
		{
			if (t[i]>w) w=(int)t[i];
		}
	}
	k=0;     
	for (h=y1;h<y2;h++)
	{
		if (k<m_iNbMax)
		{
			m_fT[k][5]=1.0*w*gauss(h,vc,sig);
		}
		k++;
	}
	m_iNb=m_iNbMax;
	delete[] t;
}
//________________________________________
long CBkDoc::composante(long w,short composante)
{
	long w1;
	switch (composante)
	{
		case 0://Composante rouge
			w1=w&255;
		break;
		case 1://Composante verte
			w1=(w/256)&255;
		break;
		case 2://Composante bleue
			w1=(w/65536)&255;
		break;
	}
	return w1;
}
//________________________________________
float CBkDoc::gauss(float p,float p0,float sigma)
{
	return (float)(exp(-pow(p-p0,2)/(2*pow(sigma,2))));
}
//________________________________________
float CBkDoc::val_cen(float t[1024],unsigned int n)
{
	float s=0,s1=0;
	int w;
	if (n==0) return 1e10;
	if (n>1024) n=1024;
	for (w=0;w<n;w++)
	{
		s=s+t[w]*(w+1);
		s1=s1+t[w];
	}
	if (fabs(s1)>1e-6) return s/s1; else return 1e10;
}
//________________________________________
float CBkDoc::sigma(float t[1024],unsigned int n)
{
	float r=0,s=0,s1=0,moy=0;
	int w;
	if (n==0) return 1e10;
	if (n>1024) n=1024;

	for (w=0;w<n;w++)
	{
		s=s+t[w]*(w+1);
		s1=s1+t[w];
	}
	moy=s/s1;
	for (w=0;w<n;w++)
	{
		r=r+pow(moy-(w+1),2)*t[w];
	}
	return (float)(pow(r/s1,0.5));
}
//________________________________________
short CBkDoc::Saveim(CString s,imgdes *image)
{
	CFile f;
	char buf[512];
	short i,j,l,h,nb;
	int ok;
	CString s1="";
	if(!f.Open(s,CFile::modeCreate|CFile::modeWrite))
	{
		AfxMessageBox("Erreur !");
		ok=-1;
	}
	else
	{
		CArchive ar( &f,CArchive::store,512,buf);
		ar << (short)m_iType;           
		l=image->endx-image->stx+1;
		h=image->endy-image->sty+1;
		if (image->imgtype==1) nb=8; else nb=24;

		ar << (short)l;           
		ar << (short)h;           
		ar << (short)nb;           
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				ar << (long)getpixelcolor(image,i,j);           
			}
		}
		//Tableau de mesure
		ar << (short)m_iNb; 
		for (i=0;i<m_iNbMax;i++)
		{
			for (j=0;j<6;j++)
			{
				ar << m_fT[i][j];
			}
		}
		//Profils
		ar << (short)m_p.radioRouge;
		ar << (short)m_p.iX1;
		ar << (short)m_p.iY1;
		ar << (short)m_p.iX2;
		ar << (short)m_p.iY2;

		ar << (short)m_iType;

		//Echelles
		ar << m_fEchXY;
		ar << m_fEchXY;//m_fEchy;
		ar << m_fEchZ;
		ar << m_fFactXY;
		ar << m_fFactXY;//m_fFacty;
		ar << m_fFactZ;
		ar << (float)0.0;//m_fXori;
		ar << (float)0.0;//m_fYori;
		ar << (float)0.0;//m_fXmi;
		ar << (float)280.0;//m_fXma;
		ar << (float)0.0;//m_fYmi;
		ar << (float)190.0;//m_fYma;
		//Calibration
		ar << (short)0;//m_pApp->m_iObj;
		for (i=0;i<6;i++)
		{
			ar << (float)1;//m_pApp->m_fEx[i];
			ar << (float)1;//m_pApp->m_fEy[i];
			ar << (float)1;//m_pApp->m_fEz[i];
			ar << (float)1;//m_pApp->m_fFx[i];
			ar << (float)1;//m_pApp->m_fFy[i];
			ar << (float)1;//m_pApp->m_fFz[i];
		}
		//Moir & speckle
		ar << (short)m_iM;
		ar << m_fDeltaZ;
		//Grandissement
		ar << (short)0;//(short)m_iObj;
		//Cotation
		ar << m_c.no;
		for (i=0;i<8;i++)
		{
			ar << m_c.x1[i];
			ar << m_c.x2[i];
			ar << m_c.y1[i];
			ar << m_c.y2[i];
			ar << m_c.s[i];
		}
		//Annotations
		ar << (short)0;//a.OK;
		for (i=0;i<6;i++)
		{
			ar << (float)1e10;//a.x[i];
			ar << (float)1e10;//a.y[i];
			ar << s1;//a.s[i];
			ar << s1;//a.a[i];
		}
		//Paramtres
		for (i=0;i<84;i++)
		{
			ar << (short)0;
		}

		//Couleurs
		for (i=0;i<7;i++)
		{
			ar << (long)m_pApp->couleur[i];
		}
		//Calibrage
		ar << (short)m_OKXY;
		ar << (short)m_OKZ;

		//Paramtres
		ar << (short)m_pApp->m_iHaut;
 		ar << (short)m_pApp->m_iEpais;

		ar.Close();
		f.Close();
		ok=0;
	}
	return ok;
}
//________________________________________
short CBkDoc::Loadim(CString s,imgdes *image)
{
	CFile f;
	short 
		er=0,
		l,h,nb,
		i,j,k;
	long w;
	CString s1;
	BOOL OK;
	float r;
	char buf[512];
	CFileException e;
	if(!f.Open(s,CFile::modeRead,&e))
	{
		er=-1;
	}
	else
	{
		CArchive ar(&f,CArchive::load,512,buf);
		ar >> (short&)m_iType;           
		ar >> (short&)l;           
		ar >> (short&)h;           
		ar >> (short&)nb;  
		freeimage(image);
		allocimage(image,l,h,nb);
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				ar >> w;
				setpixelcolor(image,i,j,w);           
			}
		}
		m_iL=l;m_iH=h;m_iNbB=nb;
		//Tableau de mesure
		ar >> (short&)m_iNb; 
		for (i=0;i<m_iNbMax;i++)
		{
			for (j=0;j<6;j++)
			{
				ar >> m_fT[i][j];
			}
		}
		//Profils
		ar >> (short&)m_p.radioRouge;
		ar >> (short&)m_p.iX1;
		ar >> (short&)m_p.iY1;
		ar >> (short&)m_p.iX2;
		ar >> (short&)m_p.iY2;

		ar >> (short&)m_iType;

		//Echelles
		ar >> m_fEchXY;
		ar >> r;
		ar >> m_fEchZ;
		ar >> m_fFactXY;
		ar >> r;
		ar >> m_fFactZ;
		for (i=0;i<85;i++)
		{
			ar >> (short&)k;
		}
		//Moir & speckle
		ar >> (short&)m_iM;
		ar >> m_fDeltaZ;
		//Grandissement
		ar >> (short&)k;
		//Cotation
		ar >> m_c.no;
		for (i=0;i<8;i++)
		{
			ar >> m_c.x1[i];
			ar >> m_c.x2[i];
			ar >> m_c.y1[i];
			ar >> m_c.y2[i];
			ar >> m_c.s[i];
		}
		//Annotations
		ar >> (short&)OK;
		for (i=0;i<6;i++)
		{
			ar >> r;
			ar >> r;
			ar >> s1;
			ar >> s1;
		}
		//Paramtres
		//float: 4 octets
		//long: 4 octets
		//short: 2 octets
		for (i=0;i<84;i++)
		{
			ar >> (short&)k;
		}
		//Couleurs
		for (i=0;i<7;i++)
		{
			ar >> (long&)m_pApp->couleur[i];
		}
		//Calibrage
		ar >> (short&)m_OKXY;
		ar >> (short&)m_OKZ;
		//Paramtres
		ar >> (short&)m_pApp->m_iHaut;
 		ar >> (short&)m_pApp->m_iEpais;
		
		ar.Close();
		f.Close();
	}
	return er;
}
//________________________________________
void CBkDoc::InitTracker(void)
{                       
	m_tracker.m_rect.SetRectEmpty();
	m_tracker.m_nStyle=m_tracker.dottedLine;
	m_tracker.m_nHandleSize=5;
}
//Sans carte d'imagerie___________________
/*
void CBkDoc::FigerAcq(void) 
{
}
void CBkDoc::AcqPerm(void) 
{
}
*/
//Carte d'imagerie Primo_________________
/**/
void CBkDoc::FigerAcq(void) 
{
	int rcode;
	short l,h,nbB;
	m_pApp->ExecPrimo(2);Sleep(1000);
	m_pApp->GrabIsStarted=FALSE;	
	//Chargement de l'image dans image temporaire 0
	l=m_pApp->imt[0]->endx-m_pApp->imt[0]->stx+1;
	h=m_pApp->imt[0]->endy-m_pApp->imt[0]->sty+1;
	nbB=m_pApp->imt[0]->bmh->biBitCount;
	if (l!=512 || h!=512 || nbB!=8)
	{
		freeimage(m_pApp->imt[0]);
		allocimage(m_pApp->imt[0],512,512,8);
	}
	rcode=loadtif("c:\\bk.tif",m_pApp->imt[0]);
	if (rcode==0)
	{
		l=image->endx-image->stx+1;
		h=image->endy-image->sty+1;
		nbB=image->bmh->biBitCount;
		if (l!=m_pApp->m_iL || h!=m_pApp->m_iH || nbB!=8)
		{
			freeimage(image);
			allocimage(image,m_pApp->m_iL,m_pApp->m_iH,8);
		}
		m_iL=m_pApp->m_iL;
		m_iH=m_pApp->m_iH;
		m_iNbB=8;
		DimensionnerFenetre(m_iL,m_iH);
		DefinirCurseurs(m_iL,m_iH);
		m_iType=0;
		//Dilatation de l'image imageori
		rcode=resize(m_pApp->imt[0],image);
		//CString z;z.Format("%d",rcode);AfxMessageBox(z);
		//Raffichage vues
		UpdateAllViews(NULL);
	}
}
//________________________________________
void CBkDoc::AcqPerm(void) 
{
	m_pApp->ExecPrimo(1);
	m_pApp->GrabIsStarted=TRUE;	
}
/**/
//Carte d'imagerie Cyclope________________
/*
void CBkDoc::FigerAcq(void) 
{
	short 
		rcode,i,j,
		l,h,nbB;
	BOOL ok=FALSE;

	i=0;
	if (m_pApp->m_OKCarte)
	{
		rcode=m_pApp->ExecCycDos(3);//Acquisition fige
 		m_pApp->GrabIsStarted=FALSE;	
		if (rcode!=0) 
		{
		}
		else
		{
			rcode=m_pApp->ExecCycDos(4);//Sauvegarde sur disque sous "c:\\visuimcy\\bk.$$$"
			if (rcode!=0) 
			{
			}
			else
			{
				//Chargement de l'image dans image temporaire 0
				l=m_pApp->imt[0]->endx-m_pApp->imt[0]->stx+1;
				h=m_pApp->imt[0]->endy-m_pApp->imt[0]->sty+1;
				nbB=m_pApp->imt[0]->bmh->biBitCount;
				if (l!=512 || h!=512 || nbB!=8)
				{
					freeimage(m_pApp->imt[0]);
					allocimage(m_pApp->imt[0],512,512,8);
				}
				rcode=loadtif("c:\\visuimcy\\bk.$$$",m_pApp->imt[0]);
				l=image->endx-image->stx+1;
				h=image->endy-image->sty+1;
				nbB=image->bmh->biBitCount;
				if (l!=m_pApp->m_iL || h!=m_pApp->m_iH || nbB!=8)
				{
					freeimage(image);
					allocimage(image,m_pApp->m_iL,m_pApp->m_iH,8);
				}
				m_iL=m_pApp->m_iL;
				m_iH=m_pApp->m_iH;
				m_iNbB=8;
				DimensionnerFenetre(m_iL,m_iH);
				DefinirCurseurs(m_iL,m_iH);
				m_iType=0;
				//Dilatation de l'image imageori
				rcode=resize(m_pApp->imt[0],image);
				//CString z;z.Format("%d",rcode);AfxMessageBox(z);
				//Raffichage vues
				UpdateAllViews(NULL);
			}	
		}
	}
}
//________________________________________
void CBkDoc::AcqPerm(void) 
{
	short er;
	if (m_pApp->m_OKCarte)
	{
 		m_pApp->GrabIsStarted=TRUE;	
		er=m_pApp->ExecCycDos(2);//Acquisition permanente
		if (er!=0) 
		{
			//sprintf(s,"Erreur n%d retoune !",er);AfxMessageBox(s);
		}
	}	
}
*/
//Carte d'imagerie Meteor_________________
//Carte d'imagerie Orion__________________
/*
//Function used to halt the grab, deselect the buffer and free the display
void CBkDoc::RemoveFromDisplay()
{
	//Halt grab if in process in THIS view
	if ((m_pApp->GrabInViewPtr==m_pView) && m_pApp->GrabIsStarted)
	{
		MdigHalt(m_pApp->MilDigitizer);
 		m_pApp->GrabIsStarted=FALSE;	
	}
	//Deselect the buffer from it's display object and given window 
	if (MilImage && MilDisplay)
	MdispDeselect(MilDisplay,MilImage);
	//Free the display
	if (MilDisplay) MdispFree(MilDisplay);
	MilDisplay=M_NULL;
}
//________________________________________
void CBkDoc::AcqPerm(void) 
{
	//MIL: Write code that will be executed on a grab start
	//Si on est en acquisition permanente dans une vue, arrt de cette acquisition
	if(m_pApp->GrabIsStarted)	m_pApp->GrabInViewPtr->SendMessage(WM_COMMAND,ID_ACQ_FIG,0);
	//Start a continuous grab in this view
	MdigGrabContinuous(m_pApp->MilDigitizer,MilImage);
	//A faire, sinon l'image n'apparat pas si Orion
	UpdateAllViews(NULL);
	//Update the variable GrabIsStarted
	m_pApp->GrabIsStarted=TRUE;	
	//GrabInViewPtr is now a pointer to this view
	m_pApp->GrabInViewPtr=m_pView;
}
*/
//Carte d'imagerie Orion__________________
/*
void CBkDoc::FigerAcq(void) 
{
	if (m_pApp->GrabIsStarted && m_pApp->m_OKCarte)
	{
		//MIL: Write code that will be executed on a grab stop 
		MdigHalt(m_pApp->MilDigitizer);	
		m_pApp->GrabIsStarted=FALSE;
		//Copie de l'image dans l'image Victor
		short 
			i,j,
			l,h,nbB;
		const long larg=m_pApp->SizeX;
		const long haut=m_pApp->SizeY;
		unsigned char *p,*p1,*p2;
		p=new unsigned char[haut*larg];
		p1=new unsigned char[haut*larg];
		p2=new unsigned char[haut*larg];
		unsigned char R,V,B;

		MbufGetColor2d(MilImage,M_SINGLE_BAND,M_RED,0,0,larg,haut,p);
		MbufGetColor2d(MilImage,M_SINGLE_BAND,M_GREEN,0,0,larg,haut,p1);
		MbufGetColor2d(MilImage,M_SINGLE_BAND,M_BLUE,0,0,larg,haut,p2);

		l=image->endx-image->stx+1;
		h=image->endy-image->sty+1;
		nbB=image->bmh->biBitCount;
		if (l!=m_pApp->SizeX || h!=m_pApp->SizeY || nbB!=24)
		{
			freeimage(image);
			allocimage(image,m_pApp->SizeX,m_pApp->SizeY,24);
			//Mmorisation caractristiques image
			m_iL=m_pApp->SizeX;
			m_iH=m_pApp->SizeY;
			m_iNbB=24;
		}
		//Mmorisation caractristiques image
		for (j=0;j<haut;j++)
		{
			for (i=0;i<larg;i++)
			{
				setpixelcolor(image,i,j,p[i+larg*j]+256*p1[i+larg*j]+256*256*p2[i+larg*j]);
			}
		}
		delete p;
		delete p1;
		delete p2;
		m_iType=0;
		DimensionnerFenetre(m_iL,m_iH);
		DefinirCurseurs(m_iL,m_iH);
		UpdateAllViews(NULL);	
	}	
}
*/
//Carte d'imagerie Meteor_________________
/*
void CBkDoc::FigerAcq(void) 
{
	if (m_pApp->GrabIsStarted && m_pApp->m_OKCarte)
	{
		//MIL: Write code that will be executed on a grab stop 
		MdigHalt(m_pApp->MilDigitizer);	
		m_pApp->GrabIsStarted=FALSE;
		//Copie de l'image dans l'image Victor
		short 
			l,h,nbB,
			i,j;
		const long larg=m_pApp->SizeX;
		const long haut=m_pApp->SizeY;
		unsigned char *p;
		p=new unsigned char[haut*larg];

		MbufGetColor2d(MilImage,M_SINGLE_BAND,M_RED,0,0,larg,haut,p);
		//ou:
		//MbufGetColor(MilImage,M_SINGLE_BAND,M_RED,p);
		//Affectation image victor
		l=image->endx-image->stx+1;
		h=image->endy-image->sty+1;
		nbB=image->bmh->biBitCount;
		if (l!=m_pApp->SizeX || h!=m_pApp->SizeY || nbB!=8)
		{
			freeimage(image);
			allocimage(image,m_pApp->SizeX,m_pApp->SizeY,8);
			//Mmorisation caractristiques image
			m_iL=m_pApp->SizeX;
			m_iH=m_pApp->SizeY;
			m_iNbB=8;
		}
		for (j=0;j<haut;j++)
		{
			for (i=0;i<larg;i++)
			{
				setpixelcolor(image,i,j,p[i+larg*j]);
			}
		}
		delete p;
		m_iType=0;
		DimensionnerFenetre(m_iL,m_iH);
		DefinirCurseurs(m_iL,m_iH);
		UpdateAllViews(NULL);	
	}
}
*/