// BkDoc.h : interface of the CBkDoc class
//
//////////////////////////////////////////
#include "Vicdefs.h"
class CBkDoc : public CDocument
{
protected: // create from serialization only
	CBkDoc();
	DECLARE_DYNCREATE(CBkDoc)

// Attributes
protected:
	class CBkApp* m_pApp;			//Pointeur sur l'application affect dans CBkView::OnInitialUpdate
public:
	class CBkView* m_pView;		//Pointeur sur la vue
	class CWnd* m_pWnd;				//Pointeur sur la fentre
	short 
		m_iL,m_iH,m_iNbB,m_iNo;	//Caractristiques de la fentre courante
	CString m_sNomFic;
	//Image_________________________________
	imgdes *image;													
	//Coordonnes souris____________________
	short	
		m_iX,m_iY,					//Absolues en pixel
		m_iDx,m_iDy,				//Relatives
		m_iXpos,m_iYpos;		//Barres de dfilement
	long
		m_iW,								//Luminance absolue
		m_iDw;							//Luminance relative
	//Attributions de l'image_______________
	short m_iType;
	//Profils_______________________________
	typedef struct
	{
		short
		radioRouge,					//0:R, 1:V, 2:B
		iX1,iY1,						//Position de trac du profil point 1 segment
		iX2,iY2;						//Position de trac du profil point 2 segment
		BOOL OK;
	}
	profil;
	profil m_p;
  //Donnes (profil,...)__________________
	short 
		m_iNbMax,				//Nb. maxi de donnes 
		m_iNb;					//Nb. effectif de donnes
	float (*m_fT)[6];	//Pointeur sur un tableau de float  6 colonnes

	//Description de la cotation____________
	typedef struct
	{
		short no;
		short x1[8],y1[8],x2[8],y2[8];	//Vecteurs de cotation
		CString s[8];										//Lgendes
	}
	cotation;
	cotation m_c;
	//Franges de moir______________________
	short m_iM;
	float m_fDeltaZ;
	//Echelles pour calirage________________
	float
		m_fEchXY,
		m_fEchZ,
		m_fFactXY,m_fFactZ;
	BOOL
		m_OKXY,m_OKZ;
	//Tracker_______________________________
	CRectTracker m_tracker;
	char m_radioTypeTracker;
// Operations
public:
	void EcritTitre(void);
	void DefinirCurseurs(short l,short h);
	void DimensionnerFenetre(short l,short h);
	void PositionnerFenetre(short l,short h);
	void LimiterTailleFenetre(short l,short h);
	void InitialiserImage(short l,short h,short nbB);
	void CalculProfils(short rouge,short X1,short Y1,short X2,short Y2);
	float sigma(float t[1024],unsigned int n);
	float val_cen(float t[1024],unsigned int n);
	float gauss(float p,float p0,float sigma);
	long composante(long w,short composante);
	short Saveim(CString s,imgdes *image);
	short Loadim(CString s,imgdes *image);
	void InitTracker(void);
	void AcqPerm(void); 
	void FigerAcq(void);
	//Carte d'imagerie Meteor_______________
	//Carte d'imagerie Orion________________
	/*
	long	BufferAttributes;	// Buffer attributes that will be allocated
	MIL_ID MilDisplay;			// Display identifier.
	MIL_ID MilImage;				//Image buffer identifier.
	void RemoveFromDisplay();
	*/

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBkDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//////////////////////////////////////////
