//Pilotage des platines motorises Polytec P.I. via carte C832
// C832.h : header file
/////////////////////////////////////////////////////////////////////////////
class CC832:public CWnd
{
// Construction
public:
	CC832(long Cte);

// Attributes
protected:                 
	long m_lCte;
	float m_fVit; 
	//Adresse carte 0 (Switch sur carte)
	#define IOADDRREG0 0x210                 //board-address
	#define IODATAREG0 0x211
	//Adresse carte 1
	#define IOADDRREG1 0x212                 //Adresses cartes
	#define IODATAREG1 0x213

	#define CONF_PARM  0x80                  //no board_interrupt, TTL-encoder
	#define RESET   0x00                     //LM628/629 Command Set
	#define PORT8   0x05
	#define PORT12  0x06
	#define DFH     0x02
	#define SIP     0x03
	#define LPEI    0x1b
	#define LPES    0x1a
	#define SBPA    0x20
	#define SBPR    0x21
	#define MSKI    0x1c
	#define RSTI    0x1d
	#define LFIL    0x1e
	#define UDF     0x04
	#define LTRJ    0x1f
	#define STT     0x01
	#define RDSIGS  0x0c
	#define RDIP    0x09
	#define RDDP    0x08
	#define RDRP    0x0a
	#define RDDV    0x07
	#define RDRV    0x0b
	#define RDSUM   0x0d
	#define RDSTAT  0xff        

	#define SET_DATA_ADR0   _outp(IOADDRREG0,CONF_PARM | channel+1)
	#define SET_DATA_ADR1   _outp(IOADDRREG1,CONF_PARM | channel+1)

	//Operations
	long drive628_0(BYTE channel, BYTE cmd, WORD ctrl_WORD, long parm);
	long drive628_1(BYTE channel, BYTE cmd, WORD ctrl_WORD, long parm);
	short get_WORD0();
	short get_WORD1();
	void put_WORD0(short data);
	void put_WORD1(short data);
	BOOL lm628_ready0(BYTE channel);
	BOOL lm628_ready1(BYTE channel);
	BOOL TEST_BUSY0(char channel);
	BOOL TEST_BUSY1(char channel);
	void init912_0(BYTE channel,long kp,long ki,long kd,long il,long acc,long vel);
	void init912_1(BYTE channel,long kp,long ki,long kd,long il,long acc,long vel);
	short parse_arg(short nargs,char *pargv[],char *pident,char *pfmt,void *pvalue);

public:
	char fin_course(char axe);
	BOOL   OK(BYTE channel);						//Test prsence carte C832 N1 ou N2
	void   AB(char axe);								//AborT
	char   BT(char axe);                //Test bute de fin de course
	void   DH(char axe);                //Define Home
	void   GH(char axe);                //Go Home
	void   IT(char axe);                //IniT
	void   MA(char axe,float x);        //Move Absolute
	void   MF(char axe);								//Motor oFf
	void   MN(char axe);								//Motor oN
	char   MD(char axe);								//Motor on Destination
	void   MR(char axe,float x);        //Move Relative
	void   RT(char axe);                //ReseT
	void   RI(char axe);                //Reset Interruptions
	void   SA(char axe,float a);        //Set Acceleration
	void   ST(char axe);                //STop
	void   SV(char axe,float v);        //Set Velocity
	char   TB(char axe);                //Tell Busy
	float  TP(char axe); 								//Tell Position (Axe=0 non permis)
	void   WS(char axe);                //Wait until Stop (Attente fin mvt et test butes)
	void   WS1(char axe);                //Wait until Stop (Attente fin mvt)


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CC832)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CC832();

	// Generated message map functions
protected:
	//{{AFX_MSG(CC832)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
