// CalcDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "CalcDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CCalcDlg dialog
CCalcDlg::CCalcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalcDlg)
	m_sS = _T("");
	m_radioType = -1;
	m_sE = _T("");
	m_sDeltaZ = _T("");
	m_sLambda = _T("");
	m_sM = _T("");
	//}}AFX_DATA_INIT
}
void CCalcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalcDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sS);
	DDX_Radio(pDX, IDC_RADIO, m_radioType);
	DDX_Text(pDX, IDC_STATIC_TEXTE2, m_sE);
	DDX_Text(pDX, IDC_DELTAZ, m_sDeltaZ);
	DDX_Text(pDX, IDC_LAMBDA, m_sLambda);
	DDX_Text(pDX, IDC_M, m_sM);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCalcDlg, CDialog)
	//{{AFX_MSG_MAP(CCalcDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CCalcDlg message handlers
BOOL CCalcDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_iNo=m_pDoc->m_iNo;

	m_radioType=0;
	m_sLambda="632.8";
	m_fLambda=632.8;
	m_fDeltaZ=m_pDoc->m_fDeltaZ;
	m_sDeltaZ.Format("%1.3f",m_fDeltaZ);
	m_iM=m_pDoc->m_iM;
	m_sM.Format("%d",m_iM);
	
	if (m_iM<0)
	{
		m_sS.Format("Image dmodule: ?");
		m_iM=0;
		m_sM="0";
	}
	else
	{
		m_sS.Format("Image dmodule: %d",m_iNo);
	}
	
	SetTimer(1,100,NULL);
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CCalcDlg::OnCancel() 
{
	KillTimer(1);
	CDialog::OnCancel();
}
//________________________________________
void CCalcDlg::OnOK() 
{
	KillTimer(1);
	if (m_radioType==1)
	{
		//Moir
		CString s;
		s.Format("DELTA_Z(mm)=%1.3f",m_fDeltaZ);
		//m_pDoc->m_pView->IncrustationChaine(m_pDoc->m_iL-s.GetLength()*8,m_pDoc->m_iH-22,s);
	}
	CDialog::OnOK();
}
//________________________________________
void CCalcDlg::OnTimer(UINT nIDEvent) 
{
	int i,j,k;

	UpdateData(TRUE);
	if (m_radioType==0)
	{
		//Speckle
		GetDlgItem(IDC_DELTAZ)->EnableWindow(FALSE);
		GetDlgItem(IDC_LAMBDA)->EnableWindow(TRUE);
	}
	else
	{
		//Moir
		GetDlgItem(IDC_DELTAZ)->EnableWindow(TRUE);
		GetDlgItem(IDC_LAMBDA)->EnableWindow(FALSE);
	}

	i=sscanf(m_sLambda,"%f",&m_fLambda);
	j=sscanf(m_sM,"%d",&m_iM);
	k=sscanf(m_sDeltaZ,"%f",&m_fDeltaZ);
	
	if (i==0 || j==0 || k==0 || m_iM<0 || m_fDeltaZ<0 || m_fLambda<0)
	{
		m_btnOK.EnableWindow(FALSE);
		m_sE.Format("EchZ= ?");
	}
	else
	{
		m_btnOK.EnableWindow(TRUE);
		if (m_radioType==0)
		{
			//Speckle
			m_fEchZ=(m_fLambda*(m_iM+1)/2e6)/256;
			m_pDoc->m_fEchZ=m_fEchZ;
			m_pDoc->m_iM=m_iM;
		}
		else
		{
			//Moir
			m_fEchZ=(m_fDeltaZ*(m_iM+1))/256;
			m_pDoc->m_fEchZ=m_fEchZ;
			m_pDoc->m_fDeltaZ=m_fDeltaZ;
			m_pDoc->m_iM=m_iM;
		}
		m_sE.Format("EchZ=%1.2e",m_fEchZ);
	}	
	UpdateData(FALSE);	
	CDialog::OnTimer(nIDEvent);
}
