// CoulDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "CoulDlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CCoulDlg dialog
CCoulDlg::CCoulDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCoulDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCoulDlg)
	m_iBleu = 0;
	m_iVert = 0;
	m_iRouge = 0;
	m_iHaut = 0;
	m_iEpais = 0;
	//}}AFX_DATA_INIT
}
void CCoulDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCoulDlg)
	DDX_Control(pDX, IDC_COMBO1, m_listeDeroul);
	DDX_Text(pDX, IDC_BLEU, m_iBleu);
	DDX_Text(pDX, IDC_VERT, m_iVert);
	DDX_Text(pDX, IDC_ROUGE, m_iRouge);
	DDX_Text(pDX, IDC_HAUT, m_iHaut);
	DDX_Text(pDX, IDC_EPAIS, m_iEpais);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCoulDlg, CDialog)
	//{{AFX_MSG_MAP(CCoulDlg)
	ON_BN_CLICKED(IDPERSO, OnPerso)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
///////////////////////////////////////////////////
// CCoulDlg message handlers
BOOL CCoulDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	long w;
	short i;
	for (i=0;i<7;i++)
	{
		m_iCouleur[i]=m_pApp->couleur[i];
	}

	m_iNo=0;
	w=m_iCouleur[m_iNo];

	m_iRouge=w&255;
	m_iVert=(w>>8)&255;
	m_iBleu=(w>>16)&255;

	m_iHaut=m_pApp->m_iHaut;
	m_iEpais=m_pApp->m_iEpais;

	m_listeDeroul.AddString("Contour marque de pointage");
	m_listeDeroul.AddString("Centre marque de pointage");
	m_listeDeroul.AddString("Segment profil et IMax/e");
	m_listeDeroul.AddString("Trac profil horizontal");
	m_listeDeroul.AddString("Trac profil vertical");
	m_listeDeroul.AddString("Cotations");
	m_listeDeroul.AddString("Annotations");

	i=m_listeDeroul.GetCount();
	CString s;
	if (i>=0)
	{
		m_listeDeroul.GetLBText(0,s);
		m_listeDeroul.SetWindowText(s);	
	}

	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CCoulDlg::OnOK() 
{
	short i;
	UpdateData(TRUE);
	if (m_iHaut<5) m_iHaut=5;
	if (m_iHaut>50) m_iHaut=50;
	if (m_iEpais<1) m_iEpais=1;
	if (m_iEpais>10) m_iEpais=10;
	m_pApp->m_iHaut=m_iHaut;
	m_pApp->m_iEpais=m_iEpais;
	
	m_pApp->EffacerOutils();
	for (i=0;i<7;i++)
	{
		m_pApp->couleur[i]=m_iCouleur[i];
	}
	m_pApp->DefinirOutils();
	m_pApp->GetDocument()->UpdateAllViews(NULL);
	CDialog::OnOK();
}
//________________________________________
void CCoulDlg::OnPerso() 
{
	short i;
	long w;
	CColorDialog d;
	i=d.DoModal();
	if (i!=IDCANCEL)
	{
		w=d.GetColor();
		m_iRouge=w&255;
		m_iVert=(w>>8)&255;
		m_iBleu=(w>>16)&255;
		m_iCouleur[m_iNo]=w;
		UpdateData(FALSE);
	}
}
//________________________________________
void CCoulDlg::OnSelchangeCombo1() 
{
	long w;
	UpdateData(TRUE);
	m_iNo=m_listeDeroul.GetCurSel();
	w=m_iCouleur[m_iNo];

	m_iRouge=w&255;
	m_iVert=(w>>8)&255;
	m_iBleu=(w>>16)&255;

	UpdateData(FALSE);
}
