// DepMaDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "DepRoDlg.h"
#include "C832.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CDepRoDlg dialog
CDepRoDlg::CDepRoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDepRoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDepRoDlg)
	m_sXpos = _T("");
	m_sVit = _T("");
	//}}AFX_DATA_INIT
}
void CDepRoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDepRoDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_sliderV);
	DDX_Control(pDX, IDC_VA, m_btnVa);
	DDX_Control(pDX, IDC_STOP, m_btnStop);
	DDX_Control(pDX, IDRESET, m_btnReset);
	DDX_Control(pDX, IDC_X_PLUS, m_btnXplus);
	DDX_Control(pDX, IDC_X_MOINS, m_btnXmoins);
	DDX_Control(pDX, IDC_GH, m_btnGH);
	DDX_Control(pDX, IDC_DH, m_btnDH);
	DDX_Text(pDX, IDC_X, m_sXpos);
	DDX_Text(pDX, IDC_STATIC_VIT, m_sVit);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CDepRoDlg, CDialog)
	//{{AFX_MSG_MAP(CDepRoDlg)
	ON_BN_CLICKED(IDC_DH, OnDh)
	ON_BN_CLICKED(IDC_GH, OnGh)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_VA, OnVa)
	ON_BN_CLICKED(IDC_X_MOINS, OnXMoins)
	ON_BN_CLICKED(IDC_X_PLUS, OnXPlus)
	ON_WM_TIMER()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDRESET, OnReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CDepRoDlg message handlers
void CDepRoDlg::OnOK() 
{
	//Bouton supprim
	//CDialog::OnOK();
}
//________________________________________
BOOL CDepRoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document courant
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;

	m_iTypeMvt=0;	//0:Moteur  l'arrt
	m_fVit=50;
	m_sVit.Format("(%3.0f)",m_fVit);
	m_sliderV.SetRange(10,360);
	m_sliderV.SetPos((short)(m_fVit));
	m_pC832=new CC832(29600);          
	if (!m_pC832->OK(2))
	{
		m_btnGH.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_sXpos="?";
	} 
	else
	{
		m_pC832->RT(2);
		m_pC832->IT(2);
		m_pC832->SV(2,m_fVit);
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnVa.EnableWindow(TRUE);      
		m_btnStop.EnableWindow(FALSE);
		m_sXpos.Format("%1.3f",1.0*m_pC832->TP(2));
  }
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CDepRoDlg::OnDh() 
{
	if (m_pC832->OK(2))
	{
		//Define Home
		m_pC832->DH(2);
		m_sXpos.Format("%1.3f",0);
		UpdateData(FALSE);
	}
}
//________________________________________
void CDepRoDlg::OnGh() 
{
	//Go Home                           
	if (m_pC832->OK(2))
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnGH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnStop.EnableWindow(TRUE);      
		m_pC832->SV(2,m_fVit);
		m_pC832->MA(2,0);
		UpdateData(FALSE);
		m_iTypeMvt=3;
		SetTimer(2,40,NULL);
  } 
}
//________________________________________
void CDepRoDlg::OnVa() 
{
	//Dplacement vers la position demande
	float x;
	int i;
	
	UpdateData(TRUE);
	i=sscanf(m_sXpos,"%f",&m_fx);
	if (m_pC832->OK(2) && i==1)
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnGH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnStop.EnableWindow(TRUE);      
		m_pC832->SV(2,m_fVit);
		m_pC832->MA(2,m_fx);
		UpdateData(FALSE);
		m_iTypeMvt=4;
		SetTimer(2,40,NULL);
	} 
}
//________________________________________
void CDepRoDlg::OnCancel() 
{
	if (m_iTypeMvt!=0)
	{
		m_pC832->ST(2);
	}
	KillTimer(2);
	UpdateData(TRUE);
	//m_pDoc->m_fVit=m_fVit;
	delete m_pC832;	
	CDialog::OnCancel();
}
//________________________________________
void CDepRoDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_fVit=m_sliderV.GetPos();
	m_sVit.Format("(%3.0f)",m_fVit);
	if (m_iTypeMvt!=0)
	{
		m_pC832->ST(2);
		m_pC832->SV(2,m_fVit);
		if (m_iTypeMvt==1)
		{
			m_pC832->MR(2,3600.0);
		}
		else
		if (m_iTypeMvt==2)
		{
			m_pC832->MR(2,-3600.0);
		}
		else
		if (m_iTypeMvt==3)
		{
			m_pC832->MA(2,0);
		}
		if (m_iTypeMvt==4)
		{
			m_pC832->MA(2,m_fx);
		}
	}
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//__________________________________________________
void CDepRoDlg::OnReset() 
{
	//Appui sur le bouton Reset
	m_pC832->RT(2);
	m_pC832->IT(2);
	m_btnGH.EnableWindow(TRUE);
	m_btnDH.EnableWindow(TRUE);
	m_btnXplus.EnableWindow(TRUE);
	m_btnXmoins.EnableWindow(TRUE);
	m_btnVa.EnableWindow(TRUE);      
	m_btnStop.EnableWindow(FALSE);
	m_sXpos.Format("%1.3f",m_pC832->TP(2));
	UpdateData(FALSE);
}
//__________________________________________________
void CDepRoDlg::OnXMoins() 
{
	if (m_pC832->OK(2))
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnGH.EnableWindow(FALSE);
		m_btnStop.EnableWindow(TRUE);      
		m_pC832->SV(2,m_fVit);
		m_pC832->MR(2,-3600.0);
		m_iTypeMvt=2;
		SetTimer(2,40,NULL);
	} 
}
//__________________________________________________
void CDepRoDlg::OnXPlus() 
{
	if (m_pC832->OK(2))
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnGH.EnableWindow(FALSE);
		m_btnStop.EnableWindow(TRUE);      
		m_pC832->SV(2,m_fVit);
		m_pC832->MR(2,3600.0);
		m_iTypeMvt=1;
		SetTimer(2,40,NULL);
	} 
}
//__________________________________________________
void CDepRoDlg::OnStop() 
{
	//Clic sur le bouton Stop
	KillTimer(2);
	if (m_iTypeMvt!=0)
	{
		m_pC832->ST(2);
		m_pC832->WS(2);
		m_sXpos.Format("%1.3f",m_pC832->TP(2));
		m_pC832->RI(2);
		m_btnStop.EnableWindow(FALSE);      
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnDH.EnableWindow(TRUE);
		m_btnGH.EnableWindow(TRUE);
		m_btnVa.EnableWindow(TRUE);      
		UpdateData(FALSE);
	}
	m_iTypeMvt=0;
}
//__________________________________________________
void CDepRoDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	if (m_iTypeMvt!=0)
	{                                   
		if (m_pC832->BT(2))
		{
			KillTimer(2);
			m_btnStop.EnableWindow(FALSE);      
			s.Format("Surcourse axe 1 dtecte !");
			AfxMessageBox(s);
		}	                    
		else 
		{ 
			m_sXpos.Format("%1.3f",m_pC832->TP(2));
			UpdateData(FALSE);
		}
		//Moteur arriv  destination
		if (m_pC832->MD(2)) 
		{
			KillTimer(2);
			m_btnStop.EnableWindow(FALSE);      
			m_btnGH.EnableWindow(TRUE);
			m_btnDH.EnableWindow(TRUE);
			m_btnXplus.EnableWindow(TRUE);
			m_btnXmoins.EnableWindow(TRUE);
			m_btnVa.EnableWindow(TRUE);      
		}
	}
	CDialog::OnTimer(nIDEvent);
}
