// Fft.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Fft.h"
#include "ProgrDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
///////////////////////////////////////////////////
// CFft
CFft::CFft()
{
	Pi=4*atan(1);
	//Boite de dialogue progression__________________
	m_pProg=new CProgrDlg();
}
CFft::~CFft()
{
	m_pProg->DestroyWindow();
	delete m_pProg;
}
BEGIN_MESSAGE_MAP(CFft, CWnd)
	//{{AFX_MSG_MAP(CFft)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
///////////////////////////////////////////////////
// CFft message handlers
//_________________________________________________
short CFft::_ISNextPowerOfTwo(short i)
{
	short n=1;
	while (n<i)
	{
		n=n*2;
	}

	return n;
}
//_________________________________________________
float **CFft::allocate2D(unsigned int h,unsigned int l)
{
	unsigned int i;
	float **matrice;
	matrice=new float*[h];
	if (matrice==NULL) 
		AfxMessageBox("Manque de mmoire");
	else
	{
		for(i=0;i<h;i++)
		{
			matrice[i]=new float[l];
			if (matrice[i]==NULL)
			{
				AfxMessageBox("Manque de mmoire");
				i=l;
			}
		}
	}
	return matrice;
}
//_________________________________________________
float *CFft::allocate1D(unsigned int l)
{
	float *vecteur;
	vecteur=new float[l];
	return vecteur;
}
//_________________________________________________
void CFft::free1D(float * vecteur)
{
	delete vecteur;
}
//_________________________________________________
void CFft::free2D(float ** matrice,unsigned int h)
{
	short i;
	for (i=0;i<h;i++)
	{
		delete matrice[i];
	}
	delete matrice;
}
//_________________________________________________
void CFft::fft(float* x_int_re, float* x_int_im, unsigned int taille) 
{
	unsigned int size_2=taille>>1,tmp1,i;
	float tmp,tmpcos,tmpsin,base=2*Pi/taille;
	const float SQ_2=sqrt(2);
	float *pair_re=allocate1D(size_2);
	float *pair_im=allocate1D(size_2);
	float *impair_re=allocate1D(size_2);
	float *impair_im=allocate1D(size_2);
	for(i=0;i<size_2;i++)
	{
		tmp1=(i<<1);
		pair_re[i]=x_int_re[tmp1];
		pair_im[i]=x_int_im[tmp1];
		impair_re[i]=x_int_re[tmp1+1];
		impair_im[i]=x_int_im[tmp1+1];
	}
	if(taille>2)
	{
		fft(pair_re,pair_im,size_2);
		fft(impair_re,impair_im,size_2);
	}
	for(i=0;i<size_2;i++)
	{
		tmp=base*i;
		tmpcos=cos(tmp);
		tmpsin=sin(tmp);
		x_int_re[i]=(pair_re[i]+impair_re[i]*tmpcos+impair_im[i]*tmpsin)/SQ_2;
		x_int_im[i]=(pair_im[i]+impair_im[i]*tmpcos-impair_re[i]*tmpsin)/SQ_2;
		x_int_re[i+size_2]=(pair_re[i]-impair_re[i]*tmpcos-impair_im[i]*tmpsin)/SQ_2;
		x_int_im[i+size_2]=(pair_im[i]-impair_im[i]*tmpcos+impair_re[i]*tmpsin)/SQ_2;
	}
	//free(pair_re);
	//free(pair_im);
	//free(impair_re);
	//free(impair_im);
	free1D(pair_re);
	free1D(pair_im);
	free1D(impair_re);
	free1D(impair_im);
}

void CFft::fft_inv(float* x_int_re, float* x_int_im, unsigned int taille)
{
	unsigned int size_2=taille>>1,tmp1,i;	
	float tmp,tmpcos,tmpsin,base=2*Pi/taille;
	const float SQ_2=sqrt(2);
	float *pair_re=allocate1D(size_2);
	float *pair_im=allocate1D(size_2);
	float *impair_re=allocate1D(size_2);
	float *impair_im=allocate1D(size_2);
	for(i=0;i<size_2;i++)
	{
		tmp1=i<<1;
		pair_re[i]=x_int_re[tmp1];
		pair_im[i]=x_int_im[tmp1];
		impair_re[i]=x_int_re[tmp1+1];
		impair_im[i]=x_int_im[tmp1+1];
	}
	if(taille>2)
	{
		fft_inv(pair_re, pair_im,size_2);
		fft_inv(impair_re, impair_im,size_2);
	}
	for(i=0;i<size_2;i++)
	{
		tmp=base*i;
		tmpcos=cos(tmp);
		tmpsin=sin(tmp);
		x_int_re[i]=(pair_re[i]+impair_re[i]*tmpcos-impair_im[i]*tmpsin)/SQ_2;
		x_int_im[i]=(pair_im[i]+impair_im[i]*tmpcos+impair_re[i]*tmpsin)/SQ_2;
		x_int_re[i+size_2]=(pair_re[i]-impair_re[i]*tmpcos+impair_im[i]*tmpsin)/SQ_2;
		x_int_im[i+size_2]=(pair_im[i]-impair_im[i]*tmpcos-impair_re[i]*tmpsin)/SQ_2;
	}
	/*
	free(pair_re);
	free(pair_im);
	free(impair_re);
	free(impair_im);
	*/
	free1D(pair_re);
	free1D(pair_im);
	free1D(impair_re);
	free1D(impair_im);
}

void CFft::tfd2d(float **x, float **xtre, float **xtim,unsigned int width, unsigned int height)
{
	unsigned int i,j,k;
	const float SQ_WIDTH=sqrt(width),SQ_HEIGHT=sqrt(height);
	float tmp,tmpcos,tmpsin,v_re=0,v_im=0,base1=2*Pi/width,base2=2*Pi/height;
	float **xint_im=allocate2D(height,width);
	float **xint_re=allocate2D(height,width);
	for(i=0;i<height;i++)
	{
		for(k=0;k<width;k++)
		{
			for(j=0;j<width;j++)
			{
				tmp=base1*k*j;
				v_re+=x[i][j]*cos(tmp);
				v_im-=x[i][j]*sin(tmp);
			}
			xint_im[i][k]=v_im/SQ_WIDTH;
			xint_re[i][k]=v_re/SQ_WIDTH;
			v_re=0;
			v_im=0;
		}
	}
	for(j=0;j<width;j++)
	{
		for(k=0;k<height;k++)
		{
			for(i=0;i<height;i++)
			{
				tmp=base2*k*i;
				tmpcos=cos(tmp);
				tmpsin=sin(tmp);
				v_re+=xint_re[i][j]*tmpcos+xint_im[i][j]*tmpsin;
				v_im+=xint_im[i][j]*tmpcos-xint_re[i][j]*tmpsin;
			}
			xtre[(k+(height>>1))%height][(j+(width>>1))%width]=v_re/SQ_HEIGHT;
			xtim[(k+(height>>1))%height][(j+(width>>1))%width]=v_im/SQ_HEIGHT;
			v_re=0;
			v_im=0;
		}
	}
	/*
	free(xint_re);
	free(xint_im);
	*/
	free2D(xint_re,height);
	free2D(xint_im,height);
}

void CFft::tfd2d_inv(float **xtre, float **xtim, float **xrec_re, float **xrec_im,unsigned int width,unsigned int height)
{
	unsigned int  i,j,k ;
	float tmp,tmpcos,tmpsin,u_re=0,u_im=0,base1=2*Pi/width,base2=2*Pi/height;
	const float SQ_WIDTH=sqrt(width);
	const float SQ_HEIGHT=sqrt(height);
	float **xint_re=allocate2D(height,width);
	float **xint_im=allocate2D(height,width);
	for(i=0;i<height;i++)
	{
		for(k=0;k<width;k++)
		{
			for(j=0;j<width;j++)
			{
				tmp=base1*k*j;
				tmpcos=cos(tmp);
				tmpsin=sin(tmp);
				u_re+=xtre[(i+(height>>1))%height][(j+(width>>1))%width] * tmpcos- xtim[(i+(height>>1))%height][(j+(width>>1))%width] * tmpsin;
				u_im+=xtim[(i+(height>>1))%height][(j+(width>>1))%width] * tmpcos+ xtre[(i+(height>>1))%height][(j+(width>>1))%width] * tmpsin;
			}
			xint_re[i][k]=u_re/SQ_WIDTH;
			xint_im[i][k]=u_im/SQ_WIDTH;

			u_re=0;
			u_im=0;
		}
	}
	for(j=0;j<width;j++)
	{			
		for(k=0;k<height;k++)
		{
			for(i=0;i<height;i++)
			{
				tmp=base2*k*i;
				tmpcos=cos(tmp);
				tmpsin=sin(tmp);
				u_re+=xint_re[i][j] *tmpcos - xint_im[i][j] * tmpsin;
				u_im+=xint_im[i][j] *tmpcos + xint_re[i][j] * tmpsin;
			}
			xrec_re[k][j]=u_re/SQ_HEIGHT;
			xrec_im[k][j]=u_im/SQ_HEIGHT;
			u_re=0;
			u_im=0;
		}
	}
	/*
	free(xint_re);
	free(xint_im);
	*/
	free2D(xint_re,height);
	free2D(xint_im,height);
}

void CFft::fft2d(float **x, float **xtre, float **xtim, unsigned int width, unsigned int height)
{
	unsigned int i,j,k ;

	//Indicateur de progression, initialisation
	m_pProg->m_progress.SetRange(0,height+width);
	
	float **xint_re=allocate2D(height,width) ;
	float **xint_im=allocate2D(height,width) ;
	float *x_int_l=allocate1D(width);
	float *x_int2_l=allocate1D(width);
	float *x_int_c=allocate1D(height);
	float *x_int2_c=allocate1D(height);
	for(k=0;k<height;k++)
	{
		//Indicateur de progression
		m_pProg->m_progress.SetPos(k);
		
		for(j=0;j<width;j++)
		{
			x_int_l[j]=x[k][j];	
			x_int2_l[j]=0;
		}
		fft(x_int_l, x_int2_l, width) ;
		for(j=0;j<width;j++)
		{
			xint_re[k][j]=x_int_l[j];
			xint_im[k][j]=x_int2_l[j];
		}
	}
	for(k=0;k<width;k++)
	{
		//Indicateur de progression
		m_pProg->m_progress.SetPos(k+height);
		for(i=0;i<height;i++)
		{
			x_int_c[i]=xint_re[i][k];
			x_int2_c[i]=xint_im[i][k];
		}
		fft(x_int_c,x_int2_c, height) ;
		for(i=0;i<height;i++)
		{
			xtre[(i+(height>>1))%height][(k+(width>>1))%width]=x_int_c[i];
			xtim[(i+(height>>1))%height][(k+(width>>1))%width]=x_int2_c[i];
		}
	}
	/*
	free(xint_re);
	free(xint_im);
	free(x_int_l);
	free(x_int2_l);
	free(x_int_c);
	free(x_int2_c);
	*/
	free2D(xint_re,height);
	free2D(xint_im,height);
	free1D(x_int_l);
	free1D(x_int2_l);
	free1D(x_int_c);
	free1D(x_int2_c);
}

void CFft::fft2d_inv(float **xtre,float **xtim,float **xrec_re,float **xrec_im,unsigned int width,unsigned int height)
{
	unsigned int i,j,k;
	float **xint_re=allocate2D(height,width);
	float **xint_im=allocate2D(height,width);
	float *x_int_l=allocate1D(width);
	float *x_int2_l=allocate1D(width);
	float *x_int_c=allocate1D(height);
	float *x_int2_c=allocate1D(height);
	for(k=0;k<height;k++)
	{
		for(j=0;j<width;j++)
		{
			x_int_l[j]=xtre[(k-(height>>1))%height][(j+(width>>1))%width];	
			x_int2_l[j]=xtim[(k-(height>>1))%height][(j+(width>>1))%width] ;
		}
		fft_inv(x_int_l, x_int2_l, width) ;
		for(j=0;j<width;j++)
		{
			xint_re[k][j]=x_int_l[j];
			xint_im[k][j]=x_int2_l[j];
		}
	}
	for(k=0;k<width;k++)
	{
		for(i=0;i<height;i++)
		{
			x_int_c[i]=xint_re[i][k];
			x_int2_c[i]=xint_im[i][k];
		}
		fft_inv(x_int_c,x_int2_c, height) ;
		for(i=0;i<height;i++)
		{
			xrec_re[i][k]=x_int_c[i];
			xrec_im[i][k]=x_int2_c[i];
		}
	}
	/*
	free(xint_re);
	free(xint_im);
	free(x_int_l);
	free(x_int2_l);
	free(x_int_c);
	free(x_int2_c);
	*/
	free2D(xint_re,height);
	free2D(xint_im,height);
	free1D(x_int_l);
	free1D(x_int2_l);
	free1D(x_int_c);
	free1D(x_int2_c);
}
