// FftDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "FftDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include "fft.h"
#include "vicdefs.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CFftDlg dialog
CFftDlg::CFftDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFftDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFftDlg)
	m_s = _T("");
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
void CFftDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFftDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_STATIC_TEXTE1, m_s1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CFftDlg, CDialog)
	//{{AFX_MSG_MAP(CFftDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CFftDlg message handlers
BOOL CFftDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	m_pDoc=m_pApp->GetDocument();
	m_iNo=m_pDoc->m_iNo;	
	m_iI=new short[m_pApp->m_iNbMax];
	//Initialisation tableau N images
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		m_iI[i]=-1;
	}                 
	j=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)!=NULL && i!=m_iNo)
		{
			s.Format("Image %d",i);	
			m_comboDest.AddString(s);
			m_iI[j]=i;
			j++;
		}         
	}
	//Recherche N nouvelle image destination
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)==NULL)
		{
			s.Format("IMAGE %d",i);	
			m_comboDest.AddString(s);
			//Image destination
			m_iI[j]=i;
			//On sort
			i=m_pApp->m_iNbMax;    
		}
	}
	//Par dfaut sur nouvelle image
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	m_s.Format("Image source: %d",m_iNo);
	m_s1="Attention, ce calcul peut prendre 30 s...";
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CFftDlg::OnCancel() 
{

	delete m_iI;
	CDialog::OnCancel();
}
//________________________________________
void CFftDlg::OnOK() 
{
	short 
		i,l,h,nbB,l1,h1,nbB1,ld,hd,
		lt,ht,nbBt,
		no;
	float r;
	long w;
	float 
		**tfre,**tfim,**pix;
	class CBkDoc* pd;
	class CFft *pFft=new CFft();;

	m_btnCancel.EnableWindow(FALSE);
	m_btnOK.EnableWindow(FALSE);
	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	//Image destination
	//Si l'utilisateur n'a pas touch au combo...
	if (m_comboDest.GetCurSel()<0) 
		no=m_iI[m_comboDest.GetCount()-1];
	else
		no=m_iI[m_comboDest.GetCurSel()];
	//Si la fentre destination n'existe pas, il faut la crer...
	if (m_pApp->GetDocument(no)==NULL)
	{
		//L'image destination existe maintenant.
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		pd=m_pApp->m_pDocument[no];
	}
	else
	{
		//Pointeur sur destination
		pd=m_pApp->m_pDocument[no];
	}
	//ld=m_pApp->image[m_iNo]->endx-m_pApp->image[m_iNo]->stx+1;
	//ou
	ld=m_pDoc->image->endx-m_pDoc->image->stx+1;
	hd=m_pApp->image[m_iNo]->endy-m_pApp->image[m_iNo]->sty+1;
	nbB=m_pApp->image[m_iNo]->bmh->biBitCount;

	//On ramne l'image  une taille infrieure  512x512 pour gagner du temps
	if (ld>511 || hd>511)
	{
		do
		{
			ld=(short)(1.0*ld*0.95);
			hd=(short)(1.0*hd*0.95);
		}
		while (ld>511 || hd>511);
	}

	//Pour faire fft puissance de 2 immdiatement sup
	//ld,hd:taille image originale
	//l,h: taille image originale puissance de 2
	l=pFft->_ISNextPowerOfTwo(ld);
	h=pFft->_ISNextPowerOfTwo(hd);

	//On met l'image rduite dans l'image temporaire n0
	lt=m_pApp->imt[0]->endx-m_pApp->imt[0]->stx+1;
	ht=m_pApp->imt[0]->endy-m_pApp->imt[0]->sty+1;
	nbBt=m_pApp->imt[0]->bmh->biBitCount;

	if (lt!=l || ht!=h || nbBt!=nbB)
	{
		freeimage(m_pApp->imt[0]);
		allocimage(m_pApp->imt[0],l,h,nbB);
	}
	resize(m_pDoc->image,m_pApp->imt[0]);

	m_s1.Format("Image FFT de %dx%d pixels.\nCalcul en cours...",l,h);
	UpdateData(FALSE);
	
	//Image destination
	l1=pd->image->endx-pd->image->stx+1;
	h1=pd->image->endy-pd->image->sty+1;
	nbB1=pd->image->bmh->biBitCount;
	if (l!=l1 || h!=h1 || nbB1!=8)
	{
		freeimage(pd->image);
		allocimage(pd->image,l,h,8);
		//Dimensionner l'image destination  la taille source
		pd->m_iH=h;
		pd->m_iL=l;
		pd->m_iNbB=8;
	}

	//Calcul de la FFT
	//Allocation mmoire
	//ATTENTION: les tableaux sont dclars en ligne(h->hauteur)-colonnes(l->largeur)
	tfre=pFft->allocate2D(h,l);
	tfim=pFft->allocate2D(h,l);
	pix=pFft->allocate2D(h,l);
	//Initialisation du tableau pix
	for( h1=0;h1<h;h1++)
	{
		for( l1=0;l1<l;l1++)
		{	
			pix[h1][l1]=0;
		}
	}
	//Affectation du tableau pix avec la luminance
	for( h1=0;h1<hd;h1++)
	{
		for( l1=0;l1<ld;l1++)
		{	
			w=getpixelcolor(m_pApp->imt[0],l1,h1);
			pix[h1][l1]=w&255;//8 bits de poids faible uniquement
		}
	}
	//On doit pouvoir y aller
	pFft->fft2d(pix,tfre,tfim,l,h);
	float maxi=-1e10,mini=1e10;
	for( h1=0;h1<h;h1++)
	{
		for( l1=0;l1<l;l1++)
		{
			//Module
			pix[h1][l1]=pow((tfre[h1][l1]*tfre[h1][l1]+tfim[h1][l1]*tfim[h1][l1]),0.5);
			if (fabs(l1-l/2)<1 || fabs(h1-h/2)<1)
			{
				//On exclut les lignes centrales du calcul maxi/mini
			}
			else
			/*
			if ((fabs(l1-l/2)<5 && fabs(h1-h/2)<5))
			{
				//On exclut aussi le centre...
			}
			else
			*/
			{
				if (pix[h1][l1]<mini)
				{
					mini=pix[h1][l1];
				}
				if (pix[h1][l1]>maxi) 
					maxi=pix[h1][l1];
			}
		}
	}
	//CString z;
	//z.Format("Maxi:%f, mini:%f",maxi,mini);
	//AfxMessageBox(z);
	
	//Etendre la luminance dans l'intervalle [0, 255]
	for( h1=0;h1<h;h1++)
	{
		for( l1=0;l1<l;l1++)
		{
			r=255.0*(pix[h1][l1]-mini)/(maxi-mini);
			if (pix[h1][l1]<=maxi && pix[h1][l1]>=mini)
				w=long(r);
			else
				w=255;
			setpixelcolor(pd->image,l1,h1,w);
		}
	}
	//Libration mmoire
	pFft->free2D(tfre,h);
	pFft->free2D(tfim,h);
	pFft->free2D(pix,h);

	//Appliquer le carr...
	for( h1=0;h1<h;h1++)
	{
		for( l1=0;l1<l;l1++)
		{
			w=getpixelcolor(pd->image,l1,h1);
			w=(long)(w*w);
			if (w>255) w=255;
			setpixelcolor(pd->image,l1,h1,w);
		}
	}
	
	//Mettre l'image pd au-dessus
	pd->PositionnerFenetre(20,20);
	pd->DimensionnerFenetre(l,h);
	pd->DefinirCurseurs(l,h);

	pd->m_iType=0;
	pd->m_sNomFic.Format("Fft2D");
	pd->UpdateAllViews(NULL);
	delete m_iI;
	delete pFft;
	m_btnCancel.EnableWindow(TRUE);
	m_btnOK.EnableWindow(TRUE);
	GetDlgItem(IDC_DEST)->EnableWindow(TRUE);
	CDialog::OnOK();
}
//________________________________________
