// GeoAna.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "GeoAna.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//__________________________________________________
CGeoAna::CGeoAna()
{                       
	PI=4.0*atan(1);
}
//__________________________________________________
//Point intersection de 2 droites
void CGeoAna::p2d(float xd1,float yd1,float a1,float xd2,float yd2,float a2,float *p_x,float *p_y)
{
	float
		b1,b2,
		a11,a21;

	a11=cos(a1);a21=cos(a2);
	if ((fabs(a11)<1e-5)&&(fabs(a21)>1e-5))
	{
		//Droite 1 verticale
		b2=yd2-tan(a2)*xd2;
		*p_x=xd1;*p_y=tan(a2)*(*p_x)+b2;
	}
	else
	if ((fabs(a21)<1e-5)&&(fabs(a11)>1e-5))
	{
		//Droite 2 verticale
		b1=yd1-tan(a1)*xd1;
		*p_x=xd2;*p_y=tan(a1)*(*p_x)+b1;
	}
	else
	if (fabs(a11-a21)<1e-8)
	{
		//Droites parallles
		*p_x=1e10;*p_y=1e10;
	}
	else
	{
		b1=yd1-tan(a1)*xd1;
		b2=yd2-tan(a2)*xd2;
		*p_x=(b2-b1)/(tan(a1)-tan(a2));
		*p_y=tan(a1)*(*p_x)+b1;
	}
}
//_________________________________________________
//Droite //  une droite
void CGeoAna::dpa(float xd,float yd,float a,float d,char dghb,float *xd1,float *yd1)
{
	dghb=toupper(dghb);
	d=fabs(d);
	*xd1=1e10;*yd1=1e10;
	while (a>2*PI || a<-2*PI)
	{
		if (a>2*PI) a=a-2*PI;
		if (a<-2*PI) a=a+2*PI;
	}
	while (a<-PI/2 || a>PI/2)
	{
		if (a<-PI/2) a=a+PI;
		if (a>PI/2)  a=a-PI;
	}
	if (fabs(a)<PI/4)
	{
		//Dcalage suivant y
		*xd1=xd;
		if (a>0)
		{
			if (dghb=='H' || dghb=='G')  *yd1=yd+d/cos(a);
			else
			if (dghb=='D' || dghb=='B')  *yd1=yd-d/cos(a);
			else
			{
				*xd1=1e10;*yd1=1e10;
			}
		}
		else
		{
			if (dghb=='H' || dghb=='D')  *yd1=yd+d/cos(a);
			else
			if (dghb=='G' || dghb=='B')  *yd1=yd-d/cos(a);
			else
			{
				*xd1=1e10;*yd1=1e10;
			}
		}
	}
	else
	{
		//Dcalage suivant x
		*yd1=yd;
		if (a>0)
		{
			if (dghb=='H' || dghb=='G') *xd1=xd-d/sin(a);
			else
			if (dghb=='D' || dghb=='B') *xd1=xd+d/sin(a);
			else
			{
				*xd1=1e10;*yd1=1e10;
			}
		}
		else
		{
			if (dghb=='H' || dghb=='D') *xd1=xd-d/sin(a);
			else
			if (dghb=='G' || dghb=='B') *xd1=xd+d/sin(a);
			else
			{
				*xd1=1e10;*yd1=1e10;
			}
		}
	}
}
//_________________________________________________
//Droite passant par 2 points
void CGeoAna::d2p(float xp1,float yp1,float xp2,float yp2,float *p_a,float *p_b)
{
	if ((fabs(xp2-xp1)<1e-6)&&(fabs(yp2-yp1)<1e-6))
	{
		*p_a=1e10;*p_b=1e10;
	}
	else
	if (fabs(xp2-xp1)<1e-6)
	{
		*p_b=1e10;
		if (yp2>yp1) *p_a=PI/2; else *p_a=-PI/2;
	}
	else
	{
		*p_a=(yp2-yp1)/(xp2-xp1);*p_b=yp1-(*p_a)*xp1;
		*p_a=atan(*p_a);
	}
}
//_________________________________________________
//Rsolution d'une quation du second degr
void CGeoAna::degre2(float a,float b,float c,float *p_x1,float *p_x2)
{
	 float delta;
	delta=pow(b,2)-4*a*c;
	if (delta<-1e-5)
	{
		*p_x1=1e10;*p_x2=1e10;
	}
	else
	if (fabs(delta)<1e-5)
	{
		*p_x1=-b/(2*a);
		*p_x2=*p_x1;
	}
	else
	{
		*p_x1=(-b-sqrt(delta))/(2*a);
		*p_x2=(-b+sqrt(delta))/(2*a);
	}
}
//_________________________________________________
//Point intersection d'une droite et d'un cercle
void CGeoAna::pdc(float xd,float yd,float a,float xc,float yc,float r,char dghb, float *p_xp,float *p_yp)
{
	float
		a1,b1,c1,
		x1,x2,y1,y2,
		k,b;

	a1=cos(a);
	if (fabs(a1)<1e-6)
	{
		//Droite verticale
		k=pow(r,2)-pow(xd-xc,2);
		if (k<0)
		{
			//Pas de solutions
			x1=1e10;x2=1e10;*p_xp=1e10;*p_yp=1e10;
		}
		else
		{
			y1=-sqrt(k)+yc;y2=sqrt(k)+yc;
			x1=xd;x2=xd;
		}
	}
	else
	{
		a=tan(a);
		b=yd-a*xd;
		a1=1+pow(a,2);
		b1=2*a*b-2*xc-2*a*yc;
		c1=pow(xc,2)+pow(yc,2)+pow(b,2)-pow(r,2)-2*b*yc;
		degre2(a1,b1,c1,&x1,&x2);
		if (x1!=1e10)
		{
			y1=a*x1+b;y2=a*x2+b;
		}
	}
	//Choix de la solution
	if (x1!=1e10)
	{
		dghb=toupper(dghb);
		if ((x1==x2)&&(y1==y2))
		{
			*p_xp=x1;*p_yp=y1;
		}
		else
		if (dghb=='B')
		{
			if (y1<y2)
			{
				*p_xp=x1;*p_yp=y1;
			}
			else
			if (y2<y1)
			{
				*p_xp=x2;*p_yp=y2;
			}
			else
			{
				*p_xp=1e10;*p_yp=1e10;
			}
		}
		else
		if (dghb=='G')
		{
			if (x1<x2)
			{
				*p_xp=x1;*p_yp=y1;
			}
			else
			if (x2<x1)
			{
				*p_xp=x2;*p_yp=y2;
			}
			else
			{
				*p_xp=1e10;*p_yp=1e10;
			}
		}
		else
		if (dghb=='H')
		{
			if (y1<y2)
			{
				*p_xp=x2;*p_yp=y2;
			}
			else
			if (y2<y1)
			{
				*p_xp=x1;*p_yp=y1;
			}
			else
			{
				*p_xp=1e10;*p_yp=1e10;
			}
		}
		else
		if (dghb=='D')
		{
			if (x1<x2)
			{
				*p_xp=x2;*p_yp=y2;
			}
			else
			if (x2<x1)
			{
				*p_xp=x1;*p_yp=y1;
			}
			else
			{
				*p_xp=1e10;*p_yp=1e10;
			}
		}
		else
		{
			*p_xp=1e10;*p_yp=1e10;
		}
	}
	else
	{
		*p_xp=1e10;*p_yp=1e10;
	}
}
//_________________________________________________
//Cercle passant par 3 points
void CGeoAna::c3p(float xp1,float yp1,float xp2,float yp2,float xp3,float yp3,float *p_xc,float *p_yc,float *p_r)
{
	float
		a,a1,b,b1,
		xh,yh,xk,yk;
	//Calcul coordonnes de K, milieu de P1P2
	xk=(xp2+xp1)/2;yk=(yp2+yp1)/2;
	d2p(xp1,yp1,xp2,yp2,&a,&b);
	if (a==1e10)
	{
		*p_xc=1e10;*p_yc=1e10;*p_r=1e10;
	}
	else
	{
		a=a+PI/2;
		//Calcul coordonnes de H, milieu de P1P3
		xh=(xp3+xp1)/2;yh=(yp3+yp1)/2;
		d2p(xp1,yp1,xp3,yp3,&a1,&b1);
		if (a1==1e10)
		{
			*p_xc=1e10;*p_yc=1e10;*p_r=1e10;
		}
		else
		{
			a1=a1+PI/2;
			p2d(xk,yk,a,xh,yh,a1,p_xc,p_yc);
			if (*p_xc==1e10)
				*p_r=1e10;
			else
				*p_r=sqrt(pow(xp1-(*p_xc),2)+pow(yp1-(*p_yc),2));
		}
	}
}
//_________________________________________________
void CGeoAna::p2c(float xc1,float yc1,float r1,float xc2,float yc2,float r2,char dghb,float *xi,float *yi)
{
	float
		beta,b,
		d,
		x,y,
		x1,y1,x2,y2;

	//Ramener le premier cercle sur l'origine du repre pour simplification
	xc2=xc2-xc1;yc2=yc2-yc1;
	d=sqrt(xc2*xc2+yc2*yc2);
	if ((d-r1-r2>1e-6) || (d+r2-r1<-1e-6) || (d+r1-r2<-1e-6))
	{
		x1=1e10;
	}
	else
	{
		x=(r1*r1-r2*r2+d*d)/(2*d);
		y=sqrt(r1*r1-x*x);
		d2p(0,0,xc2,yc2,&beta,&b);
		if (xc2<0) beta=beta+PI;
		x1=xc1+x*cos(beta)-y*sin(beta);
		y1=yc1+x*sin(beta)+y*cos(beta);
		x2=xc1+x*cos(beta)+y*sin(beta);
		y2=yc1+x*sin(beta)-y*cos(beta);
	}
	//Choix de la solution
	if (x1!=1e10)
	{
		dghb=toupper(dghb);
		if ((x1==x2) && (y1==y2))
		{
			*xi=x1;*yi=y1;
		}
		else
		if (dghb=='B')
		{
			if (y1<y2)
			{
				*xi=x1;*yi=y1;
			}
			else
			if (y2<y1)
			{
				*xi=x2;*yi=y2;
			}
			else
			{
				*xi=1e10;*yi=1e10;
			}
		}
		else
		if (dghb=='G')
		{
			if (x1<x2)
			{
				*xi=x1;*yi=y1;
			}
			else
			if (x2<x1)
			{
				*xi=x2;*yi=y2;
			}
			else
			{
				*xi=1e10;*yi=1e10;
			}
		}
		else
		if (dghb=='H')
		{
			if (y1<y2)
			{
				*xi=x2;*yi=y2;
			}
			else
			if (y2<y1)
			{
				*xi=x1;*yi=y1;
			}
			else
			{
				*xi=1e10;*yi=1e10;
			}
		}
		else
		if (dghb=='D')
		{
			if (x1<x2)
			{
				*xi=x2;*yi=y2;
			}
			else
			if (x2<x1)
			{
				*xi=x1;*yi=y1;
			}
			else
			{
				*xi=1e10;*yi=1e10;
			}
		}
		else
		{
			*xi=1e10;*yi=1e10;
		}
	}
	else
	{
		*xi=1e10;*yi=1e10;
	}
}
//_________________________________________________
//Cercle tangent  2 cercles
void CGeoAna::c2c(float xc,float yc,float r,float xc1,float yc1,float r1,float r2,char ie,char ie1,char dghb,float *xc2,float *yc2)
{
	*xc2=1e10;*yc2=1e10;
	dghb=toupper(dghb);ie1=toupper(ie1);ie=toupper(ie);
	if ((ie=='E') && (ie1=='E')) p2c(xc,yc,r+r2,xc1,yc1,r1+r2,dghb,xc2,yc2);
	else
	if ((ie=='E') && (ie1=='I'))  p2c(xc,yc,r+r2,xc1,yc1,r1-r2,dghb,xc2,yc2);
	else
	if ((ie=='I') && (ie1=='E')) p2c(xc,yc,r-r2,xc1,yc1,r1+r2,dghb,xc2,yc2);
	else
	if ((ie=='I') && (ie1=='I'))  p2c(xc,yc,r-r2,xc1,yc1,r1-r2,dghb,xc2,yc2);
}
//_________________________________________________
//Cercle passant par un point et tangent  un cercle
void CGeoAna::cpc(float xp,float yp,float xc,float yc,float r,float r1,char dghb,char ie,float *xc1,float *yc1)
{
	*xc1=1e10;*yc1=1e10;
	dghb=toupper(dghb);ie=toupper(ie);
	if (ie=='E') p2c(xp,yp,r1,xc,yc,r+r1,dghb,xc1,yc1);
	else
	if (ie=='I')
	{
		p2c(xp,yp,r1,xc,yc,r-r1,dghb,xc1,yc1);
		if (*xc1==1e10) p2c(xp,yp,r1,xc,yc,r1-r,dghb,xc1,yc1);
	}
}
//_________________________________________________
//Rotation d'un point (x,y) d'angle a autour d'un point (x1,y1)
void CGeoAna::rotation(float x,float y,float a,float xc,float yc,float *p_x1, float *p_y1)
{
	float a1,b,r,k;
	d2p(xc,yc,x,y,&a1,&b);
	r=pow(pow(x-xc,2)+pow(y-yc,2),0.5);
	if (x<xc) k=-1; else k=1;
	*p_x1=k*r*cos(a+a1)+xc;
	*p_y1=k*r*sin(a+a1)+yc;
}
//_________________________________________________
//Miroir d'un point par rapport  une droite
void CGeoAna::miroir (float xp,float yp,float xd,float yd,float a,float *xp1,float *yp1)
{
	float xi,yi,dx,dy;
	p2d(xp,yp,a+PI/2,xd,yd,a,&xi,&yi);
	dx=xi-xp;
	dy=yi-yp;
	*xp1=xi+dx;
	*yp1=yi+dy;
}
/*
procedure c2c(xc,yc,r,xc1,yc1,r1,r2:real;ie,ie1,dghb:char;var xc2,yc2:real);
{_______________________________________________________________________________
Nom procedure: C2C.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees CERCLE tangent a 2 CERCLES
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 03/06/91
_______________________________________________________________________________}

{$i p2c.inc}

{___________________________________________________________________________}
begin
	xc2:=1e10;yc2:=1e10;
	dghb:=upcase(dghb);ie1:=upcase(ie1);ie:=upcase(ie);
	if (ie='E') and (ie1='E') then p2c(xc,yc,r+r2,xc1,yc1,r1+r2,dghb,xc2,yc2)
	else
	if (ie='E') and (ie1='I') then p2c(xc,yc,r+r2,xc1,yc1,r1-r2,dghb,xc2,yc2)
	else
	if (ie='I') and (ie1='E') then p2c(xc,yc,r-r2,xc1,yc1,r1+r2,dghb,xc2,yc2)
	else
	if (ie='I') and (ie1='I') then p2c(xc,yc,r-r2,xc1,yc1,r1-r2,dghb,xc2,yc2);
end;

procedure c2d(xd1,yd1,a1,xd2,yd2,a2,r:real;dghb1,dghb2:char;var xc,yc:real);
{_______________________________________________________________________________
Nom procedure: C2D.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees CERCLE tangent a 2 DROITES
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 21/05/91
_______________________________________________________________________________}
var
  x1,y1,x2,y2:real;

{$i p2d.inc}
{$i dpa.inc}

{___________________________________________________________________________}
begin
  xc:=1e10;yc:=1e10;
  dghb1:=upcase(dghb1);
	dghb2:=upcase(dghb2);
  dpa(xd1,yd1,a1,r,dghb1,x1,y1);
	if x1<>1e10 then
  begin
		dpa(xd2,yd2,a2,r,dghb2,x2,y2);
    if x2<>1e10 then
    begin
      p2d(x1,y1,a1,x2,y2,a2,xc,yc);
    end;
  end;
end;
procedure c2p(xp1,yp1,xp2,yp2,r:real;dghb:char;var xc,yc:real);
{_______________________________________________________________________________
Nom procedure: C2P.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees CERCLE passant par 2 POINTS et de rayon donne
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 14/05/91
_______________________________________________________________________________}

{$i p2c.inc}

begin
  p2c(xp1,yp1,r,xp2,yp2,r,dghb,xc,yc);
end;
procedure c3p(xp1,yp1,xp2,yp2,xp3,yp3:real;var xc,yc,r:real);
{_______________________________________________________________________________
Nom procedure: C3P.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees CERCLE passant par 3 POINTS
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 14/05/91
_______________________________________________________________________________}
var
  a,a1,b,b1:real;
	xh,yh,xk,yk:real;
procedure d2p(xp1,yp1,xp2,yp2:real;var a,b:real);
begin
  if (abs(xp2-xp1)<1e-6) and (abs(yp2-yp1)<1e-6) then
  begin
    a:=1e10;b:=1e10;
  end
	else
  if abs(xp2-xp1)<1e-6 then
  begin
    b:=1e10;
    if yp2>yp1 then a:=pi/2 else a:=-pi/2;
  end
	else
	begin
		a:=(yp2-yp1)/(xp2-xp1);b:=yp1-a*xp1;
		a:=arctan(a);
  end;
end;
procedure p2d(xd1,yd1,a1,xd2,yd2,a2:real;var x,y:real);
var
  b1,b2:real;
  a11,a21:real;
function tan(x:real):real;
begin
  tan:=sin(x)/cos(x);
end;
begin
  a11:=cos(a1);a21:=cos(a2);
	if (abs(a11)<1e-6) and (abs(a21)>1e-6) then
  begin
    {Droite 1 verticale}
    b2:=yd2-tan(a2)*xd2;
    x:=xd1;y:=tan(a2)*x+b2;
  end
  else
  if (abs(a21)<1e-6) and (abs(a11)>1e-6) then
	begin
		{Droite 2 verticale}
		b1:=yd1-tan(a1)*xd1;
    x:=xd2;y:=tan(a1)*x+b1;
  end
  else
  if abs(a11-a21)<1e-6 then
  begin
		{Droites paralleles}
    x:=1e10;y:=1e10;
  end
  else
  begin
		b1:=yd1-tan(a1)*xd1;
    b2:=yd2-tan(a2)*xd2;
		x:=(b2-b1)/(tan(a1)-tan(a2));
    y:=tan(a1)*x+b1;
	end;
end;
{____________________________________________________________________________}
begin
  {Calcul coordonnees de K, milieu de P1P2}
  xk:=(xp2+xp1)/2;yk:=(yp2+yp1)/2;
  d2p(xp1,yp1,xp2,yp2,a,b);
	if a=1e10 then
  begin
		xc:=1e10;yc:=1e10;r:=1e10
  end
  else
  begin
		a:=a+pi/2;
    {Calcul coordonnees de H, milieu de P1P3}
    xh:=(xp3+xp1)/2;yh:=(yp3+yp1)/2;
    d2p(xp1,yp1,xp3,yp3,a1,b1);
    if a1=1e10 then
    begin
      xc:=1e10;yc:=1e10;r:=1e10
		end
    else
		begin
      a1:=a1+pi/2;
      p2d(xk,yk,a,xh,yh,a1,xc,yc);
      if xc=1e10 then r:=1e10
      else
      r:=sqrt(sqr(xp1-xc)+sqr(yp1-yc));
      {textmode(3);
			writeln(xk:1:3,'  ',yk:1:3);
      writeln(xh:1:3,'  ',yh:1:3);
			halt;}
    end;
	end;
end;

procedure cdc(xd,yd,a,xc,yc,r,r1:real;dghb,ie,dghb1:char;var xc1,yc1:real);
{_______________________________________________________________________________
Nom procedure: CPD.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees CERCLE tangent a une DROITE et a un CERCLE
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 26/05/91
_______________________________________________________________________________}
var
  xd1,yd1:real;
  x1,y1,x2,y2:real;
  m:char;

{$i dpa.inc}
{$i pdc.inc}

{___________________________________________________________________________}
begin
  xc1:=1e10;yc1:=1e10;
	dghb:=upcase(dghb);ie:=upcase(ie);dghb1:=upcase(dghb1);
  dpa(xd,yd,a,r1,dghb,xd1,yd1);
	if xd1<>1e10 then
  begin
    if ie='E' then pdc(xd1,yd1,a,xc,yc,r+r1,dghb1,xc1,yc1)
		else
    if ie='I' then pdc(xd1,yd1,a,xc,yc,r-r1,dghb1,xc1,yc1)
  end;


      {Dessin de la construction}
      {cercle(xi,yi,1,7);
			cercle(xc,yc,r+r1,7);
			if abs(cos(a))<0.5 then
      begin
        p2d(0,ymi,0,xd1,yd1,a,x1,y1);
        p2d(0,yma,0,xd1,yd1,a,x2,y2);
      end
      else
			begin
        p2d(xmi,0,pi/2,xd1,yd1,a,x1,y1);
				p2d(xma,0,pi/2,xd1,yd1,a,x2,y2);
      end;
    ligne(x1,y1,x2,y2,1);}
end;

procedure cpc(xp,yp,xc,yc,r,r1:real;dghb,ie:char;var xc1,yc1:real);
{_______________________________________________________________________________
Nom procedure: CPC.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees CERCLE passant par un point et tangent cercle
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 03/06/91
_______________________________________________________________________________}

{$i p2c.inc}

{_____________________________________________________________________________}
begin
	xc1:=1e10;yc1:=1e10;
	dghb:=upcase(dghb);ie:=upcase(ie);
	if ie='E' then p2c(xp,yp,r1,xc,yc,r+r1,dghb,xc1,yc1)
	else
	if ie='I' then
	begin
		p2c(xp,yp,r1,xc,yc,r-r1,dghb,xc1,yc1);
		if xc1=1e10 then p2c(xp,yp,r1,xc,yc,r1-r,dghb,xc1,yc1);
	end;
end;

procedure cpd(xp,yp,xd,yd,a,r:real;dghb:char;var xc,yc:real);
{_______________________________________________________________________________
Nom procedure: CPD.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees CERCLE passant par un POINT et tangent a
							 une DROITE
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 19/05/91
_______________________________________________________________________________}
var
	xd1,yd1:real;
	xi,yi:real;
	x1,y1,x2,y2:real;
	m:char;

{$i p2d.inc}
{$i dpa.inc}
{$i pdc.inc}

{___________________________________________________________________________}
begin
	xc:=1e10;yc:=1e10;
	p2d(xd,yd,a,xp,yp,0,xi,yi);
	if xi<>1e10 then
	begin
		if xp>xi then m:='D' else m:='G';
	end
	else
	begin
		p2d(xd,yd,a,xp,yp,pi/2,xi,yi);
		if yp>yi then m:='H' else m:='B';
	end;
	dpa(xd,yd,a,r,m,xd1,yd1);
	pdc(xd1,yd1,a,xp,yp,r,dghb,xc,yc);

			{Dessin de la construction}
			{cercle(xp,yp,r,7);
			if abs(cos(a))<0.5 then
			begin
				p2d(0,ymi,0,xd1,yd1,a,x1,y1);
				p2d(0,yma,0,xd1,yd1,a,x2,y2);
			end
			else
			begin
				p2d(xmi,0,pi/2,xd1,yd1,a,x1,y1);
				p2d(xma,0,pi/2,xd1,yd1,a,x2,y2);
			end;
		ligne(x1,y1,x2,y2,1);}


end;
procedure d2c(xc1,yc1,r1,xc2,yc2,r2:real;dg1,dg2:char;var xd,yd,a:real);
{_______________________________________________________________________________
Nom procedure: D2C.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees droite tangente a 2 CERCLES
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 09/05/91
_______________________________________________________________________________}
var
	alpha:real;
	beta,b:real;
	c1c2:real;
	x,y:real;

procedure d2p(xp1,yp1,xp2,yp2:real;var a,b:real);
begin
  if abs(xp2-xp1)<=1e-6 then
  begin
		a:=pi/2;b:=1e10;
    if yp2>yp1 then a:=pi/2 else a:=-pi/2;
  end
  else
  begin
    a:=(yp2-yp1)/(xp2-xp1);b:=yp1-a*xp1;
    a:=arctan(a);
	end;
end;
function arcsin(x:real):real;
begin
  if abs(x)>0.999999 then
  begin
    if x>0 then arcsin:=pi/2 else x:=-pi/2;
	end
  else
		arcsin:=arctan(x/sqrt(1-sqr(x)));
end;
{________________________________________________________________________}
begin
  dg1:=upcase(dg1);dg2:=upcase(dg2);
  {Distance entre centres}
  c1c2:=sqrt(sqr(xc1-xc2)+sqr(yc1-yc2));
  if (c1c2<1e-6) or ((dg1<>dg2) and (c1c2<r1+r2)) then
  begin
    xd:=1e10;yd:=1e10;a:=1e10;
  end
  else
  begin
		d2p(xc1,yc1,xc2,yc2,beta,b);
    if xc2<xc1 then beta:=beta+pi;
    if (dg1='G') and (dg2='G') then
    begin
      x:=r1*(r1-r2)/c1c2;
      alpha:=arcsin(x/r1);
      a:=beta-alpha;
      y:=cos(alpha)*r1;
      xd:=xc1+x*cos(beta)-y*sin(beta);
			yd:=yc1+x*sin(beta)+y*cos(beta);
    end
    else
    if (dg1='D') and (dg2='D') then
    begin
      x:=r1*(r1-r2)/c1c2;
      alpha:=arcsin(x/r1);
			a:=beta+alpha;
      y:=-cos(alpha)*r1;
      xd:=xc1+x*cos(beta)-y*sin(beta);
      yd:=yc1+x*sin(beta)+y*cos(beta);
    end
    else
    if (dg1='G') and (dg2='D') then
		begin
      x:=r1*(r1+r2)/c1c2;
			alpha:=arcsin(x/r1);
      a:=beta-alpha;
      y:=cos(alpha)*r1;
      xd:=xc1+x*cos(beta)-y*sin(beta);
      yd:=yc1+x*sin(beta)+y*cos(beta);
      writeln('x:',x:1:3);
      writeln('y:',y:1:3);
      writeln('alpha:',alpha*180/pi:1:3);
      writeln('beta:',beta*180/pi:1:3);
    end
    else
    if (dg1='D') and (dg2='G') then
    begin
			x:=r1*(r1+r2)/c1c2;
      alpha:=arcsin(x/r1);
      a:=beta+alpha;
      y:=-cos(alpha)*r1;
      xd:=xc1+x*cos(beta)-y*sin(beta);
      yd:=yc1+x*sin(beta)+y*cos(beta);
    end
    else
    begin
			xd:=1e10;yd:=1e10;a:=1e10;
    end;
  end;
end;
procedure d2p(xp1,yp1,xp2,yp2:real;var a,b:real);
{_______________________________________________________________________________
Nom procedure: D2P.PAS
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees DROITE passant par 2 POINTS
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 09/05/91
_______________________________________________________________________________}
begin
  if (abs(xp2-xp1)<1e-6) and (abs(yp2-yp1)<1e-6) then
	begin
    a:=1e10;b:=1e10;
	end
  else
  if abs(xp2-xp1)<1e-6 then
  begin
    b:=1e10;
    if yp2>yp1 then a:=pi/2 else a:=-pi/2;
  end
  else
  begin
    a:=(yp2-yp1)/(xp2-xp1);b:=yp1-a*xp1;
    a:=arctan(a);
  end;
end;
procedure dcx(xc,yc,r,a:real;dghb:char;var xd,yd:real);
{_______________________________________________________________________________
Nom procedure: DCX.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees DROITE tangente a 1 CERCLE et d'angle avec X
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 09/05/91
_______________________________________________________________________________}
var
	x,y:real;
function signe(x:real):real;
begin
  if x<0 then signe:=-1 else signe:=1;
end;
begin
  {Mise en forme: -pi/2<=a<=pi/2}
	if abs(cos(a))<=-1e6 then a:=signe(a)*pi/2 else a:=arctan(sin(a)/cos(a));
  x:=r*sin(abs(a));
  y:=r*cos(abs(a));
  dghb:=upcase(dghb);
  if dghb='D' then
  begin
    if abs(x)<1e-6 then
		begin
      xd:=1e10;yd:=1e10;
		end
    else
    begin
      xd:=xc+x;yd:=yc-signe(a)*y;
    end;
  end
  else
  if dghb='G' then
  begin
    if abs(x)<1e-6 then
    begin
      xd:=1e10;yd:=1e10;
    end
		else
    begin
      xd:=xc-x;yd:=yc+signe(a)*y;
    end;
  end
  else
  if dghb='H' then
  begin
    if abs(y)<1e-6 then
		begin
      xd:=1e10;yd:=1e10;
    end
    else
    begin
      xd:=xc-signe(a)*x;yd:=yc+y;
    end;
	end
  else
  if dghb='B' then
  begin
    if abs(y)<1e-6 then
    begin
      xd:=1e10;yd:=1e10;
		end
    else
		begin
      xd:=xc+signe(a)*x;yd:=yc-y;
    end;
  end
  else
  begin
    xd:=1e10;
    yd:=1e10;
  end;
end;
procedure dpa(xd,yd,a,d:real;dghb:char;var xd1,yd1:real);
{_______________________________________________________________________________
Nom procedure: DPA.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees DROITE PARALLELE a une DROITE
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 21/05/91
______________________________________________________________________________}
begin
  dghb:=upcase(dghb);
  d:=abs(d);
  xd1:=1e10;yd1:=1e10;
	while (a>2*pi) or (a<-2*pi) do
  begin
    if a>2*pi then a:=a-2*pi;
    if a<-2*pi then a:=a+2*pi;
  end;
  while (a<-pi/2) or (a>pi/2) do
  begin
		if a<-pi/2 then a:=a+pi;
		if a>pi/2 then a:=a-pi;
	end;
	if abs(a)<pi/4 then
	begin
		{Decalage suivant y}
		xd1:=xd;
		if a>0 then
		begin
			if (dghb='H') or (dghb='G') then yd1:=yd+d/cos(a)
			else
			if (dghb='D') or (dghb='B') then yd1:=yd-d/cos(a)
			else
			begin
				xd1:=1e10;yd1:=1e10;
			end;
		end
		else
		begin
			{a<0}
			if (dghb='H') or (dghb='D') then yd1:=yd+d/cos(a)
			else
			if (dghb='G') or (dghb='B') then yd1:=yd-d/cos(a)
			else
			begin
				xd1:=1e10;yd1:=1e10;
			end;
		end;
	end
	else
	begin
		{Decalage suivant x}
		yd1:=yd;
		if a>0 then
		begin
			if (dghb='H') or (dghb='G') then xd1:=xd-d/sin(a)
			else
			if (dghb='D') or (dghb='B') then xd1:=xd+d/sin(a)
			else
			begin
				xd1:=1e10;yd1:=1e10;
			end;
		end
		else
		begin
			{a<0}
			if (dghb='H') or (dghb='D') then xd1:=xd-d/sin(a)
			else
			if (dghb='G') or (dghb='B') then xd1:=xd+d/sin(a)
			else
			begin
				xd1:=1e10;yd1:=1e10;
			end;
		end;
	end;
end;
procedure dpc(xp,yp,xc,yc,r:real;dg:char;var a:real);
{_______________________________________________________________________________
Nom procedure: DPC.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul DROITE passant par un POINT et tangente CERCLE
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 24/05/91
_______________________________________________________________________________}
{$i d2p.inc}
function arcsin(x:real):real;
begin
	arcsin:=arctan(x/sqrt(1-sqr(x)));
end;
var
	b,beta:real;
	d:real;
begin
	a:=1e10;
	dg:=upcase(dg);
	{Point doit etre en-dehors du cercle}
	d:=sqrt(sqr(xc-xp)+sqr(yc-yp));
	if (d>r) and ((dg='D') or (dg='G')) then
	begin
		d2p(xp,yp,xc,yc,beta,b);
		{if (xc<xp) and (yc>yp) then a:=a+pi;
		if (xp1<xc) and (yp1<yc) then a:=a+pi;}
		if dg='G' then a:=beta+arcsin(r/d) else a:=beta-arcsin(r/d);
	end;
end;
procedure p2c(xc1,yc1,r1,xc2,yc2,r2:real;dghb:char;var xi,yi:real);
{_______________________________________________________________________________
Nom procedure: P2C.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees point d'intersection CERCLE/CERCLE
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 02/06/91
_______________________________________________________________________________}
var
	beta,b:real;
	d:real;
	x,y:real;
	x1,y1,x2,y2:real;

{$i d2p.inc}

begin
	{Ramener le premier cercle sur l'origine du repere pour simplification}
	xc2:=xc2-xc1;yc2:=yc2-yc1;
	d:=sqrt(sqr(xc2)+sqr(yc2));
	if (d-r1-r2>1e-6) or (d+r2-r1<-1e-6) or (d+r1-r2<-1e-6) then
	begin
		x1:=1e10;
		if x1=1e10 then
		begin
			{textmode(3);
			writeln(d);
			writeln(r1);
			writeln(r2);
			halt;}
		end;
	end
	else
	begin
		x:=(sqr(r1)-sqr(r2)+sqr(d))/(2*d);
		y:=sqrt(sqr(r1)-sqr(x));
		d2p(0,0,xc2,yc2,beta,b);
		if xc2<0 then beta:=beta+pi;
		x1:=xc1+x*cos(beta)-y*sin(beta);
		y1:=yc1+x*sin(beta)+y*cos(beta);
		x2:=xc1+x*cos(beta)+y*sin(beta);
		y2:=yc1+x*sin(beta)-y*cos(beta);
		{textmode(3);
		writeln('x:',x:1:3);
		writeln('y:',y:1:3);
		writeln('x1:',x1:1:3);
		writeln('x2:',x2:1:3);
		writeln('y1:',y1:1:3);
		writeln('y2:',y2:1:3);
		halt; }
	end;
	{Choix de la solution}
	if (x1<>1e10) then
	begin
		dghb:=upcase(dghb);
		if (x1=x2) and (y1=y2) then
		begin
			xi:=x1;yi:=y1;
		end
		else
		if dghb='B' then
		begin
			if y1<y2 then
			begin
				xi:=x1;yi:=y1;
			end
			else
			if y2<y1 then
			begin
				xi:=x2;yi:=y2;
			end
			else
			begin
				xi:=1e10;yi:=1e10;
			end;
		end
		else
		if dghb='G' then
		begin
			if x1<x2 then
			begin
				xi:=x1;yi:=y1;
			end
			else
			if x2<x1 then
			begin
				xi:=x2;yi:=y2;
			end
			else
			begin
				xi:=1e10;yi:=1e10;
			end;
		end
		else
		if dghb='H' then
		begin
			if y1<y2 then
			begin
				xi:=x2;yi:=y2;
			end
			else
			if y2<y1 then
			begin
				xi:=x1;yi:=y1;
			end
			else
			begin
				xi:=1e10;yi:=1e10;
			end;
		end
		else
		if dghb='D' then
		begin
			if x1<x2 then
			begin
				xi:=x2;yi:=y2;
			end
			else
			if x2<x1 then
			begin
				xi:=x1;yi:=y1;
			end
			else
			begin
				xi:=1e10;yi:=1e10;
			end;
		end
		else
		begin
			xi:=1e10;yi:=1e10;
		end;
	end
	else
	begin
		xi:=1e10;yi:=1e10;
	end;
end;
procedure p2d(xd1,yd1,a1,xd2,yd2,a2:real;var x,y:real);
{_______________________________________________________________________________
Nom procedure: P2D.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees POINT d'intersection 2 DROITES
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 28/11/90
_______________________________________________________________________________}
var
  b1,b2:real;
  a11,a21:real;
function tan(x:real):real;
begin
  tan:=sin(x)/cos(x);
end;
begin
  a11:=cos(a1);a21:=cos(a2);
  if (abs(a11)<1e-8) and (abs(a21)>1e-8) then
  begin
    {Droite 1 verticale}
    b2:=yd2-tan(a2)*xd2;
    x:=xd1;y:=tan(a2)*x+b2;
  end
  else
  if (abs(a21)<1e-5) and (abs(a11)>1e-5) then
  begin
    {Droite 2 verticale}
    b1:=yd1-tan(a1)*xd1;
    x:=xd2;y:=tan(a1)*x+b1;
  end
  else
  if abs(a11-a21)<1e-8 then
  begin
    {Droites paralleles}
    x:=1e10;y:=1e10;
  end
  else
  begin
    b1:=yd1-tan(a1)*xd1;
    b2:=yd2-tan(a2)*xd2;
    x:=(b2-b1)/(tan(a1)-tan(a2));
    y:=tan(a1)*x+b1;
  end;
end;

procedure pdc(xd,yd,a,xc,yc,r:real;dghb:char;var xp,yp:real);
{_______________________________________________________________________________
Nom procedure: PDC.INC
Langage      : Turbo-Pascal V4.0
But          : Calcul coordonnees POINT d'intersection DROITE/CERCLE
Auteur       : B. KEMPF - LEGT Jean Mermoz - 68300 Saint Louis
Version      : 17/05/91
_______________________________________________________________________________}
procedure degre2(a,b,c:real;var x1,x2:real);
var
  delta:real;
begin
  delta:=sqr(b)-4*a*c;
  if delta<-1e-5 then
  begin
    x1:=1e10;x2:=1e10;
  end
  else
  if abs(delta)<1e-5 then
  begin
    x1:=-b/(2*a);
    x2:=x1;
  end
  else
  begin
    x1:=(-b-sqrt(delta))/(2*a);
    x2:=(-b+sqrt(delta))/(2*a);
  end;
end;{degre2}
var
  a1,b1,c1:real;
  x1,x2,y1,y2:real;
  k,b:real;
begin
  a1:=cos(a);
  if abs(a1)<1e-6 then
  begin
		{Droite verticale}
    k:=sqr(r)-sqr(xd-xc);
    if k<0 then
    begin
      {Pas de solutions}
      x1:=1e10;x2:=1e10;xp:=1e10;yp:=1e10;
    end
    else
    begin
      y1:=-sqrt(k)+yc;y2:=sqrt(k)+yc;
      x1:=xd;x2:=xd;
    end;
  end
  else
  begin
    a:=sin(a)/cos(a);
    b:=yd-a*xd;
    a1:=1+sqr(a);
    b1:=2*a*b-2*xc-2*a*yc;
    c1:=sqr(xc)+sqr(yc)+sqr(b)-sqr(r)-2*b*yc;
    degre2(a1,b1,c1,x1,x2);
    if x1<>1e10 then
    begin
      y1:=a*x1+b;y2:=a*x2+b;
    end;
  end;
  {Choix de la solution}
  if (x1<>1e10) then
  begin
    {writeln(x1:3:3,' ',y1:3:3);
    writeln(x2:3:3,' ',y2:3:3);}
    dghb:=upcase(dghb);
    if (x1=x2) and (y1=y2) then
    begin
      xp:=x1;yp:=y1;
    end
    else
    if dghb='B' then
		begin
      if y1<y2 then
      begin
        xp:=x1;yp:=y1;
      end
      else
      if y2<y1 then
      begin
        xp:=x2;yp:=y2;
      end
      else
      begin
        xp:=1e10;yp:=1e10;
      end;
    end
    else
    if dghb='G' then
    begin
      if x1<x2 then
      begin
        xp:=x1;yp:=y1;
      end
      else
      if x2<x1 then
      begin
        xp:=x2;yp:=y2;
      end
      else
      begin
        xp:=1e10;yp:=1e10;
      end;
    end
    else
    if dghb='H' then
    begin
      if y1<y2 then
      begin
        xp:=x2;yp:=y2;
			end
      else
      if y2<y1 then
      begin
        xp:=x1;yp:=y1;
      end
      else
      begin
        xp:=1e10;yp:=1e10;
      end;
    end
    else
    if dghb='D' then
    begin
      if x1<x2 then
      begin
        xp:=x2;yp:=y2;
      end
      else
      if x2<x1 then
      begin
        xp:=x1;yp:=y1;
      end
      else
      begin
        xp:=1e10;yp:=1e10;
      end;
    end
    else
    begin
      xp:=1e10;yp:=1e10;
    end;
  end
  else
  begin
    xp:=1e10;yp:=1e10;
  end;
end;
*/
