// MasqueDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "MasqueDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMasqueDlg dialog
CMasqueDlg::CMasqueDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMasqueDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMasqueDlg)
	m_sTexte = _T("");
	m_sSource = _T("");
	m_radioTypeTracker = -1;
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_MASQUE,pParent);
}
void CMasqueDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMasqueDlg)
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Text(pDX, IDC_STATIC_SOURCE, m_sSource);
	DDX_Radio(pDX, IDC_TYPE_TRACKER, m_radioTypeTracker);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CMasqueDlg, CDialog)
	//{{AFX_MSG_MAP(CMasqueDlg)
	ON_BN_CLICKED(IDAJOUTER, OnAjouter)
	ON_BN_CLICKED(IDRETIRER, OnRetirer)
	ON_BN_CLICKED(IDC_TYPE_TRACKER, OnTypeTracker)
	ON_BN_CLICKED(IDC_TYPE_TRACKER2, OnTypeTracker2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CMasqueDlg message handlers
void CMasqueDlg::PostNcDestroy()
{
	delete this;
}
//________________________________________
BOOL CMasqueDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j,ns;
	CString s;
	CBkDoc *ps;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) ps=(CBkDoc*)pChild->GetActiveDocument(); else ps=NULL;
	m_pApp=(CBkApp*)AfxGetApp();

	if (ps!=NULL)
	{
		ns=ps->m_iNo;
		m_sSource.Format("%d",ns);
		m_iI=new short[m_pApp->m_iNbMax];
		//Initialisation tableau N images
		for (i=0;i<m_pApp->m_iNbMax;i++) m_iI[i]=-1;
		j=0;
		for (i=0;i<m_pApp->m_iNbMax;i++)
		{
			if (m_pApp->GetDocument(i)!=NULL && i!=ns)
			{
				s.Format("Image %d",i);	
				m_comboDest.AddString(s);
				m_iI[j]=i;
				j++;
			}         
		}
		//Recherche N nouvelle image destination
		for (i=0;i<m_pApp->m_iNbMax;i++)
		{
			if (m_pApp->GetDocument(i)==NULL)
			{
				s.Format("IMAGE %d",i);	
				m_comboDest.AddString(s);
				//Image destination
				m_iI[j]=i;
				//On sort
				i=m_pApp->m_iNbMax;    
			}
		}
		//Par dfaut sur nouvelle image
		m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
		m_comboDest.SetWindowText(s);	
		//Premire fois
		m_OKP=TRUE;
		m_radioTypeTracker=ps->m_radioTypeTracker;
		ps->InitTracker();
		UpdateData(FALSE);
	}
	return TRUE;
}
//________________________________________
void CMasqueDlg::OnAjouter() 
{
	short 
		l,h,nbB,
		ns,nd,
		x1,y1,a,b,
		x,y,xd,xa,yd,ya;
	float r;
	long w;

	class CBkDoc *ps,*pd;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) ps=(CBkDoc*)pChild->GetActiveDocument(); else ps=NULL;
	if (ps!=NULL)
	{
		UpdateData(TRUE);
		//Si l'utilisateur n'a pas touch au combo...
		if (m_comboDest.GetCurSel()<0) 
			nd=m_iI[m_comboDest.GetCount()-1];
		else
			nd=m_iI[m_comboDest.GetCurSel()];
		ns=ps->m_iNo;
		m_sSource.Format("%d",ns);
		UpdateData(FALSE);
		xd=ps->m_tracker.m_rect.left;	
		xa=ps->m_tracker.m_rect.right;
		yd=ps->m_tracker.m_rect.top;
		ya=ps->m_tracker.m_rect.bottom;
		if (xa>0 && ya>0 && xd>0 && yd>0 && xa!=xd && ya!=yd)
		{
			m_sTexte.Format("Zone (%d,%d), (%d,%d) ajoute...",xd,yd,xa,ya);
			UpdateData(FALSE);
			pd=InitFenetre(nd);
			if (m_OKP)
			{ 
				//PremiereFois
				m_OKP=FALSE;
				GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
				l=ps->image->endx-ps->image->stx+1;
				h=ps->image->endy-ps->image->sty+1;
				nbB=ps->image->bmh->biBitCount;
				pd->InitialiserImage(l,h,8);
				zeroimage(0,pd->image);
				//Dimensionner l'image destination  la taille source
				pd->DimensionnerFenetre(l,h);
				pd->DefinirCurseurs(l,h);
				pd->m_iType=0;
				pd->m_sNomFic.Format("Masque");
			}
			pd->PositionnerFenetre(5,5);
			//Copie image source dans temporaire n0
			m_pApp->DupliquerImageDestTempo(ns,0);
			if (m_radioTypeTracker==0)
			{
				//Rectangulaire
				for(x=xd;x<=xa;x++)
				{
					for(y=yd;y<=ya;y++)
					{
						w=getpixelcolor(m_pApp->imt[0],x,y);
						//IMPORTANT: les pts d'intensit nulle du masque sont ignors  la dmodulation
						//w++;
						//if (w>255) w=255;
						w=255;
						setpixelcolor(pd->image,x,y,w);
					}
				}
			}
			else
			{
				//Elliptique
				x1=(xa+xd)/2;
				y1=(ya+yd)/2;
				a=abs(xa-x1);
				b=abs(ya-y1);
				for(x=-a;x<=a;x++)
				{
					for(y=-b;y<b;y++)
					{
						r=pow(1.0*b*b*(1-1.0*x*x/(1.0*a*a)),0.5);
						if ((y<=(int)r && -y>=(int)r) || (y>=(int)r && -y<=(int)r))
						{
						}
						else
						{
							w=getpixelcolor(m_pApp->imt[0],x1+x,y1+y);
							//IMPORTANT: les pts d'intensit nulle du masque sont ignors  la dmodulation
							//w++;
							//if (w>255) w=255;
							w=255;
							setpixelcolor(pd->image,x1+x,y1+y,w);
						}
					}
				}
			}
			ps->InitTracker();
			pd->InitTracker();
			pd->UpdateAllViews(NULL);
			ps->UpdateAllViews(NULL);
		}
	}
}
//________________________________________
void CMasqueDlg::OnRetirer() 
{
	short
		l,h,nbB,
		ns,nd,
		x1,y1,a,b,
		x,y,xd,xa,yd,ya;
	float r;
	long w;

	class CBkDoc *ps,*pd;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) ps=(CBkDoc*)pChild->GetActiveDocument(); else ps=NULL;
	if (ps!=NULL)
	{
		UpdateData(TRUE);
		//Si l'utilisateur n'a pas touch au combo...
		if (m_comboDest.GetCurSel()<0) 
			nd=m_iI[m_comboDest.GetCount()-1];
		else
			nd=m_iI[m_comboDest.GetCurSel()];
		ns=ps->m_iNo;
		m_sSource.Format("%d",ns);
		UpdateData(FALSE);
		xd=ps->m_tracker.m_rect.left;	
		xa=ps->m_tracker.m_rect.right;
		yd=ps->m_tracker.m_rect.top;
		ya=ps->m_tracker.m_rect.bottom;
		if (xa>0 && ya>0 && xd>0 && yd>0 && xa!=xd && ya!=yd)
		{
			m_sTexte.Format("Zone (%d,%d), (%d,%d) retire...",xd,yd,xa,ya);
			UpdateData(FALSE);
			pd=InitFenetre(nd);
			if (m_OKP)
			{
				//PremiereFois
				m_OKP=FALSE;
				GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
				l=ps->image->endx-ps->image->stx+1;
				h=ps->image->endy-ps->image->sty+1;
				nbB=ps->image->bmh->biBitCount;
				pd->InitialiserImage(l,h,8);
				zeroimage(0,pd->image);
				//Dimensionner l'image destination  la taille source
				pd->DimensionnerFenetre(l,h);
				pd->DefinirCurseurs(l,h);
				pd->m_iType=0;
				pd->m_sNomFic.Format("Masque");
			}
			pd->PositionnerFenetre(5,5);

			if (m_radioTypeTracker==0)
			{
				//Rectangulaire
				for(x=xd;x<=xa;x++)
				{
					for(y=yd;y<=ya;y++)
					{
						setpixelcolor(pd->image,x,y,0);
					}
				}
			}
			else
			{
				//Elliptique
				x1=(xa+xd)/2;
				y1=(ya+yd)/2;
				a=abs(xa-x1);
				b=abs(ya-y1);
				for(x=-a;x<=a;x++)
				{
					for(y=-b;y<b;y++)
					{
						r=pow(1.0*b*b*(1-1.0*x*x/(1.0*a*a)),0.5);
						if ((y<=(int)r && -y>=(int)r) || (y>=(int)r && -y<=(int)r))
						{
						}
						else
						{
							setpixelcolor(pd->image,x1+x,y1+y,0);
						}
					}
				}
			}
			ps->InitTracker();
			pd->InitTracker();
			pd->UpdateAllViews(NULL);
			ps->UpdateAllViews(NULL);
		}
	}
}
//________________________________________
void CMasqueDlg::OnCancel() 
{
	delete m_iI;
	m_pApp->m_pMasqueDlg=NULL;	

	CBkDoc *ps;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild)	ps=(CBkDoc*)pChild->GetActiveDocument(); else ps=NULL;
	if (ps!=NULL)	ps->m_radioTypeTracker=m_radioTypeTracker;
	CDialog::OnCancel();
}
//________________________________________
void CMasqueDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CMasqueDlg::OnTypeTracker() 
{
	CBkDoc *ps;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) ps=(CBkDoc*)pChild->GetActiveDocument(); else  ps=NULL;
	if (ps!=NULL)
	{
		ps->m_radioTypeTracker=0;	
		ps->UpdateAllViews(NULL);
	}
}
//________________________________________
void CMasqueDlg::OnTypeTracker2() 
{
	CBkDoc *ps;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild)	ps=(CBkDoc*)pChild->GetActiveDocument(); else ps=NULL;
	if (ps!=NULL)
	{
		ps->m_radioTypeTracker=1;	
		ps->UpdateAllViews(NULL);
	}
}
//________________________________________
CBkDoc *CMasqueDlg::InitFenetre(short n) 
{
	class CBkDoc* p;
	if (m_pApp->GetDocument(n)==NULL)
	{
		//L'image destination existe maintenant.
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		p=m_pApp->m_pDocument[n];
		m_OKP=TRUE;
	}
	else
	{
		//Pointeur sur destination
		p=m_pApp->m_pDocument[n];
	}
	return p;
}
