// MathDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "MathDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMathDlg dialog
CMathDlg::CMathDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMathDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMathDlg)
	m_sTexte1 = _T("");
	m_sTexte2 = _T("");
	m_fCoef = 0.0f;
	//}}AFX_DATA_INIT
}
void CMathDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMathDlg)
	DDX_Control(pDX, IDORI, m_btnOri);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDAPPLIC, m_btnApplic);
	DDX_Text(pDX, IDC_STATIC1, m_sTexte1);
	DDX_Text(pDX, IDC_STATIC2, m_sTexte2);
	DDX_Text(pDX, IDC_COEF, m_fCoef);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CMathDlg, CDialog)
	//{{AFX_MSG_MAP(CMathDlg)
	ON_BN_CLICKED(IDAPPLIC, OnApplic)
	ON_BN_CLICKED(IDORI, OnOri)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
void CMathDlg::Visualiser() 
{
	short i,j;
	long w;
	float r;
	m_btnCancel.EnableWindow(FALSE);
	m_btnOK.EnableWindow(FALSE);
	m_btnApplic.EnableWindow(FALSE);
	m_btnOri.EnableWindow(FALSE);
	for (i=0;i<m_pDoc->m_iL;i++)
	{
		for (j=0;j<m_pDoc->m_iH;j++)
		{
			w=getpixelcolor(m_pDoc->image,i,j);
			r=m_fCoef*w;
			if (r>255) r=255;
			w=(long)(r);
			setpixelcolor(m_pDoc->image,i,j,w);
		}
	}
	m_btnCancel.EnableWindow(TRUE);
	m_btnOK.EnableWindow(TRUE);
	m_btnApplic.EnableWindow(TRUE);
	m_btnOri.EnableWindow(TRUE);
	//m_pDoc->UpdateAllViews(NULL);
	m_pView->MAJ_Fen();
}
//________________________________________
BOOL CMathDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_fCoef=0.5;
	m_pApp=((CBkApp*)AfxGetApp());
	m_iNo=m_pApp->m_iNo;
	//Pointeur sur l'application
	m_pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	//Pointeur sur la vue
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;

	m_iNo=m_pDoc->m_iNo;
	m_sTexte1.Format("Image %d",m_iNo);	
	m_sTexte2.Format("Image %d",m_iNo);	

	m_pApp->DupliquerImageDestTempo(m_iNo,m_iNo);	
	
	m_btnOK.EnableWindow(FALSE);
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CMathDlg::OnApplic() 
{
	UpdateData(TRUE);	
	if (m_fCoef<0) m_fCoef=-m_fCoef;
	if (m_fCoef<0.05) m_fCoef=0.05;
	if (m_fCoef>20) m_fCoef=20;
	UpdateData(FALSE);
	Visualiser();
}
//________________________________________
void CMathDlg::OnCancel() 
{
	copyimage(m_pApp->imt[m_iNo],m_pDoc->image);
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnCancel();
}
//________________________________________
void CMathDlg::OnOK() 
{
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnOK();
}
//________________________________________
void CMathDlg::OnOri() 
{
	//m_fCoef=5;
	UpdateData(FALSE);
	copyimage(m_pApp->imt[m_iNo],m_pDoc->image);
	m_pView->MAJ_Fen();
	//m_pDoc->UpdateAllViews(NULL);
}
