// MorphoDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "BkView.h"
#include "MorphoDlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMorphoDlg dialog
CMorphoDlg::CMorphoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMorphoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMorphoDlg)
	m_s1 = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_FILTRES_MORPHOLOGIQUES,pParent);
}
void CMorphoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMorphoDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDANTERIEURE, m_btnImageAnte);
	DDX_Control(pDX, IDIMAGEORI, m_btnImageOri);
	DDX_Control(pDX, IDC_COMBO1, m_liste);
	DDX_Control(pDX, IDAPPLIQUER, m_btnAppliquer);
	DDX_Text(pDX, IDC_STATIC_TEXTE1, m_s1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CMorphoDlg, CDialog)
	//{{AFX_MSG_MAP(CMorphoDlg)
	ON_BN_CLICKED(IDAPPLIQUER, OnAppliquer)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDANTERIEURE, OnAnterieure)
	ON_BN_CLICKED(IDIMAGEORI, OnImageori)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CMorphoDlg message handlers
void CMorphoDlg::PostNcDestroy()
{
	delete this;
}
//_______________________________________
BOOL CMorphoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_pDoc=pDoc;
		m_s1.Format("Image courante : %d",pDoc->m_iNo);
	}
	m_liste.AddString("Epluchage sur im. seuille ...");
	m_liste.AddString("Nettoyage sur im. seuille");
	m_liste.AddString("Filtre mdian 3X3");
	m_liste.AddString("Filtre mdian 5X5");
	m_liste.AddString("Extraction contours (Laplacien)");
	m_liste.AddString("Extraction contours (Prewitt)");
	m_liste.AddString("Dilatation (voisinage 3X3) ...");
	m_liste.AddString("Erosion (voisinage 3X3)");
	m_liste.AddString("Pixellisation (voisinage 3X3)");
	m_iNoF=0;//N filtre par dfaut
	m_liste.GetLBText(m_iNoF,s);
	m_liste.SetWindowText(s);
	UpdateData(FALSE);
	if (m_pApp->m_pFiltreDlg==NULL)
	{
		//Image originale dans imt[0]
		m_pApp->DupliquerImageDestTempo(pDoc->m_iNo,0);
		//Image antrieure dans imt[1]
		m_pApp->DupliquerImageDestTempo(pDoc->m_iNo,1);
	}
	//Images temporaires pour calcul Prewitt, dilatation et rosion
	m_pApp->DupliquerImageDestTempo(pDoc->m_iNo,3);
	m_pApp->DupliquerImageDestTempo(pDoc->m_iNo,4);
	SetTimer(1,300,NULL);
	return TRUE;
}
//________________________________________
void CMorphoDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CMorphoDlg::OnCancel() 
{
	KillTimer(1);
	m_pApp->m_pMorphoDlg=NULL;	
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL && pDoc==m_pDoc)
	{
	}
	CDialog::OnCancel();
}
//________________________________________
void CMorphoDlg::OnAppliquer() 
{
	short nb;
	BOOL ok;
	char 
		Div;
	char
		const taille=3,
		Coef2[taille*taille]={-1,-1,-1,-1,8,-1,-1,-1,-1},
		Coef3[taille*taille]={-1,-2,-1,0,0,0,1,2,1},
		Coef4[taille*taille]={-1,0,1,-2,0,2,-1,0,1};

	class CBkView *pView;
	class CBkDoc* pDoc;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pChild) pView=(CBkView*)pChild->GetActiveView(); else pView=NULL;
	if (pView!=NULL && pDoc!=NULL && pDoc==m_pDoc)
	{
		//Image antrieure
		copyimage(m_pDoc->image,m_pApp->imt[1]);
		UpdateData(TRUE);
		KillTimer(1);
		m_btnAppliquer.EnableWindow(FALSE);
		m_btnImageOri.EnableWindow(FALSE);
		m_btnImageAnte.EnableWindow(FALSE);
		m_btnCancel.EnableWindow(FALSE);

		switch (m_iNoF)
		{
			case 0://Epluchage
				nb=0;
				do
				{
					//Il faut plucher tant que ok est FAUX -> pas termin...
					ok=Epluchage(pDoc->image);
					nb++;
				}
				while ((!ok) && nb<=60);
				//if (nb>=60) AfxMessageBox("Le calcul a t arrt, mais n'est pas termin...");
			break;
			case 1://Nettoyage
				Nettoyage(pDoc->image);
			break;
			case 2://Mdian 3x3
				medianfilter(3,pDoc->image,pDoc->image);
			break;
			case 3://Mdian 5x5
				medianfilter(5,pDoc->image,pDoc->image);
			break;
			case 4://Laplacien
				Div=1;
				matrixconvex(taille,Coef2,Div,pDoc->image,pDoc->image);
			break;
			case 5://Prewitt
				copyimage(pDoc->image,m_pApp->imt[3]);
				copyimage(pDoc->image,m_pApp->imt[4]);
				Div=1;
				matrixconvex(taille,Coef3,Div,m_pApp->imt[3],m_pApp->imt[3]);
				matrixconvex(taille,Coef4,Div,m_pApp->imt[4],m_pApp->imt[4]);
				addimage(m_pApp->imt[3],m_pApp->imt[4],pDoc->image);
			break;
			case 6://Dilatation
				IpDilate(pDoc->image,pDoc->image,m_pApp->imt[3],1);
			break;
			case 7://Erosion
				IpErode(pDoc->image,pDoc->image,m_pApp->imt[3],1);
			break;
			case 8://Pixellisation 3x3
				pixellize(3,pDoc->image,pDoc->image);
			break;
		}
		m_btnAppliquer.EnableWindow(TRUE);
		m_btnImageOri.EnableWindow(TRUE);
		m_btnImageAnte.EnableWindow(TRUE);
		m_btnCancel.EnableWindow(TRUE);
		SetTimer(1,300,NULL);
		pView->MAJ_Fen();
	}	
}
//________________________________________
void CMorphoDlg::OnTimer(UINT nIDEvent) 
{
	//Contrle par timer de l'image courante
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc==NULL || pDoc!=m_pDoc)
	{
		m_btnAppliquer.EnableWindow(FALSE);
		m_btnImageOri.EnableWindow(FALSE);
		m_btnImageAnte.EnableWindow(FALSE);
		m_s1.Format("Image courante change ou ferme ...");
	}	
	else
	{
		m_s1.Format("Image courante : %d",pDoc->m_iNo);
		m_btnAppliquer.EnableWindow(TRUE);
		m_btnImageOri.EnableWindow(TRUE);
		m_btnImageAnte.EnableWindow(TRUE);
	}
	GetDlgItem(IDC_STATIC_TEXTE1)->SetWindowText(m_s1);
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CMorphoDlg::OnSelchangeCombo1() 
{
	//Changement de type de filtre
	CString s;
	m_iNoF=m_liste.GetCurSel();
	m_liste.GetLBText(m_iNoF,s);
	m_liste.SetWindowText(s);
}
//________________________________________
void CMorphoDlg::OnAnterieure() 
{
	class CBkView *pView;
	class CBkDoc* pDoc;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pChild) pView=(CBkView*)pChild->GetActiveView(); else pView=NULL;
	if (pView!=NULL && pDoc!=NULL && pDoc==m_pDoc)
	{
		copyimage(m_pApp->imt[1],m_pDoc->image);	
		pView->MAJ_Fen();
	}
}
//________________________________________
void CMorphoDlg::OnImageori() 
{
	class CBkView *pView;
	class CBkDoc* pDoc;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pChild) pView=(CBkView*)pChild->GetActiveView(); else pView=NULL;
	if (pView!=NULL && pDoc!=NULL && pDoc==m_pDoc)
	{
		copyimage(m_pApp->imt[0],m_pDoc->image);	
		pView->MAJ_Fen();
	}
}
//________________________________________
//Image in, out, temporaire
void CMorphoDlg::IpDilate(imgdes* nfi,imgdes* nfo,imgdes* imt,long size)
{
	//Dilatation, voir page 107
	short 
		nb,i,j,i1,j1;
	long w,wmax;

	zeroimage(0,imt);
	int rcode;
	for (nb=0;nb<size;nb++)
	{
		for (i=nfi->stx+1;i<=nfi->endx-1;i=i++)
		{
			for (j=nfi->sty+1;j<=nfi->endy-1;j++)
			{
				wmax=getpixelcolor(nfi,i,j)&255;
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(nfi,i1,j1)&255;
						if (w>wmax) wmax=w;
					}
				}
				//Affectation de la zone avec wmax
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(imt,i1,j1)&255;
						if (wmax>w) setpixelcolor(imt,i1,j1,wmax);
					}
				}
			}
		}
		copyimage(imt,nfo);
	}
}
//________________________________________
void CMorphoDlg::IpErode(imgdes* nfi,imgdes* nfo,imgdes* imt,long size)
{
	//Erosion, voir page 108
	short 
		nb,i,j,i1,j1;
	long w,wmin;

	int rcode;
	zeroimage(0,imt);
	for (nb=0;nb<size;nb++)
	{
		for (i=nfi->stx+1;i<=nfi->endx-1;i=i++)
		{
			for (j=nfi->sty+1;j<=nfi->endy-1;j++)
			{
				wmin=getpixelcolor(nfi,i,j)&255;
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(nfi,i1,j1)&255;
						if (w<wmin) wmin=w;
					}
				}
				//Affectation de la zone avec wmax
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(imt,i1,j1)&255;
						if (wmin<w) setpixelcolor(imt,i1,j1,wmin);
					}
				}
			}
		}
		copyimage(imt,nfo);
	}
}
//________________________________________
BOOL CMorphoDlg::Epluchage(imgdes* im)
{	
	BOOL ok=TRUE;
	short i,j,k,l,h;
	long w;
	short T[3][3];

	l=im->endx-im->stx+1;
	h=im->endy-im->sty+1;
	for (i=1;i<l-1;i++)
	{
		for (j=1;j<h-1;j++)
		{
			w=getpixelcolor(im,i,j)&255;
			if (w==255)
			{
				//On calcule les coefficients d'pluchage (masque)
				T[0][0]=(getpixelcolor(im,i-1,j-1))>>7;T[0][1]=(getpixelcolor(im,i-1,j))>>7;T[0][2]=(getpixelcolor(im,i-1,j+1))>>7;
				T[1][0]=(getpixelcolor(im,i  ,j-1))>>7;T[1][1]=(getpixelcolor(im,i  ,j))>>7;T[1][2]=(getpixelcolor(im,i  ,j+1))>>7;
				T[2][0]=(getpixelcolor(im,i+1,j-1))>>7;T[2][1]=(getpixelcolor(im,i+1,j))>>7;T[2][2]=(getpixelcolor(im,i+1,j+1))>>7;
				k=2*T[0][0]+4*T[0][1]+8*T[0][2]+256*T[1][0]+16*T[1][2]+128*T[2][0]+64*T[2][1]+32*T[2][2];
				//On superpose les 16 masques
				if (k==0 || k==454 || k==496 || k==124 || k==286 || k==248 || k==398 || k==482 || k==62 || k==240 || k==270 || k==60 || k==450 || k==480 || k==30|| k==390 || k==120)
				{
					//On met ce pixel  0
					setpixelcolor(im,i,j,0);
					//On n'a pas fini
					ok=FALSE;
				}
			}
		}
	}
	return ok;
}
//________________________________________
void CMorphoDlg::Nettoyage(imgdes* im)
{	
	short i,j,i1,j1,l,h;
	long w;
	unsigned int k;
	short /*M[4][4],*/T[3][3];

	l=im->endx-im->stx+1;
	h=im->endy-im->sty+1;

	for (i=1;i<l-1;i++)
	{
		for (j=1;j<h-1;j++)
		{
			w=getpixelcolor(im,i,j)&255;
			if (w==255)
			{
				//On calcule les coefficients de nettoyage (masque)
				T[0][0]=(getpixelcolor(im,i-1,j-1)&255)>>7;T[0][1]=(getpixelcolor(im,i-1,j)&255)>>7;T[0][2]=(getpixelcolor(im,i-1,j+1)&255)>>7;
				T[1][0]=(getpixelcolor(im,i  ,j-1)&255)>>7;T[1][1]=(getpixelcolor(im,i  ,j)&255)>>7;T[1][2]=(getpixelcolor(im,i  ,j+1)&255)>>7;
				T[2][0]=(getpixelcolor(im,i+1,j-1)&255)>>7;T[2][1]=(getpixelcolor(im,i+1,j)&255)>>7;T[2][2]=(getpixelcolor(im,i+1,j+1)&255)>>7;
				k=2*T[0][0]+4*T[0][1]+8*T[0][2]+256*T[1][0]+1*T[1][1]+16*T[1][2]+128*T[2][0]+64*T[2][1]+32*T[2][2];
				//On superpose les masques
				if (k==1 || k==3 || k==9 || k==33 || k==129 || k==5 || k==17 || k==65 || k==257 || k==7 || k==259 || k==13 || k==25 || k==385 || k==193 || k==97 || k==49)
				{
					setpixelcolor(im,i,j,0);
				}
			}
		}
	}
	/*
	//Suppression des zones isoles de taille 2x2 pixels
	for (i=2;i<l-1;i++)
	{
		for (j=2;j<h-1;j++)
		{
			w=getpixelcolor(im,i,j)&255;
			if (w==255)
			{
				//On calcule les coefficients de nettoyage (masque)
				M[0][0]=(getpixelcolor(im,i-2,j-2)&255)>>7;M[0][1]=(getpixelcolor(im,i-2,j-1)&255)>>7;M[0][2]=(getpixelcolor(im,i-2,j)&255)>>7;M[0][3]=(getpixelcolor(im,i-2,j+1)&255)>>7;
				M[1][0]=(getpixelcolor(im,i-1,j-2)&255)>>7;M[1][1]=(getpixelcolor(im,i-1,j-1)&255)>>7;M[1][2]=(getpixelcolor(im,i-1,j)&255)>>7;M[1][3]=(getpixelcolor(im,i-1,j+1)&255)>>7;
				M[2][0]=(getpixelcolor(im,i,j-2)&255)>>7;  M[2][1]=(getpixelcolor(im,i,j-1)&255)>>7;  M[2][2]=(getpixelcolor(im,i,j)&255)>>7;  M[2][3]=(getpixelcolor(im,i,j+1)&255)>>7;
				M[3][0]=(getpixelcolor(im,i+1,j-2)&255)>>7;M[3][1]=(getpixelcolor(im,i+1,j-1)&255)>>7;M[3][2]=(getpixelcolor(im,i+1,j)&255)>>7;M[3][3]=(getpixelcolor(im,i+1,j+1)&255)>>7;

				k=2*M[0][0]+4*M[0][1]+8*M[0][2]+256*M[1][0]+1*M[1][1]+16*M[1][2]+128*M[2][0]+64*M[2][1]+32*M[2][2]+512*M[3][0]+1024*M[3][1]+2048*M[3][2]+4096*M[3][3]+8192*M[2][3]+16384*M[1][3]+32768*M[0][3];
				//On superpose les masques
				if (k==1+16+32+64)
				{
					setpixelcolor(im,i,j,0);
				}
			}
		}
	}

	*/
}
