// ProfilDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ProfilDlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CProfilDlg dialog
CProfilDlg::CProfilDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProfilDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProfilDlg)
	m_s = _T("");
	m_OKGaussH = FALSE;
	m_OKGaussV = FALSE;
	m_OKProfilH = FALSE;
	m_OKProfilV = FALSE;
	m_radioRouge = -1;
	m_OKExcel = FALSE;
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_PROFIL,pParent);
}
void CProfilDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProfilDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Check(pDX, IDC_GAUSSH, m_OKGaussH);
	DDX_Check(pDX, IDC_GAUSSV, m_OKGaussV);
	DDX_Check(pDX, IDC_PROFILH, m_OKProfilH);
	DDX_Check(pDX, IDC_PROFILV, m_OKProfilV);
	DDX_Radio(pDX, IDC_ROUG, m_radioRouge);
	DDX_Check(pDX, IDC_EXCEL, m_OKExcel);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CProfilDlg, CDialog)
	//{{AFX_MSG_MAP(CProfilDlg)
	ON_BN_CLICKED(IDC_ROUG, OnRoug)
	ON_BN_CLICKED(IDC_VERT, OnVert)
	ON_BN_CLICKED(IDC_BLEU, OnBleu)
	ON_BN_CLICKED(IDC_GAUSSH, OnGaussh)
	ON_BN_CLICKED(IDC_GAUSSV, OnGaussv)
	ON_BN_CLICKED(IDC_PROFILH, OnProfilh)
	ON_BN_CLICKED(IDC_PROFILV, OnProfilv)
	ON_BN_CLICKED(IDC_EXCEL, OnExcel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CProfilDlg message handlers
void CProfilDlg::PostNcDestroy()
{
	delete this;
}
//_______________________________________
BOOL CProfilDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	MAJ();

	//IMPORTANT: Voir CBkApp::InitInstance() et stdafx.h
	m_pAppli=new _Application();

	return TRUE;
}
//________________________________________
void CProfilDlg::OnCancel() 
{
	CDialog::OnCancel();
	m_pApp->m_pProfilDlg=NULL;	
	if (m_OKExcel) m_pAppli->Quit();
	delete m_pAppli;
}
//________________________________________
void CProfilDlg::MAJ()
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_s.Format("(%d)",pDoc->m_iNo);
		//Affectation paramtres courants
		m_radioRouge=pDoc->m_p.radioRouge;
		m_s.Format("Digitalisez un segment  la souris sur l'image %d...",pDoc->m_iNo);
		if (pDoc->m_iNbB==8)
		{
			GetDlgItem(IDC_VERT)->EnableWindow(FALSE);
			GetDlgItem(IDC_BLEU)->EnableWindow(FALSE);
		}
		else
		{
			GetDlgItem(IDC_VERT)->EnableWindow(TRUE);
			GetDlgItem(IDC_BLEU)->EnableWindow(TRUE);
		}
		if (pDoc->m_iType&2) m_OKExcel=TRUE; else m_OKExcel=FALSE;
		if (pDoc->m_iType&4) m_OKProfilH=TRUE; else m_OKProfilH=FALSE; 
		if (pDoc->m_iType&16) m_OKGaussH=TRUE; else m_OKGaussH=FALSE;  
		if (pDoc->m_iType&8) m_OKProfilV=TRUE; else m_OKProfilV=FALSE; 
		if (pDoc->m_iType&32) m_OKGaussV=TRUE; else m_OKGaussV=FALSE;
		//Si aucun profil slectionn, on slectionne PROFIL H
		if (!m_OKProfilH && !m_OKProfilV && !m_OKGaussH && !m_OKGaussV) 
		{
			m_OKProfilH=TRUE;
			pDoc->m_iType=pDoc->m_iType+4;
		}
		m_iX1=pDoc->m_p.iX1;
		m_iY1=pDoc->m_p.iY1;
		m_iX2=pDoc->m_p.iX2;
		m_iY2=pDoc->m_p.iY2;
		pDoc->m_p.OK=FALSE;
	}
	UpdateData(FALSE);
}
//________________________________________
void CProfilDlg::Affecte(short X1,short Y1,short X2,short Y2)
{
	short i;
	//UpdateData(TRUE);
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_s.Format("Digitalisation: Pt1(%d,%d) - Pt2(%d,%d)",X1,Y1,X2,Y2);
		m_iX1=X1;m_iX2=X2;m_iY1=Y1;m_iY2=Y2;
		pDoc->m_p.iX1=X1;pDoc->m_p.iY1=Y1;
		pDoc->m_p.iX2=X2;pDoc->m_p.iY2=Y2;
		UpdateData(FALSE);
	}
}
//________________________________________
void CProfilDlg::OnRoug() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_radioRouge=0;	
		pDoc->m_p.radioRouge=m_radioRouge;
	}
}
//________________________________________
void CProfilDlg::OnVert() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_radioRouge=1;	
		pDoc->m_p.radioRouge=m_radioRouge;
	}
}
//________________________________________
void CProfilDlg::OnBleu() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_radioRouge=2;	
		pDoc->m_p.radioRouge=m_radioRouge;
	}
}
//________________________________________
void CProfilDlg::OnGaussh() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		UpdateData(TRUE);
		//Bit 4=16
		if (m_OKGaussH)
			pDoc->m_iType=pDoc->m_iType+16;	
		else
			pDoc->m_iType=pDoc->m_iType-16;	
	}
}
//________________________________________
void CProfilDlg::OnGaussv() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		UpdateData(TRUE);
		//Bit 5=32
		if (m_OKGaussV) 
			pDoc->m_iType=pDoc->m_iType+32;	
		else
			pDoc->m_iType=pDoc->m_iType-32;	
	}
}
//________________________________________
void CProfilDlg::OnProfilh() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		UpdateData(TRUE);
		//Bit 2=4
		if (m_OKProfilH)
			pDoc->m_iType=pDoc->m_iType+4;
		else
			pDoc->m_iType=pDoc->m_iType-4;	
	}
}
//________________________________________
void CProfilDlg::OnProfilv() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		UpdateData(TRUE);
		//Bit 3=8
		if (m_OKProfilV)
			pDoc->m_iType=pDoc->m_iType+8;
		else
			pDoc->m_iType=pDoc->m_iType-8;
	}
}
//________________________________________
void CProfilDlg::OnExcel() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		UpdateData(TRUE);
		//Bit 1=2
		if (m_OKExcel)
			pDoc->m_iType=pDoc->m_iType+2;
		else
			pDoc->m_iType=pDoc->m_iType-2;
	}
}
//________________________________________
void CProfilDlg::OnOK() 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		//pDoc->CalculProfils(pDoc->m_iType,m_radioRouge,pDoc->m_p.iX1,pDoc->m_p.iY1,pDoc->m_p.iX2,pDoc->m_p.iY2);
		pDoc->m_p.OK=TRUE;
		m_pApp->m_pProfilDlg=NULL;
		pDoc->UpdateAllViews(NULL);
		if (m_OKExcel)
		{
			m_s.Format("Exportation vers Excel en cours...");
			UpdateData(FALSE);
			m_btnOK.EnableWindow(FALSE);
			EcritureExcel();
			m_s.Format("Fichier Excel cr...");
			UpdateData(FALSE);
		}
		else
		{
			delete m_pAppli;
			CDialog::OnOK();
		}
	}
}
//________________________________________
void CProfilDlg::EcritureExcel(void) 
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		CString s1,s2,s3,s4,s5,s6;
		Range range,range1,range2,range3,range4,range5,range6;
		Workbooks books;
		_Workbook book;
		Worksheets sheets;
		_Worksheet sheet;

		COleVariant 
			covTrue((short)TRUE),
			covFalse((short)FALSE),
			covOptional((long)DISP_E_PARAMNOTFOUND,VT_ERROR);
		if (!m_pAppli->CreateDispatch("Excel.Application"))
		{
			AfxMessageBox("Erreur de dmarrage Excel");
		}
		else
		{
			m_pAppli->SetVisible(TRUE);
			books=m_pAppli->GetWorkbooks();
			book=books.Add(covOptional); 
			sheets=m_pAppli->GetSheets();
			//m_pAppli->SetSheetsInNewWorkbook(1);
			sheet=sheets.GetItem(COleVariant((short)1));
			sheet.SetName("Profil(s)");

			range=sheet.GetRange(COleVariant("A1"),COleVariant("A1"));
			range.SetValue(COleVariant("LOGICIEL VISUIM"));

			range1=sheet.GetRange(COleVariant("A2"),COleVariant("A2"));
			range2=sheet.GetRange(COleVariant("B2"),COleVariant("B2"));
			range3=sheet.GetRange(COleVariant("C2"),COleVariant("C2"));
			range4=sheet.GetRange(COleVariant("D2"),COleVariant("D2"));
			range5=sheet.GetRange(COleVariant("E2"),COleVariant("E2"));
			range6=sheet.GetRange(COleVariant("F2"),COleVariant("F2"));

			s1=s2=s3=s4=s5=s6="";
			//Units
			if (pDoc->m_OKXY)
			{
				if (m_OKProfilH || m_OKGaussH) s1="x(mm)";
				if (m_OKProfilV || m_OKGaussV) s4="y(mm)";
			}
			else
			{
				if (m_OKProfilH || m_OKGaussH) s1="iH(pixel)";
				if (m_OKProfilV || m_OKGaussV) s4="jV(pixel)";
			}

			//Units
			if (pDoc->m_OKZ)
			{
				if (m_OKProfilH) s2="zH(mm)";
				if (m_OKGaussH) s3="GaussH(mm)";
				if (m_OKProfilV) s5="zV(mm)";
				if (m_OKGaussV) s6="GaussV(mm)";
			}
			else
			{
				if (m_OKProfilH) s2="wH(luminance)";
				if (m_OKGaussH) s3="GaussH";
				if (m_OKProfilV) s5="wV(luminance)";
				if (m_OKGaussV) s6="GaussV";
			}
			range1.SetValue(COleVariant(s1));
			range2.SetValue(COleVariant(s2));
			range3.SetValue(COleVariant(s3));
			range4.SetValue(COleVariant(s4));
			range5.SetValue(COleVariant(s5));
			range6.SetValue(COleVariant(s6));
			short i,nb;
			i=3;
			for (nb=0;nb<=pDoc->m_iNb;nb++)
			{
				s1.Format("A%u",i);
				range1=sheet.GetRange(COleVariant(s1),COleVariant(s1));
				s2.Format("B%u",i);
				range2=sheet.GetRange(COleVariant(s2),COleVariant(s2));
				s3.Format("C%u",i);
				range3=sheet.GetRange(COleVariant(s3),COleVariant(s3));
				s4.Format("D%u",i);
				range4=sheet.GetRange(COleVariant(s4),COleVariant(s4));
				s5.Format("E%u",i);
				range5=sheet.GetRange(COleVariant(s5),COleVariant(s5));
				s6.Format("F%u",i);
				range6=sheet.GetRange(COleVariant(s6),COleVariant(s6));
				//m_fT[0]:iH, [1]:wH,[2]:GaussH, [3]:wV, [4]:jV, [5]:GaussV
				s1=s2=s3=s4=s5=s6="";
				if (pDoc->m_OKXY)
				{
					//mm
					if (pDoc->m_fT[nb][0]!=1e10) s1.Format("%1.3e",pDoc->m_fT[nb][0]/pDoc->m_fEchXY);//xmm
					if (pDoc->m_fT[nb][4]!=1e10) s4.Format("%1.3e",pDoc->m_fT[nb][4]/pDoc->m_fEchXY);//ymm
				}
				else
				{
					//pixel
					if (pDoc->m_fT[nb][0]!=1e10) s1.Format("%1.0f",pDoc->m_fT[nb][0]);//iH
					if (pDoc->m_fT[nb][4]!=1e10) s4.Format("%1.0f",pDoc->m_fT[nb][4]);//jV
				}
				if (pDoc->m_OKZ)
				{
					//mm
					if (pDoc->m_fT[nb][1]!=1e10) s2.Format("%1.3e",pDoc->m_fT[nb][1]/pDoc->m_fEchZ);//ZH(mm)
					if (pDoc->m_fT[nb][2]!=1e10) s3.Format("%1.3e",pDoc->m_fT[nb][2]/pDoc->m_fEchZ);//GaussH(mm)
					if (pDoc->m_fT[nb][3]!=1e10) s5.Format("%1.3e",pDoc->m_fT[nb][3]/pDoc->m_fEchZ);//zV(mm)
					if (pDoc->m_fT[nb][5]!=1e10) s6.Format("%1.3e",pDoc->m_fT[nb][5]/pDoc->m_fEchZ);//GaussV(mm)*pDoc->m_fEchZ
				}
				else
				{
					//luminance
					if (pDoc->m_fT[nb][1]!=1e10) s2.Format("%1.0f",pDoc->m_fT[nb][1]);//wH
					if (pDoc->m_fT[nb][2]!=1e10) s3.Format("%1.0f",pDoc->m_fT[nb][2]);//GaussH
					if (pDoc->m_fT[nb][3]!=1e10) s5.Format("%1.0f",pDoc->m_fT[nb][3]);//wV
					if (pDoc->m_fT[nb][5]!=1e10) s6.Format("%1.0f",pDoc->m_fT[nb][5]);//GaussV
				}
				range1.SetValue(COleVariant(s1));
				range2.SetValue(COleVariant(s2));
				range3.SetValue(COleVariant(s3));
				range4.SetValue(COleVariant(s4));
				range5.SetValue(COleVariant(s5));
				range6.SetValue(COleVariant(s6));
				i++;
			}
			//Trac des graphes
			Charts charts;
			VARIANT v;
			_Chart chart1,chart2;
			charts=m_pAppli->GetCharts();
			//Units absisses
			if (pDoc->m_OKXY)
			{
				s3="iH(mm)";
				s4="0.0E+0";
			}
			else
			{
				s3="iH(pixel)";
				s4="0";
			}
			if (pDoc->m_OKZ)
			{
				s5="0.0E+0";
			}
			else
			{
				s5="0";
			}
			//Plage de donnes profil horizontal
			if (m_OKProfilH || m_OKGaussH)
			{
				v=COleVariant((short)(1));//1: Nb. de sheets  ajouter
				chart1=charts.Add(covOptional,covOptional,v);
				chart1.SetVisible(FALSE);
			}
			if (m_OKProfilH)
			{
				s1.Format("A2:A%u",pDoc->m_iNb+2);
				s2.Format("B2:B%u",pDoc->m_iNb+2);
				//											Plage de donnes
				//															Titre du graphe
				//																								Titre de la feuille
				//																															Titre axe des absisses
				GrapheExcel(sheet,chart1,s1,s2,"Profil horizontal","Trac horiz.",s3,s4,s5);
			}
			if (m_OKGaussH)
			{
				s1.Format("A2:A%u",pDoc->m_iNb+2);
				s2.Format("C2:C%u",pDoc->m_iNb+2);
				GrapheExcel(sheet,chart1,s1,s2,"Profil horizontal","Trac horiz.",s3,s4,s5);
			}
			//Units absisses
			if (pDoc->m_OKXY)
				s3="jV(mm)";
			else
				s3="jV(pixel)";
			//Plage de donnes profil vertical
			if (m_OKProfilV || m_OKGaussV)
			{
				v=COleVariant((short)(1));//1: Nb. de sheets  ajouter
				chart2=charts.Add(covOptional,covOptional,v);
				chart2.SetVisible(FALSE);
			}	
			if (m_OKProfilV)
			{
				s1.Format("D2:D%u",pDoc->m_iNb+2);
				s2.Format("E2:E%u",pDoc->m_iNb+2);
				GrapheExcel(sheet,chart2,s1,s2,"Profil vertical\n(A tourner dans le sens horaire)","Trac vert.",s3,s4,s5);
			}
			if (m_OKGaussV)
			{
				s1.Format("D2:D%u",pDoc->m_iNb+2);
				s2.Format("F2:F%u",pDoc->m_iNb+2);
				GrapheExcel(sheet,chart2,s1,s2,"Profil vertical\n(A tourner dans le sens horaire)","Trac vert.",s3,s4,s5);
			}
			//Pour ne pas avoir une demande automatique de sauvegarde...
			book.SetSaved(TRUE);
		}
	}
}
//_________________________________________________
void CProfilDlg::GrapheExcel(_Worksheet sheet,_Chart chart,CString plage1,CString plage2,CString titre,CString nom,CString abs,CString FormatX,CString FormatY) 
{
	COleVariant 
		covTrue((short)TRUE),
		covFalse((short)FALSE),
		covOptional((long)DISP_E_PARAMNOTFOUND,VT_ERROR);
	LPDISPATCH pdisp;
	Axis axis;
	TickLabels tick;
	VARIANT v,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11;
	Font fonte;
	PlotArea aire;
	Interior interieur;

	
	pdisp=sheet.GetRange(COleVariant(plage1),COleVariant(plage2));
	v1=COleVariant((short)(2));//Donnes en colonnes
	chart.ApplyCustomType(-4169,covOptional);
	chart.SetSourceData(pdisp,v1);
	v2=COleVariant((long)(-4169));//Nuage de points
	v3=COleVariant((short)(6));//Format: 1: points uniquement, 2:points relis, 4 & 5: chelles log, 6: courbe uniquement,7,8,9: !!
	v4=COleVariant((short)(2));//Donnes en colonnes
	v5=COleVariant((short)(1));//Donnes en colonnes
	v6=COleVariant((short)(1));//Donnes en colonnes
	v7=covTrue;//Avec noms des sries
	v8=COleVariant(titre);
	v9=COleVariant(abs);//Category axis title text.
	v10=covOptional;
	v11=covOptional;
	chart.ChartWizard(covOptional,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11);
	chart.SetName(nom);
	chart.SetVisible(FALSE);
	//Absisse__________________________________________
	v=COleVariant((short)(1));
	axis=chart.Axes(v,1);//Grille absisses
	axis.SetHasMajorGridlines(TRUE);
	tick=axis.GetTickLabels();
	tick.SetNumberFormat(FormatX);//Format division absisse
	//Ordonne_______________________________________
	v=COleVariant((short)(2));
	axis=chart.Axes(v,1);//Grille ordonne
	axis.SetHasMajorGridlines(TRUE);
	fonte=tick.GetFont();
	v=COleVariant((short)(9));
	fonte.SetSize(v);
	tick=axis.GetTickLabels();
	tick.SetNumberFormat(FormatY);//Format division ordonne 
	fonte=tick.GetFont();
	v=COleVariant((short)(9));
	fonte.SetSize(v);
	aire=chart.GetPlotArea();
	interieur=aire.GetInterior();
	//v=COleVariant((long)RGB(220,220,220));//Gris
	//v=COleVariant((long)RGB(255,255,200));//Jaune clair
	v=COleVariant((long)RGB(228,230,189));//Vert clair
	//v=COleVariant((long)RGB(164,223,255));//Bleu clair
	interieur.SetColor(v);
	chart.SetVisible(TRUE);
	chart.Select(covOptional);
}
