// PseuDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "PseuDlg.h"
#include "BkDoc.h"
#include "Vicdefs.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CPseuDlg dialog
CPseuDlg::CPseuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPseuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPseuDlg)
	m_sTexte = _T("");
	m_sNb = _T("");
	//}}AFX_DATA_INIT
}
void CPseuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPseuDlg)
	DDX_Control(pDX, IDVISU, m_btnVisu);
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Text(pDX, IDC_STATIC_NB, m_sNb);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPseuDlg, CDialog)
	//{{AFX_MSG_MAP(CPseuDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDVISU, OnVisu)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CPseuDlg message handlers
BOOL CPseuDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j,rcode;
	CString s;

	m_pApp=((CBkApp*)AfxGetApp());
	m_iNo=m_pApp->m_iNo;
	m_ps=m_pApp->GetDocument();
	m_sTexte.Format("Image live: %d",m_iNo);

	m_OKP=TRUE;
	m_iI=new short[m_pApp->m_iNbMax];
	//Initialisation tableau N images
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		m_iI[i]=-1;
	}                 
	j=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)!=NULL && i!=m_iNo)
		{
			s.Format("Image %d",i);	
			m_comboDest.AddString(s);
			m_iI[j]=i;
			j++;
		}         
	}
	//Recherche N nouvelle image destination
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)==NULL)
		{
			s.Format("IMAGE %d",i);	
			m_comboDest.AddString(s);
			//Image destination
			m_iI[j]=i;
			//On sort
			i=m_pApp->m_iNbMax;    
		}
	}
	//Par dfaut sur nouvelle image
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CPseuDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CPseuDlg::OnCancel() 
{
	if (m_OKP==FALSE) KillTimer(1);
	delete m_iI;
	CDialog::OnCancel();
}
//________________________________________
void CPseuDlg::OnTimer(UINT nIDEvent) 
{
	short i,j;
	long w;
	unsigned char R,V,B;

	if (m_OK)
	{
		m_OK=FALSE;
		m_iNb++;
		m_sNb.Format("(%d)",m_iNb);
		//Acq. d'une image dans m_ps
		if (m_pApp->m_OKCarte) AcqPerm();
		if (m_pApp->m_OKCarte) AcqFig();
		for (i=m_ps->image->stx;i<=m_ps->image->endx;i++)
		{
			for (j=m_ps->image->sty;j<=m_ps->image->endy;j++)
			{
				w=getpixelcolor(m_ps->image,i,j);
				m_pApp->PseudoCoul(w,&R,&V,&B);
				w=(long)R+256*V+65536*B;
				setpixelcolor(m_pd->image,i,j,w);
			}
		}
		UpdateData(FALSE);
		//m_pd->UpdateAllViews(NULL);
		m_pd->m_pView->MAJ_Fen();
		m_OK=TRUE;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CPseuDlg::AcqPerm(void) 
{
	m_ps->AcqPerm();
}
//________________________________________
void CPseuDlg::AcqFig(void) 
{
	m_ps->FigerAcq();
}
//________________________________________
void CPseuDlg::PremiereFois() 
{
	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	//Image source: m_iNo,m_ps
	//Image destination
	//Si l'utilisateur n'a pas touch au combo...
	if (m_comboDest.GetCurSel()<0) 
		m_iNod=m_iI[m_comboDest.GetCount()-1];
	else
		m_iNod=m_iI[m_comboDest.GetCurSel()];
	//Si la fentre destination n'existe pas, il faut la crer...
	if (m_pApp->GetDocument(m_iNod)==NULL)
	{
		//L'image destination existe maintenant.
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		m_pd=m_pApp->m_pDocument[m_iNod];
	}
	else
	{
		//Pointeur sur destination
		m_pd=m_pApp->m_pDocument[m_iNod];
	}

	short l,h,nbB;
	l=m_ps->image->endx-m_ps->image->stx+1;
	h=m_ps->image->endy-m_ps->image->sty+1;
	nbB=m_ps->image->bmh->biBitCount;
	m_pd->InitialiserImage(l,h,24);
	//Dimensionner l'image destination  la taille source
	m_pd->DimensionnerFenetre(l,h);
	m_pd->DefinirCurseurs(l,h);
	m_pd->m_iType=0;
	m_pd->m_sNomFic.Format("Pseudo");
	m_pd->InitTracker();//Pas de tracker sur la destination...

	m_ps->m_sNomFic.Format("SansNom%d",m_iNo);
	m_ps->PositionnerFenetre(l+15,0);
	m_pd->PositionnerFenetre(0,0);

	m_btnVisu.EnableWindow(FALSE);
}
//________________________________________
void CPseuDlg::OnVisu() 
{
	if (m_OKP)
	{
		//La premire fois
		m_OKP=FALSE;
		//Cration fentre destination
		PremiereFois();
		m_OK=TRUE;SetTimer(1,300,NULL);
	}
	//Acquisition d'une rfrence
	m_iNb=0;
}
