// SeuilDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "SeuilDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Vicdefs.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CSeuilDlg dialog
CSeuilDlg::CSeuilDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSeuilDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSeuilDlg)
	m_iW = 0;
	m_s1 = _T("");
	m_iSup = 0;
	m_iInf = 0;
	//}}AFX_DATA_INIT
}
//________________________________________
void CSeuilDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSeuilDlg)
	DDX_Control(pDX, IDC_CURSEUR, m_curseur);
	DDX_Control(pDX, IDAPPLIQUER, m_btnAppliquer);
	DDX_Text(pDX, IDC_W, m_iW);
	DDX_Text(pDX, IDC_STATIC_TEXTE3, m_s1);
	DDX_Text(pDX, IDC_WSUP, m_iSup);
	DDX_Text(pDX, IDC_WINF, m_iInf);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CSeuilDlg, CDialog)
	//{{AFX_MSG_MAP(CSeuilDlg)
	ON_BN_CLICKED(IDAPPLIQUER, OnAppliquer)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CSeuilDlg message handlers
BOOL CSeuilDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//Pointeur sur l'application
	m_pApp=((CBkApp*)AfxGetApp());
	//Pointeur sur le document
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	//Pointeur sur la vue
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pDoc!=NULL)
	{
		m_s1.Format("(%d)",m_pDoc->m_iNo);
		if (m_pDoc->image->bmh->biBitCount!=8) AfxMessageBox("Attention, votre image source n'est pas en nuances de gris !\nVous devriez la convertir...");
	}
	//Image originale dans imt[6]
	m_pApp->DupliquerImageDestTempo(m_pDoc->m_iNo,6);
	m_iInf=0;
	m_iSup=255;
	m_iW=m_pApp->m_iSeuil;
	m_curseur.SetRange(0,255);
	m_curseur.SetPos(m_iW);

	UpdateData(FALSE);
	m_pApp->m_bBusy=FALSE;
	Seuil(m_iW,m_iInf,m_iSup);
	return TRUE;
}
//________________________________________
void CSeuilDlg::OnAppliquer() 
{
	if (m_pView!=NULL && m_pDoc!=NULL)
	{
		UpdateData(TRUE);
		if (m_iW<0) m_iW=0;
		if (m_iW>255) m_iW=255;
		if (m_iInf<0) m_iInf=0;
		if (m_iInf>m_iW) m_iInf=m_iW;
		if (m_iSup>255) m_iSup=255;
		if (m_iSup<m_iW) m_iSup=m_iW;

		UpdateData(FALSE);
		Seuil(m_iW,m_iInf,m_iSup);
	}
}
//________________________________________
void CSeuilDlg::OnCancel() 
{
	//On annule
	copyimage(m_pApp->imt[6],m_pDoc->image);	
	CDialog::OnCancel();
}
//________________________________________
void CSeuilDlg::OnOK() 
{
	m_pApp->m_iSeuil=m_iW;
	CDialog::OnOK();
}
//________________________________________
void CSeuilDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateData(TRUE);
	m_iW=m_curseur.GetPos();

	if (m_iW<0) m_iW=0;
	if (m_iW>255) m_iW=255;
	if (m_iInf<0) m_iInf=0;
	if (m_iInf>m_iW) m_iInf=m_iW;
	if (m_iSup>255) m_iSup=255;
	if (m_iSup<m_iW) m_iSup=m_iW;

	UpdateData(FALSE);
	if (m_pView!=NULL && m_pDoc!=NULL)
	{
		Seuil(m_iW,m_iInf,m_iSup);
	}	
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CSeuilDlg::Seuil(short ws,short winf,short wsup) 
{
	long w=0;
	short 
		l,h,
		i,j;
	if (m_pApp->m_bBusy) return ;	
	if (m_pView!=NULL && m_pDoc!=NULL)
	{
		m_pApp->m_bBusy=TRUE;
		copyimage(m_pApp->imt[6],m_pDoc->image);	
		//UpdateData(TRUE);
		l=m_pDoc->image->endx-m_pDoc->image->stx+1;
		h=m_pDoc->image->endy-m_pDoc->image->sty+1;
		if (ws<0) ws=0;
		if (ws>255) ws=255;
		if (winf<0) winf=0;
		if (winf>ws) winf=ws;
		if (wsup>255) wsup=255;
		if (wsup<ws) wsup=ws;
		//Calcul de l'image seuille
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				w=getpixelcolor(m_pDoc->image,i,j)&255;
				if (w>=ws) 
					setpixelcolor(m_pDoc->image,i,j,wsup);
				else
					setpixelcolor(m_pDoc->image,i,j,winf);
			}
		}
		m_pView->MAJ_Fen();
		m_pApp->m_bBusy=FALSE;
	}
}
