// TemReDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "TemReDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
////////////////////////////////////////////////////
// CTemReDlg dialog
CTemReDlg::CTemReDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTemReDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTemReDlg)
	m_sTexte = _T("");
	m_sNb = _T("");
	m_sGain = _T("");
	//}}AFX_DATA_INIT
}
void CTemReDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemReDlg)
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Text(pDX, IDC_STATIC_NB, m_sNb);
	DDX_Text(pDX, IDC_GAIN, m_sGain);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTemReDlg, CDialog)
	//{{AFX_MSG_MAP(CTemReDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDACQREF, OnAcqref)
	ON_EN_CHANGE(IDC_GAIN, OnChangeGain)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CTemReDlg message handlers
BOOL CTemReDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j,rcode;
	CString s;

	m_pApp=((CBkApp*)AfxGetApp());
	m_iNo=m_pApp->m_iNo;
	m_ps=m_pApp->GetDocument();
	m_sTexte.Format("Image live: %d",m_iNo);

	short 
		l,h,nbB,
		l1,h1,nbB1;
	l=m_ps->image->endx-m_ps->image->stx+1;
	h=m_ps->image->endy-m_ps->image->sty+1;
	nbB=m_ps->image->bmh->biBitCount;

	l1=m_pApp->imt[0]->endx-m_pApp->imt[0]->stx+1;
	h1=m_pApp->imt[0]->endy-m_pApp->imt[0]->sty+1;
	nbB1=m_pApp->imt[0]->bmh->biBitCount;

	if (l!=l1 || h!=h1 || nbB!=nbB1)
	{
		freeimage(m_pApp->imt[0]);
		rcode=allocimage(m_pApp->imt[0],l,h,nbB);
	}
	m_iGain=5;
	m_sGain.Format("%d",m_iGain);
	m_OKP=TRUE;

	m_iI=new short[m_pApp->m_iNbMax];
	//Initialisation tableau N images
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		m_iI[i]=-1;
	}                 
	j=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)!=NULL && i!=m_iNo)
		{
			s.Format("Image %d",i);	
			m_comboDest.AddString(s);
			m_iI[j]=i;
			j++;
		}         
	}
	//Recherche N nouvelle image destination
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)==NULL)
		{
			s.Format("IMAGE %d",i);	
			m_comboDest.AddString(s);
			//Image destination
			m_iI[j]=i;
			//On sort
			i=m_pApp->m_iNbMax;    
		}
	}
	//Par dfaut sur nouvelle image
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CTemReDlg::OnCancel() 
{
	if (m_OKP==FALSE) KillTimer(1);
	delete m_iI;
	CDialog::OnCancel();
}
//________________________________________
void CTemReDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CTemReDlg::OnTimer(UINT nIDEvent) 
{
	short i,j;
	long w;

	m_iNb++;
	m_sNb.Format("(%d)",m_iNb);
	//Acq. d'une image dans m_ps
	if (m_pApp->m_OKCarte) m_ps->AcqPerm();
	if (m_pApp->m_OKCarte) m_ps->FigerAcq();
	//On soustrait cette image  la rfrence et on la multiplie par le gain
	for (i=m_ps->image->stx;i<=m_ps->image->endx;i++)
	{
		for (j=m_ps->image->sty;j<=m_ps->image->endy;j++)
		{
			w=abs(getpixelcolor(m_ps->image,i,j)-getpixelcolor(m_pApp->imt[0],i,j));
			w=w*m_iGain;
			if (w>255) w=255;
			setpixelcolor(m_pd->image,i,j,w);
		}
	}
	UpdateData(FALSE);
	//m_pd->UpdateAllViews(NULL);
	m_pd->m_pView->MAJ_Fen();
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CTemReDlg::OnAcqref() 
{
	if (m_OKP)
	{
		//La premire fois
		m_OKP=FALSE;
		//Cration fentre destination
		PremiereFois();
		SetTimer(1,300,NULL);
	}
	//Acquisition d'une rfrence
	m_iNb=0;
	m_ps->AcqPerm();
	m_ps->FigerAcq();
	//L'image est maintenant dans m_ps->image;
	//On la copie dans la rfrence
	copyimage(m_ps->image,m_pApp->imt[0]);
}
//________________________________________
void CTemReDlg::OnChangeGain() 
{
	//Vrification de la validit du changement de gain
	int i,j;
	UpdateData(TRUE);
	if (m_sGain.GetLength()>0)
	{
		j=sscanf(m_sGain,"%d",&i);
		if (j==0)
			m_iGain=1;
		else
			m_iGain=abs(i);
		m_sGain.Format("%d",m_iGain);
	}
	else
	{
		m_iGain=1;
		m_sGain="1";
	}
	UpdateData(FALSE);
}
//________________________________________
void CTemReDlg::PremiereFois() 
{
	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	//Image source: m_iNo,m_ps
	//Image destination
	//Si l'utilisateur n'a pas touch au combo...
	if (m_comboDest.GetCurSel()<0) 
		m_iNod=m_iI[m_comboDest.GetCount()-1];
	else
		m_iNod=m_iI[m_comboDest.GetCurSel()];
	//Si la fentre destination n'existe pas, il faut la crer...
	if (m_pApp->GetDocument(m_iNod)==NULL)
	{
		//L'image destination existe maintenant.
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		m_pd=m_pApp->m_pDocument[m_iNod];
	}
	else
	{
		//Pointeur sur destination
		m_pd=m_pApp->m_pDocument[m_iNod];
	}

	short l,h,nbB;
	l=m_ps->image->endx-m_ps->image->stx+1;
	h=m_ps->image->endy-m_ps->image->sty+1;
	nbB=m_ps->image->bmh->biBitCount;
	m_pd->InitialiserImage(l,h,8);
	//Dimensionner l'image destination  la taille source
	m_pd->DimensionnerFenetre(l,h);
	m_pd->DefinirCurseurs(l,h);
	m_pd->m_iType=0;
	m_pd->m_sNomFic.Format("TempsRel");
	m_pd->InitTracker();//Pas de tracker sur la destination...

	m_ps->m_sNomFic.Format("SansNom%d",m_iNo);
	m_ps->PositionnerFenetre(l+15,0);
	m_pd->PositionnerFenetre(0,0);
}
