// ZoomDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ZoomDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
///////////////////////////////////////////////////
// CZoomDlg dialog
CZoomDlg::CZoomDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZoomDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZoomDlg)
	m_s = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_ZOOM,pParent);
}
void CZoomDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZoomDlg)
	DDX_Control(pDX, IDORIGINAL, m_btnOri);
	DDX_Control(pDX, IDZOOMPLUS, m_btnZoomPlus);
	DDX_Control(pDX, IDZOOMMOINS, m_btnZoomMoins);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CZoomDlg, CDialog)
	//{{AFX_MSG_MAP(CZoomDlg)
	ON_BN_CLICKED(IDZOOMPLUS, OnZoomplus)
	ON_BN_CLICKED(IDZOOMMOINS, OnZoommoins)
	ON_BN_CLICKED(IDORIGINAL, OnOriginal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CZoomDlg message handlers
void CZoomDlg::PostNcDestroy()
{
	if (m_OK)
	{
		delete[] m_OKZoom;	
		delete[] m_fCoef;
		m_OK=FALSE;	
	}
	delete this;
}
//________________________________________
void CZoomDlg::MAJ()
{
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
	if (pDoc!=NULL)
		m_s.Format("(%d)\nCoef: %1.2f\nCliquer sur Image originale pour annuler le zoom.",pDoc->m_iNo,m_fCoef[pDoc->m_iNo]);
	UpdateData(FALSE);
}
//_________________________________________________
void CZoomDlg::Zoom()
{
	short 
		l,h,l1,h1,
		no;
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		no=pDoc->m_iNo;
		l=m_pApp->imt[no]->endx-m_pApp->image[no]->stx+1;
		h=m_pApp->imt[no]->endy-m_pApp->image[no]->sty+1;

		
		
		l1=(short)(1.0*l*m_fCoef[no]);
		h1=(short)(1.0*h*m_fCoef[no]);

		//La largeur minimale de la fentre est limite  140 pixels
		if (l1<=140)
		{
			m_btnZoomMoins.EnableWindow(FALSE);
		}
		else
		{
			m_btnZoomMoins.EnableWindow(TRUE);
			freeimage(m_pApp->image[no]);
			pDoc->m_iL=l1;
			pDoc->m_iH=h1;
			allocimage(m_pApp->image[no],l1,h1,m_pApp->imt[no]->bmh->biBitCount);
			resize(m_pApp->imt[no],m_pApp->image[no]);
			pDoc->DefinirCurseurs(l1,h1);
			if (l1<l || h1<h)
				pDoc->DimensionnerFenetre(l1,h1);
			else
				pDoc->DimensionnerFenetre(l,h);
		}
	}
}
//_________________________________________________
void CZoomDlg::PremiereFois()
{
	short 
		i,l,h,nbB,l1,h1,nbB1,
		no;

	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		no=pDoc->m_iNo;	
		if (!m_OKZoom[no])
		{
			//Suppression des profils et cotes
			pDoc->m_iType=0;		
			//Suppression calibration
			pDoc->m_OKXY=pDoc->m_OKZ=FALSE;

			l=m_pApp->image[no]->endx-m_pApp->image[no]->stx+1;
			h=m_pApp->image[no]->endy-m_pApp->image[no]->sty+1;
			nbB=m_pApp->image[no]->bmh->biBitCount;
			l1=m_pApp->imt[no]->endx-m_pApp->image[no]->stx+1;
			h1=m_pApp->imt[no]->endy-m_pApp->image[no]->sty+1;
			nbB1=m_pApp->imt[no]->bmh->biBitCount;

			m_OKZoom[no]=TRUE;
			//Copie de l'image originale dans l'image temporaire
			if (l!=l1 || h!=h1 || nbB!=nbB1)
			{
				freeimage(m_pApp->imt[no]);
				allocimage(m_pApp->imt[no],l,h,nbB);
			}
			copyimage(m_pApp->image[no],m_pApp->imt[no]);
		}	
	}
}
//_________________________________________________
BOOL CZoomDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i;
	m_pApp=((CBkApp*)AfxGetApp());
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_fCoef=new float[m_pApp->m_iNbMax];
		//Mmorisation des n d'images zoomes
		m_OKZoom=new BOOL[m_pApp->m_iNbMax];
		for (i=0;i<m_pApp->m_iNbMax;i++) 
		{
			m_OKZoom[i]=FALSE;//Pas de zoom sur aucune image
			m_fCoef[i]=1;
		}
		m_OK=TRUE;
		m_btnOri.EnableWindow(FALSE);

		m_s.Format("(%d)\nAttention:\nLes profils, annotations et cotes seront supprims !",pDoc->m_iNo);
		UpdateData(FALSE);
	}
	return TRUE;
}
//_________________________________________________
void CZoomDlg::OnOK() 
{
	//CDialog::OnOK();
}
//_________________________________________________
void CZoomDlg::OnCancel() 
{
	m_pApp->m_pZoomDlg=NULL;
	delete[] m_OKZoom;	
	delete[] m_fCoef;
	m_OK=FALSE;	
	CDialog::OnCancel();
}
//_________________________________________________
void CZoomDlg::OnZoomplus() 
{
	short no;
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_btnOri.EnableWindow(TRUE);
		no=pDoc->m_iNo;	
		if (!m_OKZoom[no])
		{
			PremiereFois();
		}
		m_fCoef[no]=m_fCoef[no]*1.1;
		MAJ();
		//On applique le zoom
		Zoom();
	}	
}
//_________________________________________________
void CZoomDlg::OnZoommoins() 
{
	short no;
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		m_btnOri.EnableWindow(TRUE);
		no=pDoc->m_iNo;	
		if (!m_OKZoom[no])
		{
			PremiereFois();
		}	
		m_fCoef[no]=m_fCoef[no]/1.1;
		MAJ();
		//On applique le zoom
		Zoom();
	}
}
//_________________________________________________
void CZoomDlg::OnOriginal() 
{
	short no;
	class CBkDoc* pDoc;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		no=pDoc->m_iNo;	
		m_fCoef[no]=1;
		MAJ();
		//On applique le zoom
		Zoom();
	}
}
