// DigiDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "DigiDlg.h"
#include "BkDoc.h"
#include "C832.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CDigiDlg dialog
CDigiDlg::CDigiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDigiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDigiDlg)
	m_s = _T("");
	m_s2 = _T("");
	m_sPas = _T("");
	//}}AFX_DATA_INIT
}
void CDigiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDigiDlg)
	DDX_Control(pDX, IDC_PAS, m_editPas);
	DDX_Control(pDX, IDC_DEPLIEE, m_comboDeplie);
	DDX_Control(pDX, IDC_CONTOUR, m_comboContour);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDARRETER, m_btnArreter);
	DDX_Text(pDX, IDC_STATIC1, m_s);
	DDX_Text(pDX, IDC_STATIC2, m_s2);
	DDX_Text(pDX, IDC_PAS, m_sPas);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CDigiDlg, CDialog)
	//{{AFX_MSG_MAP(CDigiDlg)
	ON_BN_CLICKED(IDARRETER, OnArreter)
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CDigiDlg message handlers
BOOL CDigiDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	short n,i,j;
	m_pApp=(CBkApp*)AfxGetApp();
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document courant
  if (pChild) m_ps1=(CBkDoc*)pChild->GetActiveDocument(); else m_ps1=NULL;
  if (!(GetVersion() & 0x80000000))
  {
    //Windows NT, 2000, XP prsent
		//Carte de motorisation ne fonctionne pas sous ces systmes d'exploitation
		m_OKCarte=FALSE;
		m_s.Format("Carte C832 non fonctionnelle sous NT, XP, ...\nLecture fichier flacon.tif si trouv !");
	}
	else
	{
		m_pC832=new CC832(29600);
		m_iNoAxe=2;          
		if (!m_pC832->OK(m_iNoAxe))
		{
			//Carte P.I. non trouve
			delete m_pC832;
			m_OKCarte=FALSE;
			m_s.Format("Carte C832 non trouve !");
		}
		else
		{
			//Carte P.I. OK
			m_OKCarte=TRUE;
			m_s.Format("Carte C832 dtecte !");
			m_pC832->RT(m_iNoAxe);
			m_pC832->IT(m_iNoAxe);
			m_pC832->SV(m_iNoAxe,m_pApp->m_fVit);
			//Origine sur la position courante	
			m_pC832->DH(m_iNoAxe);	
		}
	}
	m_btnArreter.EnableWindow(FALSE);
	m_fPas=m_pApp->m_fPas;
	m_sPas.Format("%1.1f",m_fPas);

	m_is1=m_ps1->m_iNo;
	m_s2.Format("%d",m_is1);

	m_iI=new short[m_pApp->m_iNbMax];
	//Initialisation tableau N images
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		m_iI[i]=-1;
	}                 
	j=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)!=NULL)
		{
			s.Format("Image %d",i);	
			m_comboContour.AddString(s);
			m_comboDeplie.AddString(s);
			m_iI[j]=i;
			j++;
		}         
	}
	//Recherche N nouvelles images
	n=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)==NULL)
		{
			s.Format("IMAGE %d",i);	
			m_comboDeplie.AddString(s);
			m_comboContour.AddString(s);
			m_iI[j]=i;
			j++;
			n++;
			//On sort car on a trouv 3 nouvelles images disponibles
			//L'image in et l'image masque doivent dj exister
			if (n>=2) i=m_pApp->m_iNbMax;    
		}
	}
	//Par dfaut sur dernire image
	m_is2=m_comboContour.GetCount()-2;if (m_is2<0) m_is2=0;
	m_comboContour.GetLBText(m_is2,s);
	m_comboContour.SetWindowText(s);
	//Par dfaut sur avant-dernire
	m_is3=m_comboDeplie.GetCount()-1;if (m_is3<0) m_is3=0;
	m_comboDeplie.GetLBText(m_is3,s);
	m_comboDeplie.SetWindowText(s);	
	m_OKPremiereFois=TRUE;	
	SetTimer(3,200,NULL);
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CDigiDlg::OnOK() 
{
	//Bouton supprim
	//CDialog::OnOK();
}
//________________________________________
void CDigiDlg::OnCancel() 
{
	KillTimer(3);
	delete m_iI;

	if (m_OKCarte) delete m_pC832;
	CDialog::OnCancel();
}
//________________________________________
void CDigiDlg::OnArreter() 
{
	//Arrt du timer des acquisitions et de fin dplacement
	m_OK=FALSE;
	KillTimer(2);
	//KillTimer(4);
	//KillTimer(5);



	m_editPas.EnableWindow(TRUE);
	m_btnArreter.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(TRUE);
	m_btnDemarrer.EnableWindow(TRUE);
	
	m_s.Format("Acquisitions arrtes...");
	UpdateData(FALSE);
	Sleep(500);

	Encadrement(m_ps3->image,&m_iH1,&m_iH2);
	m_s.Format("Encadrement...\n(H1: %d, H2: %d)",m_iH1,m_iH2);
	UpdateData(FALSE);
	Sleep(500);

	m_ps3->m_iH=m_pApp->m_iH;
	m_s.Format("Remplissage...\n%d,%d,%d,%d",m_iH1,m_iH2,(int)(2*m_fAngle),m_ps3->m_iH);
	UpdateData(FALSE);
	Remplissage(m_ps3->image,m_iH1,m_iH2,(int)(2*m_fAngle),m_ps3->m_iH);
}
//________________________________________
void CDigiDlg::OnDemarrer() 
{
	KillTimer(3);
	UpdateData(TRUE);
	int i;
	float r;
	i=sscanf(m_sPas,"%f",&r);
	r=fabs(r);
	if (i==0 || r<0.5 || r>90.0)
		m_fPas=10.0f;
	else
	{
		m_fPas=floor(2*r);
		m_fPas=m_fPas/2;
	}
	m_sPas.Format("%1.1f",m_fPas);
	m_pApp->m_fPas=m_fPas;
	UpdateData(FALSE);

	m_editPas.EnableWindow(FALSE);
	m_btnDemarrer.EnableWindow(FALSE);
	m_btnArreter.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(FALSE);

	if (m_OKPremiereFois) PremiereFois();
	zeroimage(0,m_ps3->image);

	m_fAngle=0;m_OK=TRUE;
	SetTimer(2,40,NULL);
}
//________________________________________
void CDigiDlg::OnTimer(UINT nIDEvent) 
{
	short rcode;
	UpdateData(TRUE);
	switch (nIDEvent)
	{
		case 2:
			KillTimer(2);
			//Acquisition permanente
			m_ps1->AcqPerm();
			if (m_OKCarte)
			{
				//Si la carte C832 est fonctionnelle
				//Dplacement du moteur avec attente d'arrive sur position
				m_pC832->MA(m_iNoAxe,m_fAngle);
				//Modifi pour pouvoir appuyer sur Arrt pendant le mouvement
				//m_pC832->WS1(m_iNoAxe); //Sans test de bute...
			}
			else
			{
				//Pour essai:
				rcode=loadtif("flacon.tif",m_ps1->image);
				m_ps1->UpdateAllViews(NULL);
			}
			SetTimer(4,40,NULL);

		break;
		case 3://Test numros images
			//Si l'utilisateur n'a pas touch aux combos...
			if (m_comboContour.GetCurSel()<0)
				m_is2=m_iI[m_comboContour.GetCount()-2];
			else
				m_is2=m_iI[m_comboContour.GetCurSel()];

			if (m_comboDeplie.GetCurSel()<0)
				m_is3=m_iI[m_comboDeplie.GetCount()-1];
			else
				m_is3=m_iI[m_comboDeplie.GetCurSel()];

			if (m_is1==m_is2 || m_is1==m_is3 || m_is2==m_is1 || m_is2==m_is3 || m_is3==m_is1 || m_is3==m_is2)
				m_btnDemarrer.EnableWindow(FALSE);
			else
				m_btnDemarrer.EnableWindow(TRUE);

		break;
		case 4://Attente fin dplacement
			if (m_OKCarte)
			{
				if (m_pC832->MD(m_iNoAxe))
				{
					//Le mouvement est arriv  destination
					KillTimer(4);
					SetTimer(5,40,NULL);
				}
				else
				if(m_OK)
				{
					//Position courante
					m_s.Format("Angle: %1.1f",m_pC832->TP(m_iNoAxe));
				}
			}
			else
			{
				//La carte P.I. n'est pas prsente, on arrte l'attente...
				KillTimer(4);
				SetTimer(5,40,NULL);
			}
		break;
		case 5://Acquisition profil
			KillTimer(5);
			//Acquisition fige
			m_ps1->FigerAcq();
			//Maintenant, il faut analyser l'image m_ps1

			//Contour dans m_ps2
			Contour();
			//Image dplie dans m_ps3
			Depliement();

			m_s.Format("Angle: %1.1f",m_fAngle);
			if (m_fAngle>=360.1 || m_OK==FALSE)
			{
				//On a fait un tour, on s'arrte
				//KillTimer(2);
				m_btnArreter.EnableWindow(FALSE);
				m_btnCancel.EnableWindow(TRUE);
				m_btnDemarrer.EnableWindow(TRUE);
				m_editPas.EnableWindow(TRUE);
				m_s.Format("Acquisitions termines...");
				UpdateData(FALSE);
				Sleep(500);
				Encadrement(m_ps3->image,&m_iH1,&m_iH2);
				m_s.Format("Encadrement...\n(H1: %d, H2: %d)",m_iH1,m_iH2);
				UpdateData(FALSE);
				Sleep(500);
				m_s.Format("Remplissage...");
				UpdateData(FALSE);
				m_ps3->m_iH=m_pApp->m_iH;
				Remplissage(m_ps3->image,m_iH1,m_iH2,(int)(2*m_fAngle),m_ps3->m_iH);
			}
			else
			{
				m_fAngle=m_fAngle+m_fPas;
				//Ce n'est pas fini, angle suivant
				SetTimer(2,40,NULL);
			}
		break;
	}	
	UpdateData(FALSE);
	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CDigiDlg::PremiereFois(void) 
{
	m_OKPremiereFois=FALSE;
	m_comboDeplie.EnableWindow(FALSE);
	m_comboContour.EnableWindow(FALSE);
	//Ouverture des fentres si elles n'existent pas encore...
	if (m_pApp->GetDocument(m_is2)==NULL)
	{
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		m_ps2=m_pApp->GetDocument();
	}
	else
		m_ps2=m_pApp->m_pDocument[m_is2];

	if (m_pApp->GetDocument(m_is3)==NULL)
	{
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		m_ps3=m_pApp->GetDocument();
	}
	else
		m_ps3=m_pApp->m_pDocument[m_is3];

	//Dimensionner les fentres  la taille de l'acquisition
	short l,h,nbB;
	
	l=m_pApp->m_iL;h=m_pApp->m_iH;nbB=m_pApp->m_iNbB;
	m_ps1->InitialiserImage(l,h,nbB);
	m_ps1->m_iL=l;
	m_ps1->m_iH=h;
	m_ps1->m_iNbB=nbB;
	m_ps1->DimensionnerFenetre(l,h);
	m_ps1->DefinirCurseurs(l,h);
	m_ps1->PositionnerFenetre(l+15,0);
	m_ps1->m_sNomFic.Format("Camra");

	m_ps2->InitialiserImage(l,h,nbB);
	m_ps2->m_iL=l;
	m_ps2->m_iH=h;
	m_ps2->m_iNbB=nbB;
	m_ps2->DimensionnerFenetre(l,h);
	m_ps2->DefinirCurseurs(l,h);
	m_ps2->PositionnerFenetre(0,0);
	m_ps2->m_sNomFic.Format("ImContour");

	m_ps3->InitialiserImage(721,h,nbB);
	m_ps3->m_iL=720;
	m_ps3->m_iH=h;
	m_ps3->m_iNbB=nbB;
	m_ps3->DimensionnerFenetre(721,h);
	m_ps3->DefinirCurseurs(721,h);
	m_ps3->PositionnerFenetre(0,h-100);
	m_ps3->m_sNomFic.Format("ImDplie");
	zeroimage(0,m_ps3->image);
}
//________________________________________
void CDigiDlg::Contour(void) 
{
	short 
		l,h,i,i1,j;
	long w,max;

	//Duplique l'image courante n m_iNo vers l'image temporaire n0
	m_pApp->DupliquerImageDestTempo(m_is1,0);
	zeroimage(0,m_pApp->imt[0]);
	l=m_ps1->m_iL;
	h=m_ps1->m_iH;

	for (j=0;j<h;j++)
	{
		max=0;
		for (i=0;i<l;i++)
		{
			w=getpixelcolor(m_ps1->image,i,j);
			if (w>max && w>m_pApp->m_iSeuil1) 
			{
				//Pixel significatif du contour trouv
				max=w;
				i1=i;
			}
		}
		if (max!=0) setpixelcolor(m_pApp->imt[0],i1-1,j,255);
	}
	//copyimage(m_pApp->imt[0],m_ps2->image);
	//On bouche les trous dans le contour
	IpDilate(m_pApp->imt[0],m_pApp->imt[0],m_ps2->image,1);
	m_ps2->UpdateAllViews(NULL);
}
//________________________________________
void CDigiDlg::Depliement(void) 
{
	short i,j,l,h,R;
	long w,w1;
	float r;

	l=m_ps1->m_iL;
	h=m_ps1->m_iH;
	for (j=0;j<h;j++)
	{
		i=0;
		do
		{
			w=getpixelcolor(m_ps2->image,i,j);
			if (w==255) 
			{
				//Pixel du contour trouv
				R=i-m_pApp->m_iR0;
				r=255.0*R/m_pApp->m_iR;
				w1=(long)(r);
				if (w1>255) w1=255;
				setpixelcolor(m_ps3->image,(int)(m_fAngle*2),j,w1);
			}
			i++;
		}
		while(i<l && w!=255);
	}
	m_ps3->UpdateAllViews(NULL);
}
//________________________________________
void CDigiDlg::IpDilate(imgdes* nfi,imgdes* nfo,imgdes* imt,long size)
{
	short 
		nb,i,j,i1,j1;
	long w,wmax;

	zeroimage(0,imt);
	int rcode;
	for (nb=0;nb<size;nb++)
	{
		for (i=nfi->stx+1;i<=nfi->endx-1;i=i++)
		{
			for (j=nfi->sty+1;j<=nfi->endy-1;j++)
			{
				wmax=getpixelcolor(nfi,i,j)&255;
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(nfi,i1,j1)&255;
						if (w>wmax) wmax=w;
					}
				}
				//Affectation de la zone avec wmax
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(imt,i1,j1)&255;
						if (wmax>w) setpixelcolor(imt,i1,j1,wmax);
					}
				}
			}
		}
		copyimage(imt,nfo);
	}
}
//________________________________________
void CDigiDlg::Encadrement(imgdes* im,short *H1,short *H2)
{
	short 
		l,h,i,j;
	long w;
	
	l=m_ps2->m_iL;
	h=m_ps2->m_iH;

	//Variables destines  connatre l'ordonne de dpart et de fin des contours
	*H1=0;
	*H2=h;
	for (i=0;i<l;i++)
	{
		j=0;
		do
		{
			w=getpixelcolor(im,i,j);
			if (w==0) j++;
		}
		while (j<h && w==0);
		if (j<h && j>*H1) *H1=j;		
		j=h-1;
		do
		{
			w=getpixelcolor(im,i,j);
			if (w==0) j--;
		}
		while (j>0 && w==0);
		if (j>0 && j>*H2) *H2=j;		
	}
}
//________________________________________
void CDigiDlg::Remplissage(imgdes* im,short H1,short H2,short L,short H)
{
	short 
		l,i,j,id,ia,k;
	long w,wd,wa;
	float r;
	
	for (j=0;j<H1;j++)
	{
		for (i=0;i<L;i++)
		{
			setpixelcolor(im,i,j,0);
		}
	}
	for (j=H2;j<H;j++)
	{
		for (i=0;i<L;i++)
		{
			setpixelcolor(im,i,j,0);
		}
	}
	
	for (j=H1;j<=H2;j++)
	{
		id=0;
		wd=getpixelcolor(im,id,j);
		ia=0;
		do
		{
			ia++;
			wa=getpixelcolor(im,ia,j);
			if (wa!=0 && ia>=id+2)
			{
				//On fait une interpolation linaire entre id et ia de wd ver wa
				k=1;
				r=1.0*(wa-wd)/(ia-id-1);
				for (i=id+1;i<=ia;i++)
				{
					w=(long)(r*k);
					w=w+wd;
					if (w<0) w=0;
					if (w>255) w=255;
					setpixelcolor(im,i,j,w);
					k++;
				}
				id=ia;
				wd=wa;
			}
		}
		while(ia<L);
	}

}